2007-04-23  Zoltan Varga  <vargaz@gmail.com>

	* mini-alpha.c cpu-alpha.md: More alpha port work from 
	Sergey Tikhonov <tsv@solvo.ru>.
	
2007-04-19  Zoltan Varga  <vargaz@gmail.com>

	* cpu-s390.md (break): Correct the length of break instruction.

Thu Apr 19 16:28:52 CEST 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix a couple of soft-float issues and comments.

2007-04-15  Miguel de Icaza  <miguel@novell.com>

	* trace.c (is_filenamechar): - is also a filename char.

2007-04-15  Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Correct checking for enum type in return value processing.

2007-04-14  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (BUILT_SOURCES): Add 'version.h'.
	(version.h): Makefile is in the build directory.

2007-04-06  Andreas Faerber  <andreas.faerber@web.de>

	* mini-amd64.h: fix for assertion failure on Solaris/amd64

2007-04-11  Martin Baulig  <martin@ximian.com>

	* mini.c (can_access_member): Fix handling of generic classes;
	fixes #81259.

2007-04-10  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_plt_resolve): Fix disabling of AOT. Fixes #81316.

2007-04-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c: Fix disabling of AOT. Fixes #81316.

Fri Mar 23 20:25:31 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-codegen.c: make sure the right spill amount is
	used for fp or integer registers (fixes the float_sub_spill() on ppc).

Fri Mar 23 19:43:35 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixes for the fp_branch_nan test.

2007-03-23  Zoltan Varga  <vargaz@gmail.com>

	* basic.cs: Comment out new test which still fails on ia64.

Fri Mar 23 15:54:23 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: immediate shifted or fix (mono_metadata_user_string assert).

Fri Mar 23 12:53:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc.h: struct passing ABI fix (bug #77968).

2007-03-22  Zoltan Varga  <vargaz@gmail.com>

	* cfold.c (FOLD_BINOP): Cast the result to gint32 to prevent overflow problems
	on 64 bit machines. Fixes part of #80738.

	* basic.cs: Add regression test.

2007-03-17  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg basic.cs: Revert previous change to fix build.

	* inssel.brg (SWITCH): Clean out the upper word of the switch value on 64 bit
	platforms.
	
	* inssel.brg (SWITCH): Use an integer comparison. Fixes #80738.

	* basic.cs: Add new regression test.

2007-03-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_emit_prolog): Fix an assert when a function has too
	many arguments.

2007-03-16  Neale Ferguson <neale@sinenomine.net>

	* cpu-s390x.md: Correct length of break instruction.

2007-03-16  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, cpu-s390x.md: Fix #80507 for s390x.
	* mini-s390.c, cpu-s390.md: Fix #80507 for s390.

2007-03-15  Jonathan Chambers  <joncham@gmail.com>

	* *.c: Begin WIN64 port.
	* mini.c:  Use correct register in profiler.
	* mini-amd64.c: No inline assembly on Win64.
	* mini-amd64.h: Implement MONO_INIT_CONTEXT_FROM_FUNC for Win64.
	Only define MONO_ARCH_USE_SIGACTION on non-windows platforms.
	* exceptions-amd64.c: Only need gregs_from_ucontext if MONO_ARCH_USE_SIGACTION
	is defined. Implement mono_arch_sigctx_to_monoctx, mono_arch_monoctx_to_sigctx, and
	mono_arch_ip_from_context for Win64.
	
	Contributed under MIT/X11 license.

2007-03-15  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-amd64.c (seh_handler): Ditto.

	* exceptions-x86.c (seh_handler): Fix a memory leak.

Thu Mar 15 13:47:59 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, mini-mips.c, mini-ppc.c, mini-s390.c,
	mini-s390x.c: fixed peephole optimizations to deal
	correctly with 1 and 2 byte reload avoidance.

Thu Mar 15 10:17:54 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-s390.md, cpu-s390x.md: update localloc length.

Wed Mar 14 21:00:19 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-g4.md: added missing descriptions.

2007-03-14  Miguel de Icaza  <miguel@novell.com>

	*  Makefile.am: Add support so the tail tests are not executed on
	PowerPC as that is a known limitation of the PowerPC port.

2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* runmdesc.bat:  Move to msvc directory.
	
2007-03-13  Jonathan Chambers  <joncham@gmail.com>

	* runmdesc.bat:  Run executable that was produced by the current
	target and sent via an argument.
	
2007-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix box+brtrue optimization. Fixes
	#81102.

	* generics.2.cs: Add regression test.

2007-03-09  Wade berrier  <wberrier@novell.com>

	* mini-ppc.h: Undo typo of MONO_CONTEXT_SET_SP (ppc doesn't define this symbol)

2007-03-09  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Load all dependent assemblies eagerly since all
	AOT code depends on this.

Thu Mar 8 19:36:13 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: more precise tracking of types in the eval stack
	(part of fix for bug #81044).

2007-03-07  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_class_from_name): Add a cache.

	* aot-compiler.c (encode_patch): Remove an obsolete comment.

2007-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Fix a warning.

	* mini.c (mono_method_to_ir): Add a workaround for bug #80733.

2007-02-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (type_from_op): Convert CEE_CONV_U to OP_LCONV_TO_U when the argument is
	a pointer on 64 bit systems. Fixes #80190.

	* iltests.il: Add new regression test.

Tue Feb 20 11:33:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: inline a constant for Environment.IsRunningOnWindows.

2007-02-19  Geoff Norton  <gnorton@customerdna.com>

	* trace.c: Remove an erroneous alignemnt check when tracing.
	  Fixes --trace on OSX86.

Wed Feb 14 19:45:56 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-$(arch).h: initialize SP in context for all the archs.

2007-02-14  Sebastien Pouliot  <sebastien@ximian.com>

	* mini-x86.h: Initialize SP in MONO_INIT_CONTEXT_FROM_FUNC. Fix CAS
	regressions in the thread tests.

2007-02-14  Zoltan Varga  <vargaz@gmail.com>

	* *-alpha.*: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>:
	- fixed implementation of LOCALLOC opcode
	- implemented non-un compare for floats
	- code cleanup
	- implementation of FDIV and CKFINITE opcodes
	- fixes for latest mono updates
	- additional arch opcodes

Mon Feb 12 11:54:16 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: simplify and merge rules for cross-compilation.

2007-02-07  Massimiliano Mantione  <massi@ximian.com>

	* local-propagation.c: Actually *apply* the fix for bug 80591...

Tue Feb 6 19:03:19 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: backuot part of the last change
	(fixes cas tests on amd64 related to GetExecutingAssembly ()).

2007-02-06  Massimiliano Mantione  <massi@ximian.com>
	* inssel.brg: Fix bug 59286.


Tue Feb 6 12:23:50 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: patch from Zoltan to correctly check for
	stack boundaries (using the stack register, not the frame register),
	fixes bugs #80724, #79717.

2007-02-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c inssel-sparc.brg mini-sparc.c cpu-sparc.md: Get rid of OP_SETREG/
	OP_SETREGIMM, use OP_MOVE/OP_ICONST instead.

	* mini-amd64.c (mono_arch_output_basic_block): Fix ATOMIC_EXCHANGE in the
	presence of frame pointer elimination.

2007-02-01  Geoff Norton  <gnorton@customerdna.com>
        
	* mini-x86.h: NetBSD UCONTEX_REG defines.

2007-02-01  Zoltan Varga  <vargaz@gmail.com>

	* inssel-amd64.brg: Fix amd64 build.

Thu Feb 1 14:02:09 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h: remove extern to workaround what looks likes gcc bug 26905
	on amd64.

2007-01-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_is_regsize_var): New helper function usable by the back
	ends.

	* mini-<ARCH>.c: Use mono_is_regsize_var ().

2007-01-30 Mark Mason <mason@broadcom.com>

	   * exceptions-mips.c: Lots of exception handling fixes, LMFs now work, some cleanups.
	   * mini-mips.h: Add LMF magic numbers, and fix context set/get macros.
	   * mini-mips.c: Cleanups, LMF handling now works, optimize store of zero, implement localloc
	   beginning support for CEE_JMP [not quite working yet]
	   * tramp-mips.c: LMF handling now works
	
2007-01-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Optimize code common in initlocals blocks.

	* mini.h (NULLIFY_INS): New macro.

Tue Jan 30 16:33:33 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: statistical profiler fix for windows, patch
	from Tor Lillqvist (tml@novell.com).

2007-01-30  Massimiliano Mantione  <massi@ximian.com>
	* local-propagation.c: Fix bug 80591.

Mon Jan 29 12:14:34 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: put back the --export-dynamic option as with
	the previous gmodule flags (thanks to Robert Jordan).

2007-01-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (peephole_pass): Fix #80622 for sparc as well.

	mini.h *.c: Allocate fp vregs from the same pool as the int vregs. Use this to
	simplify and speed up the local register allocator. Also rename some fields
	like iassign->vassign.
	
	* regalloc.c: Remove some functions which are no longer used since their
	inlined version is in mini-codegen.c.
	
	* mini-codegen.c: Rename mono_regstate2_ functions to mono_regstate_.

	* basic.cs objects.cs iltests.il: Merge tests from the linear IL branch.

2007-01-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (peephole_pass): Remove optimizations which omit a 
	narrowing. Fixes #80622.

	* iltests.il: Add new regresssion test.	

Fri Jan 26 18:31:45 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-trampolines.c, aliasing.c, mini-codegen.c,
	debug-debugger.c, debug-debugger.h: warning fixes.
	* driver.c: updated copyright year and made it fit in one line.

Fri Jan 26 12:48:39 CET 2007 Paolo Molaro <lupus@ximian.com>

	* aot-runtime.c: updated to use mono-dl instead of gmodule.

2007-01-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_output_basic_block): Fix #80507 for x86.

	* mini-amd64.c (mono_arch_output_basic_block): Fix #80507 for amd64.

	* iltests.il: Add new test for bug #80507.

Wed Jan 24 19:10:28 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h: use soft-float also on vfp for now.

Wed Jan 24 14:54:40 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix some more soft-float issues.

2007-01-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.h (MONO_ARCH_FRAME_ALIGNMENT): Fix sparc build.

2007-01-24  Massimiliano Mantione  <massi@ximian.com>
	* mini-arch.h, , inssel-amd64.brg, mini-x86.c, inssel-x86.brg,
	mini-ia64.c, mini-sparc.c, mini-alpha.c: Introduced
	MONO_ARCH_LOCALLOC_ALIGNMEENT to fix bug 80498.

Wed Jan 24 12:04:39 GMT 2007 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: typo fix.

2007-01-23  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c: Use lgb instructions for I1 type variables instead of lb.

2007-01-21  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_allocate_stack_slots_full): Allocate memory from the cfg mempool.
	Share stack slots for scalar types. Avoid expensive g_list_free () calls.

	* mini-x86.c (mono_arch_allocate_vars): Don't free the result of allocate_stack_slots_full.

	* mini-amd64.c mini-ia64.c mini-alpha.c: Ditto.	

	* mini.h (MonoJitStats): Add a new JIT statistics: locals_stack_size.
	
	* inssel.brg: Fix a warning.

	* mini.h (MonoBasicBlock): Make bb->dominated a GSList.

	* abcremoval.c ssa.c ssapre.c: Update after this change.
	
	* dominators.c (compute_dominators): Allocate bb->dominated from the cfg mempool.

	* dominators.c (df_set): Use mono_bitset_union_fast.	

Sat Jan 20 16:59:01 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, genmdesc.c, genmdesc.pl, mini-${arch}.c, cprop.c,
	mini-codegen.c: reduce relocations and memory usage for the cpu
	description.

2007-01-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_regstate2_alloc_int): Optimize this using bsfq on amd64.

	* genmdesc.c genmdesc.pl mini.h: Remove some unused fields from the mdesc tables
	to reduce their size.

2007-01-19 Mark Mason <mason@broadcom.com>

	* exceptions-mips.c: fix mono_arch_ip_from_context(), increase exception debug support.
	* mini-mips.c: more configuration macros, support long conditional branches, additional
	asserts, fix epilog instrumentation.
	* mini-mips.h: use standard stack walk
	* cpu-mips.md: increase size of div, rem and conditional branches
	
Fri Jan 19 17:23:32 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-codegen.c, mini-$(arch).h: claenup references
	to cpu spec data.

2007-01-19  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (encode_klass_info): Allow classes of the form <Type>[][].
	(compile_method): Ditto.

	* aot-runtime.c (decode_klass_info): Ditto.

	* mini.c (mono_method_to_ir): Call mono_get_got_var () in a place where it is
	needed by the code generated by inssel.brg. Also fix a warning.

Thu Jan 18 17:55:22 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: deal with enums that become genericinsts by
	being nested in a generic class (bug #79956).

Thu Jan 18 16:52:56 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: match the generic definition to check for
	private access with generic types (bug #78431).

Thu Jan 18 11:50:13 CET 2007 Paolo Molaro <lupus@ximian.com>

	* genmdesc.pl, Makefile.am: perl implementation of genmdesc,
	to make life easier for people cross-compiling that insist on not
	using scratchbox.

2007-01-17 Mark Mason <mason@broadcom.com>

	* inssel-long.brg: patch to deal with mips missing flags
	* inssel-long32-mips.brg: implement overflow checks
	* insset-mips.brg: implement overflow checks
	* mini-mips.h: implement conditional exception handling
	* mini-mips.c: add mips_emit_exc_by_name(), implement conditional exception handling.
	  Remove unused code, minor cleanups.
	* exceptions-mips.c: minor cleanups
	* mini-ops.h: add mips conditional exception ops
	* cpu-mips.md: add mips conditional exception ops

	
Wed Jan 17 19:22:34 CET 2007 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: patch from Mark Mason <mason@broadcom.com>
	to deal with mips missing of flags.

Tue Jan 16 20:01:01 CET 2007 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: execute fault handlers.

Tue Jan 16 19:54:44 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: handle missing call locationss with FORCE_INDIR_CALL.

Tue Jan 16 13:14:31 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle also floating point values in initialize_array.

Tue Jan 16 12:42:40 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, aot-runtime.c, aot-compiler.c: enable aot compilation of
	array initialization and make it conditional on the intrins option.

Tue Jan 16 11:28:45 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.h, patch-info.h, Makefile.am, aot-compiler.c: reduce
	relocations and put the patch info names close to the enum definition.

2007-01-15 Mark Mason <mason@broadcom.com>

	* basic.cs, exceptions.cs: break up large tests to increase debugability.

Mon Jan 15 18:57:14 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c: optimized RuntimeHelpers::InitializeArray () calls.

2007-01-12  Raja R Harinath  <rharinath@novell.com>

	* mini.c (mono_method_to_ir): Use new MonoGenericContext accessor.

Thu Jan 11 11:16:42 CET 2007 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: distribute the mips sources.

Wed Jan 10 19:49:33 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini-codegen.h: handle bug #80489 here, by excluding ecx
	directly.

Wed Jan 10 19:08:05 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-x86.md: back out for now as this triggers other regressions.

Wed Jan 10 18:33:16 CET 2007 Paolo Molaro <lupus@ximian.com>

	* cpu-x86.md: force src1 and dest regpair for long shift instructions
	to eax:edx, so ecx can't get allocated to them (bug #80489).

Tue Jan 9 12:36:11 CET 2007 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-exceptions.c: enabled running fault handlers
	(bug #80469).

2007-01-03  Miguel de Icaza  <miguel@novell.com>

	* driver.c: If nothing fail, do not use the string "failed",
	because it makes it very annoying to view test result logs on the
	web. 

2006-12-30  Miguel de Icaza  <miguel@novell.com>

	* debug-debugger.c (mono_debugger_main): Rename "main" to
	"main_method" to prevent a warning.

	Remove a warning for unused field.

2006-12-28  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c
	(MONO_DEBUGGER__debugger_info): Add `get_lmf_addr'.

2006-12-22  Martin Baulig  <martin@ximian.com>

	* mdb-debug-info32.s, mdb-debug-info64.s: New files.
	Put a pointer to the `MONO_DEBUGGER__debugger_info' into a
	seperate `.mdb_debug_info' section, so we can access it from the
	debugger even if the binary is stripped.

	* debug-debug.c: Reference the `MONO_DEBUGGER__debugger_info_ptr'
	from the `.mdb_debug_info' here to prevent the linker from
	removing that section.

	* Makefile.am (mono_debugger_sources): Add mdb-debug-info32.s /
	mdb-debug-info64.s.

2006-12-19  Robert Jordan  <robertj@gmx.net>

	* mini-x86: enable the code to return small structures in
	registers for FreeBSD as well. Fixes bug #80278.
	* aot-runtime.c: Include sys/wait.h for WEXITSTATUS/WIFEXITED.

Mon Dec 18 19:47:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: align the stack when calling the profiler
	function instrumenting the prolog (on OSX).

Thu Dec 14 15:22:43 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: emit a break opcode where Debugger.Break () is called.

2006-12-13  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_method_to_ir): Provide useful information on this
	assert, to prevent others from debugging like I did.

Tue Dec 12 17:01:38 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: enable code which was incorrectly commented
	(bug #80235).

Tue Dec 12 16:28:15 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: enable on OSX, too, the code to return small
	structures in registers.

Mon Dec 11 19:22:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: remove the use of the dynamic code manager here, too.

Mon Dec 11 19:08:33 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, debug-debugger.c, tramp-*.c: fixed 
	mono_debugger_create_notification_function() to use
	mono_global_codeman_reserve () instead of a dynamic code manager.

Tue Dec 5 17:54:50 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.h, jit-icalls.c: remove the 
	ves_array_element_address() jit icall and use a generated
	managed method instead (which is about 4 times faster for a rank 3
	array access).

2006-11-29  Mark Mason  <mason@broadcom.com>

	* basic-calls.cs: additional tests for passing
	structures as function arguments.

2006-11-29  Mark Mason  <mason@broadcom.com>

	* mini-mips.h: disable custom exception handling
	* mini-mips.c: throw/rethrow should use jalr to call
	exception stubs.  Fixed bug with passing structures
	by value. More support for tracing floating point
	functions.

Wed Nov 29 20:28:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: fixed typo in the soft-float ldind.r4 handling
	(bug #80086).

Wed Nov 29 11:33:03 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, driver.c: added --runtime command line
	option to select a different runtime than the autodetected one.
	* jit.h: added API for embedders to initialize with a specific
	runtime version.

Tue Nov 28 21:24:55 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle also boxing of r4 values (bug #80024).

Tue Nov 28 19:45:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: force indirect calls until we reserve
	enough address space for all the generated code.

Tue Nov 28 20:04:34 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c: workaround bugs in the libc definition
	of struct ucontext.

Mon Nov 27 15:13:41 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: fixes from me and Mark Mason.

2006-11-23  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_seminfo): No need to adjust the counter
	semaphore display now we've fixed the initial value

Wed Nov 22 11:04:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: partially revert the last change to fix the build.

2006-11-21  Mark Mason  <mason@broadcom.com>

	* inssel.brg: Add and use compare-and-branch macros to support
	architectures that do not have condition code registers (ie. MIPS).
	* *-mips.{c,brg,md}: Fix copyright statements

2006-11-20  Mark Mason  <mason@broadcom.com>

	* Makefile.am: remove mini-codegen.c from list of MIPS sources
	* mini.c: Allow GET_CONTEXT to be specified by the arch port
	* mini.h: Added declaration for mono_print_ins()
	* mini-codegen.c: added ins_spec initializer for MIPS
	* mini-codegen.c (mono_call_inst_add_outarg_reg): added asserts for
	vreg to be virtual and hreg to be non-virtual.
	* mini-codegen.c (mono_spillvar_offset): assert if MIPS - spilling
	is not yet working/implemented correctly.
	* mini-codegen.c (print_ins): rename to mono_print_ins(), make
	non-static, fixup calls to print_ins() from other parts in the file.

2006-11-20  Mark Mason  <mason@broadcom.com>

	* basic-calls.cs: added tests for passing structures as arguments
	to calls.

Mon Nov 20 19:40:11 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-long32.brg: optimize signed division by power of two.

Mon Nov 20 17:37:58 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: added support for interworking with thumb code
	(mono must be still be built using the ARM instruction encoding).

2006-11-19  Miguel de Icaza  <miguel@novell.com>

	* mini.c (type_from_op): Separate the conditions for OP_EQ as the
	verifier has different rules for it.   Fixes a few verifier issues
	in the test suite.

	* mini-exceptions.c (mono_handle_native_sigsegv): Put the message
	at the end, so people know what happened.

Thu Nov 16 14:07:18 CET 2006 Paolo Molaro <lupus@ximian.com>

	* brach-opts.c: in optimize_exception_target() make sure we
	are in a catch clause (fixes bug #79871).

Thu Nov 16 12:42:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c, jit-icalls.h, mini-arm.c, mini.c:
	more soft-float support fixes.

Wed Nov 15 18:45:47 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, inssel-arm.brg: ABI fix for longs and doubles
	that are passed half on the stack and half in registers.

Wed Nov 15 17:00:27 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini-arch.h, helpers.c, Makefile.am:
	more mips integration work from Mark E Mason 
	<mark.e.mason@broadcom.com>.

Wed Nov 15 16:34:03 CET 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-mips.c, inssel-mips.brg, mini-mips.h,
	cpu-mips.md, inssel-long32-mips.brg, mini-mips.c,
	tramp-mips.c: added sources for the mips port, not
	integrated in the build yet. Contributed by
	Mark E Mason <mark.e.mason@broadcom.com>.

2006-11-14  Neale Ferguson <neale@sinenomine.net>

	* mini-s390[x].c (is_regsize_var): Support PTR/FNPTR too.

Tue Nov 14 16:06:37 CET 2006 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, inssel-float.brg, inssel-softfloat.brg:
	put the soft-float rules in its own file since it seems to
	break s390 compilation.

Mon Nov 13 15:54:38 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed wrnings.

Fri Nov 10 19:18:32 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, mini-arm.h, cpu-arm.md, inssel-float.brg,
	inssel-arm.brg: ARM support for soft-float.

Fri Nov 10 18:38:15 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c, jit-icalls.h: added first cut at handling
	loads and stores of 32 bit fp values.

2006-11-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (is_regsize_var): Support PTR/FNPTR too.

	* tramp-sparc.c (mono_arch_patch_callsite): Fix this function so it actually
	works. Fixes #79852 and #79463.

Thu Nov 9 16:56:13 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-codegen.c, jit-icalls.c, jit-icalls.h:
	more soft-float support WIP and fixes.

Wed Nov 8 16:40:02 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: some VFP updates.

Tue Nov 7 19:45:51 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: 0 is a valid local var offset in some
	architectures, don't assert (bug #78508).

Tue Nov 7 18:17:52 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c: fixed off by one error in stack walk code.

Tue Nov 7 11:27:26 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c: more precise tracking of type load exceptions.

2006-11-03  Robert Jordan  <robertj@gmx.net>

	* Makefile.am: [WIN32] Add monow.exe target.
	* driver.c: [WIN32] Don't detach the console when debugging.
	Fixes bug #79797.
	
2006-10-30  Miguel de Icaza  <miguel@novell.com>

	* tramp-x86.c (mono_arch_patch_delegate_trampoline): Eliminate warning.

2006-10-23  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (emit_method_info): Add a case missed earlier.

	* driver.c (mini_regression): Fix --regression with AOT.

	* aot-compiler.c (emit_method_info): Fix AOT on amd64.

2006-10-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (GET_CONTEXT): Correct the definition of this for sparc/linux.

	* mini-sparc.h: Don't use sigaction on sparc/linux.

	* exceptions-sparc.c: Call mono_arch_flush_icache () in a couple of places.

	* mini-sparc.c (mono_sparc_flushw): Call mono_arch_flush_icache ().

	* mini-exceptions.c: Add proper include files for getpid ().

2006-10-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method): Change this to return the native code
	address instead of a MonoJitInfo* to avoid decoding the exception info for the
	method.

	* aot-runtime.c aot-compiler.c: Use uint16 instead of uint32 entries in the
	name cache to reduce its size.

	* mini.h (MONO_AOT_FILE_VERSION): Bump aot file format version.

2006-10-15  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c: Save/restore the current LMF structure more efficiently using
	the mono_lmf TLS variable.

	* exceptions-x86.c (mono_arch_find_jit_info): Only access lmf->method in 
	trampoline lmf frames.	

	* mini-sparc.h (MONO_ARCH_ENABLE_EMIT_STATE_OPT): Define this on sparc as well.

2006-10-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c: Save/restore the current LMF structure more efficiently using
	the mono_lmf TLS variable.

	* mini-exceptions.c: Access the LMF structure through accessors.

	* mini.c: Allow the backends the option for storing the lmf in a dedicated TLS 
	variable instead of in jit_tls->lmf.

	* mini-x86.c mini-amd64.c: Update after lmf->lmf_addr name change.
	
	* exceptions-amd64.c (mono_arch_find_jit_info): Only access lmf->method in 
	trampoline lmf frames.

	* mini-amd64.c (mono_arch_emit_prolog): Do not set lmf->method as it is not needed.

2006-10-12  Zoltan Varga  <vargaz@gmail.com>

       * mini.c trace.c mini-x86.c: Revert these too.
	
       * mini.c trace.c mini-x86.c: Remove warning workarounds after the mono_type_size ()
       signature change.

Tue Oct 10 11:35:20 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* genmdesc.c: removed now dead code.

2006-10-09  Robert Jordan <robertj@gmx.net>

	* mini.c: Disable the CrashReporter on MacOS X; Fixes #74869

Mon Oct 9 17:06:41 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: do not leave gaps in the opcode values.

Mon Oct 9 16:08:51 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.h: flag functions as internal here, too.

Mon Oct 9 15:58:18 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, aliasing.h, declsec.h, regalloc.h, trace.h: mark internal
	functions with the internal attribute.

Mon Oct 9 15:52:45 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: fclose the file descriptor in the profile read loop.

Fri Oct 6 16:01:38 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c, inssel-float.brg: beginnings of support
	for soft-float.

2006-10-05  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (emit_load_volatile_arguments): New function to handle arguments of
	tail calls as on other platforms.

	* mini.c (mono_method_to_ir): Fix a few tailcall problems. Fixes #79557.

	* iltests.il: Add a few tailcall tests.

Tue Oct 3 16:33:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: fix loop for old compilers (bug #79521).

2006-10-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (ves_icall_get_trace): Remove debug printf.

	* aot-runtime.c (mono_aot_get_class_from_name): Avoid a memory allocation.

	* aot-compiler.c: Add a new option 'metadata-only' to only emit the cached
	metadata without any code.

	* mini-exceptions.c (mono_handle_native_sigsegv): Add some code to print out
	more precise debugging information using gdb.

2006-09-30  Zoltan Varga  <vargaz@gmail.com>

	* inssel-ia64.brg: Make the helper methods static.

Thu Sep 28 16:40:07 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-x86.brg: make the helper methods static.

Thu Sep 28 16:31:32 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel-amd64.brg, mini-amd64.c: small cleanup, use inst_call.

Thu Sep 28 15:36:07 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: updates for monoburg changes.
	* inssel.brg: make a few helper functions static as they should.

2006-09-27  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Move mini-codegen.c to common_sources.

Wed Sep 27 15:07:08 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: instroduce inst_call in MonoInst for use in OUTARG
	instructions.
	* Makefile.am, cpu-g4.md, inssel-ppc.brg, mini-codegen.c, mini-ppc.c,
	mini-ppc.h: port to use the common local register allocator.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Remove the comment too then.

Tue Sep 26 14:02:58 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: put back backend.data which is to be used shortly and
	doesn't increase the size of MonoInst. If any 64 bit arch aligned
	pointers on 4 byte boundaries it'd have much bigger issues running
	and you can ifdef it out anyway.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoInst): Remove backend.data field since it is unused and increases
	MonoInst size by 4 bytes on 64 bit machines.

Tue Sep 26 11:57:26 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* *.{c,h,brg}: long due removal of the unused field in MonoInst and
	replacement with more meaningful field names. Arch maintainers, please
	check the assigned names are good enough for your arch.

2006-09-26  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ia64.md mini-ia64.c inssel-ia64.brg mini-ops.h: Get rid of the 
	OP_IA64_FETCHADD opcodes, use OP_ATOMIC_ADD_IMM_NEW opcodes instead.

Mon Sep 25 11:05:24 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, driver.c, optflags-def.h, Makefile.am: reduce runtime
	relocations and memory requirements, put the optimization flags
	definitions in their own file.

2006-09-24  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.c (mono_helper_stelem_ref): Remove this unused helper function.

	* mini.c (mini_init): Remove reference to mono_helper_stelem_ref.

2006-09-22  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (add_valuetype): Fix an uninitialized memory issue.

Thu Sep 21 19:06:09 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: use the correct function to get the size of an item
	in an array, given an element class.
	* aot-compiler.c: do not access class->class_size directly.

Thu Sep 21 12:10:56 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, debug-mini.c: added a debugging function to print
	info about local variables and arguments in a jitted method.

2006-09-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

	* exceptions-ia64.c: Fix some problems reported by Bill Seurer <seurer@us.ibm.com>.

2006-09-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_call_opcode): Avoid using the same loop index in the
	inner and outer loops when passing vtypes.

Tue Sep 19 17:53:40 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: take into account the cpu errata for cache flushing
	which caused some random errors (bug #79381).

2006-09-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_exceptions): Emit the call to 
	mono_arch_throw_corlib_exception using emit_call () too. Fixes #79271.

2006-09-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module): Return immeditely if the AOT module was already
	loaded.

	* exceptions-amd64.c (gregs_from_ucontext): Apply another patch from the
	freebsd ports tree.

	* mini-amd64.c (emit_call): Avoid near calls on freebsd.
	(mono_arch_patch_code): Remove the unused handling of MONO_PATCH_INFO_CLASS_INIT.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Fix check for 32 bitness of
	displacement.

2006-09-13  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (load_aot_module_from_cache): Fix PPC build.

2006-09-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (UNVERIFIED): Add a 'break-on-unverified' MONO_DEBUG option so this 
	macro does not have to be changed during debugging.

	* cpu-alpha.md inssel-alpha.brg mini-alpha.h mini-alpha.c exceptions-alpha.c tramp-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

	* cpu-pentium.md: Rename this to cpu-x86.md for consistency with other platforms.

	* Makefile.am mini-x86.c mini-codegen.c: Rename pentium_desc to x86_desc.
	
	* mini.c (mini_get_ldelema_ins): Allow ldelema2d optimization if 
	MONO_ARCH_NO_EMULATE_MUL is defined.

	* mini-ia64.h (MONO_ARCH_CALLEE_FREGS): Reserve f33 for use by instructions.

	* mini-ia64.h: Define MONO_ARCH_NO_EMULATE_MUL.

	* mini-ia64.c: Implement CEE_MUL based on gcc emitted code.

	* mini-ia64.c (mono_arch_lowering_pass): Optimize store_membase_imm with offset==0.
	
2006-09-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.h mini-amd64.h mini-exceptions.c: Move the bsd specific MAP_ANON
	stuff to mini-exceptions.c where it is used.

	* mini-sparc.c (mono_arch_setup_jit_tls_data): Remove the duplicate altstack
	setup code, the real one is in mini-exceptions.c.

	* mini-amd64.h mini-amd64.c exceptions-amd64.c: Move all dependencies on the
	layout of ucontext_t to helper functions in exceptions-amd64.c, as on x86. Add
	some changes from the freebsd ports tree.

	* mini-amd64.h exceptions-amd64.c: Fix the amd64 build. Get rid of the SC_
	constants.
	
	* mini-amd64.h: Freebsd has MAP_ANON instead of MAP_ANONYMOUS.

Mon Sep 11 13:18:55 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: on Linux, check for /proc to be mounted
	(bug# 79351, novell bug#201204).

Mon Sep 11 13:10:12 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle cases where pthread_attr_getstack() behaves
	incorrectly (bug #78096).

Mon Sep 11 11:31:10 BST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: support larger stack frames (bug #79272).

2006-09-08  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_class_from_name): Remove a debug printf.

	* aot-compiler.c: Add a hash table to the AOT file mapping class names to typedef 
	tokens.

	* aot-runtime.c (mono_aot_get_class_from_name): New function used by 
	mono_class_from_name () to find a class from its name.

	* mini.c (mini_init): Register mono_aot_get_class_from_name () with the runtime.

2006-09-07  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_call): Avoid strstr () call if possible.

2006-09-05  Kornél Pál  <kornelpal@gmail.com>

	* Makefile.am: Renamed mono-1.dll to mono.dll. (-avoid-version)

2006-09-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_icall_get_wrapper): Fix a race condition on initializing
	callinfo->trampoline.

	* mini-amd64.c (emit_call): Special case calls to the vararg array icalls. Hopefully
	fixes #79271.
	(mono_arch_patch_code): Add some debug code to help track down similar failures in the
	future.

2006-09-03  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_plt_resolve): Add an assert.

2006-09-02  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_specific_trampoline): Don't increase
	stats.method_trampolines, it is already done by the generic trampoline code.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Ditto.
	
2006-09-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Remove some references to mono_compile_aot, and use cfg->compile_aot instead.

	* aot-runtime.c: Add some tweaks to the MONO_AOT_CACHE functionality.

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Fix a FIXME.

	* mini.c (print_jit_stats): Print mscorlib mempool size too.
	
	* mini.c (print_jit_stats): Print new stats.

	* *-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

2006-08-31  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_get_ldelema_ins): Fix verifier error when calling
	Address on two dimensional arrays. Fixes #78729.

	* mini.h (MonoCompile): Add a 'skip_visibility' field.

	* mini.c (method_to_ir): Disable visibility checks if skip_visibility is set on
	a method.

	* mini-amd64.c (mono_arch_emit_exceptions): Fix assertion introduced by the last change.

	* mini.c (mono_runtime_cleanup_handlers): Clean up signal handlers on unix. Fixes
	#79130.
	
	* mini.c (handle_array_new): Applied patch from "briaeros007". Fix
	a race condition.
	(mini_get_ldelema_ins): Ditto.

2006-08-30  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_exceptions): Align fp constants to 16 bytes.
	(mono_arch_output_basic_block): Avoid unaligned accesses in FNEG implementation. 
	Fixes #79213.

2006-08-29 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c, mini-s390x.c: Fix VARARG case processing with 0 arguments. Add
	mono_arch_get_patch_offset as a dummy entry point to allow successful link. 

	* exceptions-s390x.c: Cosmetic change.

	* tramp-s390.c: Fix warning.

	* cpu-s390.md: Correct length of mul_imm.

Wed Aug 23 19:24:00 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: added binary writer with ELF backend
	implementation (only on Linux/x86 for now).

2006-08-18  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am: Don't run net 2.0 AOT tests.

	* aot-compiler.c (compile_method): Skip methods with tail calls as well.
	(mono_compile_assembly): Skip net 2.0 assemblies as well.

	* aot-runtime.c (load_patch_info): Fix an uninitialized memory error.

Fri Aug 18 19:38:28 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* aot-compiler.c: simplified and refactored the asm-writing code
	to allow different backends.

2006-08-18  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file format version.

	* aot-compiler.c aot-runtime.c: Reorg the GOT slot allocation code a 
	little. Share patches of type TYPE_FROM_HANDLE as well.

	* mini.c (mono_patch_info_equal): New helper function.
	(mono_patch_info_hash): Ditto.

	* aot-compiler.c (emit_method_code): Fix s390 build.

	* mini.c (mono_allocate_stack_slots_full): Fix yet another place where byref
	is not handled because it is stored as a flag and not as a type ctor. Fixes
	#79016.

2006-08-17  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Fix computation of GOT slot statistics.
	
	* aot-compiler.c aot-runtime.c: Implement sharing of GOT slots for classes/fields.
	Also remove support for not PIC AOT.

	* mini.h: Bump AOT file format version.

	* objects.cs: Add a test for #78990.

	* mini-x86.c (mono_arch_output_basic_block): Applied patch from Peter Dettman
	(peter.dettman@iinet.net.au). Fixes #79087.

	* basic-long.cs: Add a test for the above.

2006-08-16  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c (get_got_offset): Add a cache for GOT entries, not yet used.
	
	* aot-compiler.c (get_plt_index): Add a cache for wrappers too. Simplify the
	code somewhat.

2006-08-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Fix registration of idiv/imul opcodes which can throw
	exceptions.

2006-08-10  Jonathan Chambers  <joncham@gmail.com>

	* mini.c: Don't verify COM proxy invoke calls
	

2006-08-10  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_seminfo): More info, to help track down
	which process is holding semaphores locked.

2006-08-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c mini-amd64.c: Fix #79027.

	* mini-sparc.c (mono_arch_call_opcode): Fix the previous patch.

	* mini-sparc.c (mono_arch_call_opcode): Fix #79027.

	* mini-x86.c (mono_arch_call_opcode): Handle the case where there are no
	implicit arguments in a vararg call. Fixes #79027.

2006-08-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_get_element_address_signature): Use CDECL calling convention on windows. Fixes #78969.
	(mono_get_array_new_va_signature): Ditto.

2006-08-05  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c: Call init_plt lazily.

	* inssel-long.brg: Fix unsigned long->int conversion.

	* aot-runtime.c (init_plt): Remove a redundant make_writable () call.

	* aot-compiler.c aot-runtime.c: Reorganize the file structure in the amd64 case so
	that most data is now in the .rss/.data section.

2006-08-04  Zoltan Varga  <vargaz@gmail.com>

	* aot-compiler.c: Correct the computation of the 'direct-calls' statistic.	

	* aot-compiler.c: Print the number of methods without GOT slots as a statistics.

	* aot-compiler.c aot-runtime.c tramp-amd64.c: Resurrect amd64 AOT support.

	* tramp-amd64.c (mono_arch_patch_callsite): Fix a warning.

	* jit-icalls.c (mono_helper_compile_generic_method): Unbox vtypes since this is a
	virtual call. Fixes #79010.

	* mini.c (mono_method_to_ir): Pass an additional out arg to compile_generic_method 
	and use the result as the this argument in the real call.

	* generics.2.cs: Add a new test for #79010.
	
2006-08-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c: Fix a warning.

	* aot-compiler.c: Add a bunch of statistics.

	* mini.c (inline_method): Disable inlining in out-of-line bblocks.

2006-08-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-arch.h Makefile.am mini-ops.h mini-codegen.c: More alpha updates.

2006-08-01  Zoltan Varga  <vargaz@gmail.com>

	* cpu-alpha.md inssel-alpha.brg mini-alpha.h mini-alpha.c exceptions-alpha.c tramp-alpha.c: More alpha port work from Sergey Tikhonov <tsv@solvo.ru>.

2006-07-13  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_method_to_ir): Obtain the original method in the
	CIL stream and use this to perform validation.

	Fixed: #78816

2006-07-19  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_argument_info): Fix a warning.
	(mono_arch_call_opcode): Ditto.

	* mini.c (mono_method_to_ir): Clear ins_flag at the end of CEE_CALL. Fixes
	#78826.

	* mini.c (mono_patch_info_dup_mp): New helper function.
	
	* aot-compiler.c (compile_method): Fix some of the memory allocated during
	compilation. Fixes #78827.

2006-07-18  Kornél Pál  <kornelpal@gmail.com>

	* declsec.c: Use original security informations for
	  MONO_WRAPPER_MANAGED_TO_MANAGED.

2006-07-15  Jonathan Chambers  <joncham@gmail.com>

	* mini.c: Allow Com Interop methods/classes and
	don't verify COM wrapper calls
	

2006-07-13  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long32.brg: Fix long->i4 checked conversion.

	* exceptions.cs: Add a test for the above.

2006-07-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_setup_altstack): Fix a memory leak.

	* mini.c: Applied patch from Joachim Ante (joe@otee.dk). Fix some shutdown 
	leaks.

	* helpers.c (mono_disassemble_code): Avoid using fixed temporary files. Fixes
	#78775.

2006-07-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Fix solaris/x86 exception handling.

	* Makefile.am: Get rid of $(ICU_LIBS).

2006-07-02  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Fix handling of unhandled SIGSEGV exceptions on ia64.
	(ves_icall_System_Security_SecurityFrame_GetSecurityStack): Use MONO_INIT_CONTEXT_FROM_CURRENT.
	(ves_icall_System_Security_SecurityFrame_GetSecurityFrame): Ditto.

	* mini-ia64.h (MONO_CONTEXT_SET_FUNC): New macro.

	* mini-exceptions.c (mono_handle_native_sigsegv): Prevent infinite loops if
	this function causes a SIGSEGV.

2006-06-22  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Remove unused solaris/x86 includes.

2006-06-21  Zoltan Varga  <vargaz@gmail.com>

	* jit.h: Add G_BEGIN_DECLS/G_END_DECLS.

2006-06-20  Jb Evain  <jbevain@gmail.com>

	* cpu-g4.md: fix max length of start_handler instruction.

2006-06-20  Massimiliano Mantione  <massi@ximian.com>
	* simple-cee-ops.h, simple-mini-ops.h: Fixed bug 78656.

2006-06-16  Massimiliano Mantione  <massi@ximian.com>
	* ssa.c: Fixed bug 78653 for SSA based deadce.
	* mini.h: added MONO_INST_DEFINITION_HAS_SIDE_EFFECTS flag go
	MonoInst.flags, used in SSA based deadce.
	* aliasing.c: Fixed bug 78653 for "fastpath" deadce.
	* simple-cee-ops.h, simple-mini-ops.h: Fixed bug 78653.

Thu Jun 15 16:52:46 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: don't use malloc () for trampoline code, sometimes
	it can end up using non executable memory on ppc64 systems
	running ppc32 userspace (fix from Johannes Berg).

2006-06-14  Dick Porter  <dick@ximian.com>

	* wapihandles.c: Fix a bunch of signed/unsigned warnings from gcc
	4.1.1

2006-06-13  Massimiliano Mantione  <massi@ximian.com>
	* mini.c: Made so that inline is locally disabled if it would
	trigger a .cctor, because too many apps depend on this behavior
	(which seems to be also the one of the MS CLR).

2006-06-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_emit_stack_alloc): Fix initialization of localloc'ed memory.
	No idea why this worked before.

	* branch-opts.c (mono_branch_optimize_exception_target): Avoid branches
	which branch to outer exception clauses since they could skip the
	inner finally clauses. Fixes #78633.

	* exceptions.cs: Add a test for the above.

	* mini.c (merge_basic_blocks): Nullify the branch at the end of the first bb.
	Fixes #78629.

	* iltests.il: Add a test for the above.

2006-06-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (remove_block_if_useless): Do not remove the bblock immediately
	after the end of a try bblock, to prevent asserts in mini_method_compile ().

	* iltests.il: Add a test for the above.

2006-06-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Remove some code duplication.
	
	* mini-ia64.c inssel-ia64.brg: Implement the new net 2.0 Interlocked.Add
	methods as instrinsics.

2006-06-09  Wade Berrier <wberrier@novell.com>

	* Makefile.am: Fix sources list for svn rename so that make dist succeeds
	(simple-cee-ops.h ssapre-mini-ops.h)

2006-06-09  Neale Ferguson <neale@sinenomine.net>

	* mini-exceptions.c (ves_icall_get_frame_info): Fix this function on s390/s390x.
	* mini-s390x.c, mini-s390.c: Correct ATOMIC operations (incorrect register for CS
	instruction).
	* mini-s390x.h, mini-s390.h: Simplify MCONTEXT_GET_BP.
	* cpu-s390x.md: Fix max. length values for a couple of instructions.

2006-06-09  Jonathan Chambers  <jonathan.chambers@ansys.com>

	* mini-exceptions.c: Minor fix for building mono in Visual Studio.

2006-06-08  Massimiliano Mantione  <massi@ximian.com>

	* ssapre-cee-ops.h: Renamed as "simple-cee-ops.h"
	* simple-cee-ops.h: Was "ssapre-cee-ops.h" (renamed).
	* ssapre-mini-ops.h: Renamed as "simple-mini-ops.h"
	* simple-mini-ops.h: Was "ssapre-mini-ops.h" (renamed).
	* local-propagation.c: In mono_cprop_invalidate_values use a whitelist
	of opcodes, so that bug 78549 should not happen again.
	* ssapre.c: Updated to use the renamed files.

2006-06-08  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix a wrong reg-reg move 
	in OP_ATOMIC_EXCHANGE_I4.

2006-06-07  Wade Berrier <wberrier@novell.com>

	* tramp-s390.c: Fix s390 build (add missing pointer declarations 
	in mono_debugger_create_notification_function)

2006-06-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (NEW_AOTCONST_TOKEN): Fix amd64 build.
	
	* mini.c (type_from_stack_type): Disable some changes which do not
	seem to work.

	* driver.c: Reenable opts.

	* mini.h (MonoStackSlot): New structure to keep track of the verification state
	of the evaluation stack.
	
	* mini.h (MonoBasicBlock): Add a 'stack_state' field to keep track of the
	evaluation stack trace at entry to the bblock.

	* mini.c (merge_stacks): New function to perform verification of stack merges.
	Turned off by default.

	* mini.c: Fill up ins->klass for instructions whose type is STACK_OBJ or
	STACK_MP.
	
2006-06-06  Massimiliano Mantione  <massi@ximian.com>

	* local-propagation.c: Fixed bug 78549.

2006-06-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (ves_icall_get_frame_info): Fix this function on ia64.

2006-06-02  Miguel de Icaza  <miguel@novell.com>

	* tramp-sparc.c, tramp-ppc.c, tramp-s390.c, tramp-s390x.c,
	tramp-arm.c, tramp-ia64.c
	(mono_debugger_create_notification_function): Update signature to
	new signature and use new protocol for creating the notification
	function.  

	Should fix the build.

2006-06-02  Geoff Norton  <gnorton@customerdna.com>

	* exceptions-ppc.c (mono_jit_walk_stack)
	(ves_icall_get_frame_info): Fix the build

2006-06-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_set_defaults): Fix the handling of -O=-all.

2006-05-31  Raja R Harinath  <rharinath@novell.com>

	* il2tests.2.il: New file for generics CIL tests.  Add test for
	#78019.
	* Makefile.am: Update.

	Fix #78019
	* mini.c (mono_method_to_ir): Don't apply box+brtrue optimization
	to nullable types.

2006-05-30  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed bug 78311.

2006-05-29  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c (mono_find_jit_info): When computing the
	native offset, check whether we're actually inside the method's
	code; call mono_debug_print_stack_frame() to format the frame.
	(ves_icall_System_Exception_get_trace): Call
	mono_debug_print_stack_frame() to format the stack frame.
	(ves_icall_get_trace): Update to the new debugging API.
	(mono_jit_walk_stack_from_ctx): Likewise.
	(ves_icall_get_frame_info): Likewise.

	* mini.c (get_method_from_ip): Use the new debugging API.
	(mono_print_method_from_ip): Likewise.

	* exceptions-ppc.c
	(mono_jit_walk_stack): Use the new debugging API.
	(ves_icall_get_frame_info): Likewise.	

2006-05-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_output_basic_block): Fix MONO_PROFILE_COVERAGE.

2006-05-25  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added "limitator" to inline for debugging.

2006-05-24  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (mono_debugger_init): Create a private,
	malloc()-based code manager for the notification function and
	intentionally leak it on exit.  This fixes the crash-on-exit race
	condition.

	* tramp-amd64.c
	(mono_debugger_create_notification_function): Added
	`MonoCodeManager *' argument.

	* tramp-x86.c
	(mono_debugger_create_notification_function): Added
	`MonoCodeManager *' argument.

2006-05-23  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed 64 bit issue.
	* driver.c: Enabled inline,consprop,copyprop,treeprop,deadce by
	default since all known bugs are fixed (one more time!).

Tue May 23 13:47:28 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: write barrier support.

2006-05-23  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Revert Paolo's change.  Add comment and #error
	check at the top of the file.

Sun May 21 12:22:29 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: fix the build. Again. Hopefully Martin will stop
	reverting changes without reason and without changelog entries.

2006-05-18  Zoltan Varga  <vargaz@gmail.com>

	* mini-sparc.c (mono_arch_output_basic_block): Add support for large stack offets
	to a few opcodes. Fixes #78439.

	* mini-sparc.c: Rename mono_sparch_break () to mono_arch_break () to improve
	consistency with other archs.

	* mini-ia64.c (mono_arch_emit_prolog): Remove debug stuff left in by mistake.

Wed May 17 18:07:33 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: fix the build.

2006-05-17  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c
	(debugger_thread_vtable): Moved here from ../metadata/threads.c.
	(debugger_init_threads): Formerly known as mono_debugger_init_threads().
	(debugger_finalize_threads): Formaly known as mono_debugger_finalize_threads().
	(debugger_attach): Call GC_mono_debugger_add_all_threads().

2006-05-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Call pthread_attr_destroy () to fix a small memory leak.

2006-05-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_instrument_epilog): Fix handling of 
	MONO_TYPE_GENERICINST.
	
	* mini-amd64.c (mono_arch_instrument_epilog): Fix handling of 
	MONO_TYPE_GENERICINST.

2006-05-09  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_get_vcall_slot_addr): Add a missing call sequence. Fixes
	#78325.

2006-05-08  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_create_jump_trampoline): Allocate MonoJitInfo from the domain
	mempool.
	(mono_jit_free_method): Remove the method from jump_trampoline_hash as well.

2006-05-06  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Applied patch from Joachim Ante (joe@otee.dk). Call
	mono_trace_cleanup ().

	* iltests.il: Fix problem with the newly added test.

	* mini-codegen.c (mono_local_regalloc): When changing the dreg of an instruction
	due to register constraints, free up the previous hreg. Fixes #78314.

	* iltests.il: Add new test for #78314.	

	* mini-x86.c (mono_arch_get_inst_for_method): Use OP_ATOMIC_ADD_NEW_I4 for
	Interlocked.Add. Fixes #78312.

	* mini-amd64.c (mono_arch_get_inst_for_method): Ditto.
	
2006-05-05  Zoltan Varga  <vargaz@gmail.com>

	* inssel.brg (mini_emit_virtual_call): Fix a warning.

2006-05-05  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debug_open_block): New method.

	* mini-amd64.c
	(mono_arch_output_basic_block): Call mono_debug_open_block() at
	the beginning of each basic block.

	* mini-x86.c
	(mono_arch_output_basic_block): Call mono_debug_open_block() at
	the beginning of each basic block.

2006-05-04  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Disabled inline,consprop,copyprop,treeprop,deadce by
	default until I understand why they break the build on amd64.

2006-05-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Call mono_cleanup ().

	* mini.c (UNVERIFIED): New macro to make it easier to track down verification
	errors.

2006-05-04  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed shameful cut&paste error that caused JIT crashes.
	* driver.c: Enabled inline,consprop,copyprop,treeprop,deadce by
	default since all known bugs are fixed, and I cannot reproduce bug
	77944... I'm asking Matt Hargett to test again after this commit.

2006-04-28  Massimiliano Mantione  <massi@ximian.com>

	* mini-codegen.c: Fixed typo that thrashed inline.

2006-04-28  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Avoid using a worklist since
	it is not correct in some cases. Instead, iterate over all bblocks as
	in the original paper. Fixes --compile-all -O=all System.Xml.dll.

2006-04-28  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_jit_compile_method_inner): Use
	mono_prepare_exception_from_error that resets the value
	internally.

2006-04-27  Miguel de Icaza  <miguel@novell.com>

	* mini.c: Move the mini_loader_error_to_exception to metadata. 
	
2006-04-27  Massimiliano Mantione  <massi@ximian.com>

	* aliasing.c: Fixed bug 78210.

2006-04-27  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Disabled inline,consprop,copyprop,treeprop,deadce by
	default until all their problems (or the ones they trigger) are fixed.

2006-04-26  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c (mono_aot_get_method_from_token_inner): Fix the previous patch.
	
	* aot-runtime.c (mono_aot_get_method_from_token_inner): Mark the method
	as loaded only after resolving patches since that could invoke the same method.

	* aot-runtime.c (mono_aot_plt_resolve): Fix ppc etc. builds.

	* aot-compiler.c: Refactor mono_aot_compile_aot () into a bunch of smaller
	functions.

	* aot-runtime.c (init_plt): Use a normal trampoline to transfer code to the
	AOT loader.

	* aot-compiler.c (emit_plt): Pass the plt offset in %eax instead of on the
	stack.

	* mini-trampolines.c (mono_aot_plt_trampoline): New trampoline to handle calls
	made from AOT code through the PLT table.

	* mini-x86.h mini-amd64.h: Define MONO_ARCH_AOT_PLT_OFFSET_REG to the register
	holding the plt offset when a call is made to the aot plt trampoline.
	
2006-04-25  Zoltan Varga  <vargaz@gmail.com>

	* aot-runtime.c aot-compiler.c cpu-amd64.md mini-amd64.c: Update parts of the 
	amd64 AOT support.

	* Makefile.am (common_sources): Fix build breakage.

	* aot-runtime.c aot-compiler.c: Reorganize the AOT code yet again: Make all
	calls through a jump table similar to the ELF PLT table. Avoid indirect calls for
	intra-assembly calls if possible.
	
	* tramp-*.c: Add new functions for patching/nullifying PLT entries.

	* mini-trampolines.c: Handle PLT entries.

	* mini.c: Avoid creating a GOT var for calls.

	* jit-icalls.c (helper_ldstr_mscorlib): New helper function for loading strings
	from mscorlib code.

	* jit-icalls.c (helper_newobj_mscorlib): New helper function to create objects
	from mscorlib code.

	* mini.c (mono_method_to_ir): Use the new helper functions in throw bblocks in
	AOT code.	

	* mini.h: Bump AOT file format version.
	
	* mini.c (get_basic_blocks): Fix the calculation of bb->out_of_line so it
	covers more cases.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* driver.c: Disable copyprop, consprop and inline when running
	inside the debugger.

2006-04-25  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h (MonoDebuggerInfo): Replaced `get_thread_id'
	with `get_current_thread' and added `detach'.
	(MonoDebuggerMetadataInfo): Added `thread_size',
	`thread_tid_offset', `thread_stack_ptr_offset' and
	`thread_end_stack_offset'.

2006-04-25  Zoltan Varga  <vargaz@gmail.com>

	* aot.c Makefile.am: Split aot.c into two new files aot-compiler.c and 
	aot-runtime.c.

	* inssel.brg (mini_emit_load_intf_reg_vtable): Use a new kind of AOT constant
	ADJUSTED_IID to avoid the need for adjusting the IID at runtime.

	* mini.h (MonoJumpInfoType): Add MONO_PATCH_INFO_ADJUSTED_IID.

	* mini.c (mono_resolve_patch_target): Handle ADJUSTED_IID.

	* aot.c: Add support for ADJUSTED_IID.	

2006-04-24  Zoltan Varga  <vargaz@gmail.com>

	* aot.c (emit_method_order): Don't align method_order_end.

	* inssel.brg (stmt): Fix interface calls in AOT code which got broken by
	the interface ID changes.

2006-04-21  Dick Porter  <dick@ximian.com>

	* mini.c (mini_thread_cleanup): Clear the JIT TLS data when
	cleaning up a thread.  Fixes the new part of bug 77470.

2006-04-20  Geoff Norton  <gnorton@customerdna.com>

	* mini-ppc.c: Call mono_jit_thread_attach when transitioning a native
	to managed wrapper.
                     
2006-04-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c: Remove mono_type_to_ldind/stind () which are now in marshal.c.
	
	* mini.c (mono_runtime_install_handlers): Handle SIGABRT similarly to
	SIGSEGV. Fixes #78072.

	* mini-exceptions.c (mono_handle_native_sigsegv): Add a 'signal' argument,
	unregister our SIGABRT handler.

2006-04-19  Massimiliano Mantione  <massi@ximian.com>

        * mini.c: Disabled inline where it can alter the call stack in a
	way visible from managed code.
	* driver.c: enabled inline,consprop,copyprop,treeprop,deadce by
	default.

2006-04-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_emit_prolog): Attach the thread to the runtime as it is done
	on other platforms. Fixes #78089.

2006-04-13  Martin Baulig  <martin@ximian.com>

	* driver.c: Also check a `MONO_INSIDE_MDB' environment variable to
	determine whether we're inside the debugger.

	* debug-debugger.h
	(MonoDebuggerMetadataInfo): Added all offsets from `MonoDefaults'.

2006-04-12  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Handle multiple LEAVE statements inside a single
	handler clauses. Fixes #78024.

	* mini-sparc.c (mono_arch_output_basic_block): Handle large offsets
	in the CALL_MEMBASE opcodes. Fixes #78088.
	(mono_arch_get_vcall_slot_addr): Ditto.

2006-04-10  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: The thread handling code has now been moved
	into ../metadata/threads.c.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* driver.c (mono_main): Fix --with-gc=none build.

	* mini-codegen.c (mono_spillvar_offset): Improve alignment.
	(mono_spillvar_offset_float): Ditto.
	(mono_local_regalloc): Only do the OP_MOVE optimization if ins->dreg is a local
	hreg, not when its !global, since on ia64, there is a third category: stacked
	registers.	

Mon Apr 10 14:39:49 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: set MonoInst->klass for load field address and a few other
	places.

2006-04-10  Zoltan Varga  <vargaz@gmail.com>

	* helpers.c (mono_disassemble_code): Emit debug info on amd64 as well.

2006-04-07  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Fix yet another bug which surfaced after
	the branch opt changes.

2006-04-06  Dick Porter  <dick@ximian.com>

	* wapihandles.c (mini_wapi_semdel): Fix parameters in semctl () call.
	
	* wapihandles.c (mini_wapi_seminfo): 
	* driver.c (mono_main): Add semaphore info option

2006-04-05  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (compute_dominators): Fix a bug which surfaced after the recent
	branch optimization changes. Fixes #78009.

Wed Apr 5 16:40:33 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: ignore accessibility of methods in managed->native wrappers.

2006-04-04  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_cleanup): Call print_jit_stats () earlier since it accesses metadata.
	
	* mini.c (mini_cleanup): Free 'emul_opcode_map' as well.

2006-04-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Modify the branch optimizations to preserve the invariant that
	the entries inside the in_bb and out_bb arrays are unique.
	(mono_unlink_bblock): Avoid creation of new arrays.

2006-04-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_unlink_bblock): Fix regression caused by previous
	change (#77992).

2006-04-01  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (optimize_branches): Remove the "optimizations" in
	the cbranch1/cbranch2 -> branch cases which were causing several
	problems in the past. Fixes #77986.

2006-03-31  Chris Toshok  <toshok@ximian.com>

	* driver.c (DEFAULT_OPTIMIZATIONS): back out the new set of
	default optimizations :(

2006-03-31  Zoltan Varga  <vargaz@gmail.com>

	* inssel-x86.brg mini-codegen.c mini.c: Merge some changes/fixes from linear-il
	branch.

2006-03-31  Massimiliano Mantione  <massi@ximian.com>

        * local-propagation.c: Added comments to structs and removed
	"Mono" prefixes from local tree mover types.

2006-03-30  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am (arch_sources): Define this for each architecture so 
	libmono_la_SOURCES is defined in one place.

Wed Mar 29 20:51:14 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, wapihandles.c, Makefile.am: integrate the io-layer utils
	from handles/.

Wed Mar 29 17:16:57 CEST 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: print the GC name supplied by configure.

2006-03-29  Massimiliano Mantione  <massi@ximian.com>

        * local-propagation.c: Added tree mover, and moved here all the
	local propagation code from mini.c
        * mini.c: Added support for treeprop, and moved all the	local
	propagation code to local-propagation.c
        * mini.h: Added support for treeprop
        * driver.c: Added support for treeprop, enabled consprop, copyprop,
	treeprop, inline and deadce by default
        * Makefile.am: Added local-propagation.c

2006-03-25  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-sparc.c: Applied patch from David S. Miller  <davem@sunset.davemloft.net>: Implement correct support for sparc/linux.

Fri Mar 24 20:07:19 CET 2006 Paolo Molaro <lupus@ximian.com>

	* debug-debugger.c: make it compile without the Boehm GC.

Wed Mar 22 18:25:18 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: fixed issue with mismatch when an icall is registered
	with multiple names but same address.

Tue Mar 21 15:59:57 CET 2006 Paolo Molaro <lupus@ximian.com>

	* declsec.c, mini-exceptions.c: use write barrier to set reference
	fields of managed objects.

2006-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_print_method_from_ip): Recognize JIT trampolines as well.
	(can_access_internals): Fix a warning.

	* mini.c (print_method_from_ip): Rename this to 
	mono_print_method_from_ip so it gets exported.

	* trace.c: Deal with strings inside StringBuilder's containing garbage
	and fix memory leaks. Fixes #77848.

2006-03-19  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mini_init): Disable the setting of GC_stackbottom on ia64. Hopefully
	fixes #77787.

2006-03-16 Neale Ferguson <neale@sinenomine.net>
	
	* mini-s390.c: Remove OP_X86_TEST_NULL.

Thu Mar 16 17:19:04 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: use the correct GetHashCode() for the moving collector.

2006-03-16  Massimiliano Mantione  <massi@ximian.com>

        * liveness.c: Regalloc spill cost tuning.

2006-03-15 Neale Ferguson <neale@sinenomine.net>
	
	* mini-s390x.h: Correct S390_LONG macro.

	* mini-s390x.c: Cleanup unused code.

2006-03-15  Zoltan Varga  <vargaz@gmail.com>

	* jit-icalls.h: New file.

	* Makefile.am mini.c jit-icalls.c: Use a proper include file for the jit
	icalls and include that instead of including jit-icalls.c.

	* mini-ppc.c (mono_arch_output_basic_block): Remove references to
	OP_X86 opcodes.

Tue Mar 14 20:23:53 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: when checking for member accessibility, also check for
	friend assemblies and for explicit interface implementations.

2006-03-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Remove incorrect g_free () calls.

	* cpu-arm.md cpu-g4.md: Remove x86_ opcodes.

	* mini-x86.h (MONO_ARCH_INST_FIXED_REG): Reorganize the comparisons so
	common cases are done first.	

	* mini-ops.h: Only define platform specific opcodes on the given platform.

	* mini.h regalloc.h mini-codegen.c: Merge optimizations from the linear-il
	branch.
	
2006-03-14  Martin Baulig  <martin@ximian.com>

	Revert Paolo's change from r57348:

	* mini.h: don't use gboolean for bitfields.
	* mini.c: verifier changes for fields and methods accessibility.

2006-03-13  Neale Ferguson <neale@sinenomine.net>

	* mini-s390.h, mini-s390x.h: Fix calls to mono_call_inst_add_outarg_reg.

	* mini-s390x.c: Fix conv_r_un.

	* cpu-s390, cpu-s390x.md: Fix lengths.

Sun Mar 12 17:31:22 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: nested types have access to all the nesting
	levels, not just the enclosing types.

Sun Mar 12 16:23:11 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: added a few more verification checks.

2006-03-12  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c: Merge optimizations from the linear-il branch.

2006-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (emit_call): Add a comment.

	* tramp-ia64.c (mono_arch_patch_callsite): Handle indirect calls as well.

	* tramp-ia64.c: Fix some warnings.

Sat Mar 11 20:15:59 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h: don't use gboolean for bitfields.
	* mini.c: verifier changes for fields and methods accessibility.

2006-03-11  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_icall_get_wrapper): Fix an ia64 bug introduced by the
	lazy icall wrapper changes.

	* dominators.c: Replace all the dominator algorithms with faster
	ones from the linear-il branch.

	* inssel-*.brg: Allocate call->out_ireg_args and call->out_freg_args from
	the mempool.

	* mini-amd64.h (MONO_ARCH_INST_FIXED_REG): Reorganize the comparisons so
	common cases are done first.

	* mini-amd64.c: Fix some warnings.

	* mini-codegen.c mini-*.c: Allocate call->out_ireg_args and call->out_freg_args
	from the mempool.

	* mini.c (mono_jit_compile_method_with_opt): Fix a race in the newly
	added code.

	* mini.h: Add a missing prototype.

2006-03-10  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Compile icall wrappers lazily.

	* mini-codegen.c: Use printf instead of g_print since its much faster.

	* mini.h (mono_bitset_foreach_bit): Use the faster mono_bitset_find_start ()
	function.

	* mini.c (optimize_branches): Cache the negative result from 
	remove_block_if_useless ().

	* mini.c (optimize_branches): Avoid restarting the iteration after each change.	
	Also fix some bblock linking issues.

	* helpers.c (mono_disassemble_code): Reduce the size of the temporary
	assembly files.

	* mini.h: Define G_LIKELY/G_UNLIKELY macros for older glib versions.

	* mini.h (MonoBasicBlock): Reorganize the fields, putting more frequently
	accessed fields first, for better cache behavior.
	
Fri Mar 10 18:21:41 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: speedup IList<T> array accesses.

2006-03-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Handle large methods overflowing the 
	inline_costs counter. Fixes #77190.

2006-03-06  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c: Call mono_trace_is_enabled () before printing
	trace messages. Fixes #77706.

2006-03-04  Martin Baulig  <martin@ximian.com>

	* tramp-amd64.c, tramp-x86.c
	(mono_debugger_create_notification_function): Use
	mono_global_codeman_reserve() to allocate a buffer at runtime and
	return it.

	* debug-debugger.h (MonoDebuggerInfo): Added `initialize'.

	* debug-debugger.c (mono_debugger_init): Dynamically allocate the
	notification function at runtime and then call `initialize' in the
	`MONO_DEBUGGER__debugger_info' vtable.

2006-03-04  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Fix a visibility problem.

Wed Mar 1 15:55:25 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, mini.c: add hooks for the counters API.

Wed Mar 1 12:28:04 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c: show disabled options.

Wed Mar 1 12:18:51 CET 2006 Paolo Molaro <lupus@ximian.com>

	* linear-scan.c: always use cost-driven selection.

2006-02-28  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (helper_compile_generic_method): Revert change from
	2006-02-24.

Mon Feb 27 18:58:19 GMT 2006 Paolo Molaro <lupus@ximian.com>

	* cpu-arm.md, mini-arm.c: implemented MemoryBarrier.

Sat Feb 25 17:39:21 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: style fixes, mostly to force the updated monoburg
	to run for people using svn.

Sat Feb 25 17:07:42 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: match monoburg changes.

Sat Feb 25 16:04:33 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c, abcremoval.c, aliasing.c, liveness.c,
	ssapre.c, graph.c, ssa.c: put the mono_burg_arity[]
	declaration in the header file.

Sat Feb 25 14:19:31 CET 2006 Paolo Molaro <lupus@ximian.com>

	* helpers.c: reduce relocations and mem usage.

Sat Feb 25 11:58:16 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-codegen.c: disable logging features if
	requested by configure.

Sat Feb 25 11:54:49 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: tiny verifier changes.

Fri Feb 24 18:17:52 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, inssel-x86.brg, tramp-x86.c, mini-x86.c,
	cpu-pentium.md: stack alignment changes for osx/x86,
	partially from Geoff Norton <gnorton@customerdna.com>.

2006-02-24  Raja R Harinath  <harinath@gmail.com>

	* jit-icalls.c (helper_compile_generic_method): Update to changes
	in metadata/class.c.

2006-02-24  Zoltan Varga  <vargaz@gmail.com>
	
	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add a missing check.
	
	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Add support for
	interface calls with large offsets.

2006-02-23  Raja R Harinath  <rharinath@novell.com>

	* jit-icalls.c (helper_compile_generic_method): Document the
	special-case we depend on so that we can inflate the method twice
	with the same context with no bad side-effects.

Thu Feb 23 13:45:46 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-amd64.c: fix for case when xen support
	is disabled.

Wed Feb 22 19:38:40 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, mini-amd64.c: generate code to access tls items
	in a faster way for Xen systems.

Wed Feb 22 10:31:25 CET 2006 Paolo Molaro <lupus@ximian.com>

	* exceptions-x86.c, mini-x86.h, driver.c, mini-codegen.c:
	updates and compilation fixes for the OSX/x86 port, mostly from
	Geoff Norton <gnorton@customerdna.com>.

Tue Feb 21 19:56:55 CET 2006 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: faster interface call implementation
	to sync with the interface_offsets MonoVTable changes.

Mon Feb 20 10:37:57 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: more verification checks.

Fri Feb 17 19:47:29 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: added a few more verification checks.

2006-02-17	Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h: Check for presence of long displacement
	facility on the processor and use it if available.

Fri Feb 17 16:12:52 CET 2006 Paolo Molaro <lupus@ximian.com>

	* driver.c, aot.c, mini.c: throw exception if the IL code is
	invalid or unverifiable.

2006-02-17  Raja R Harinath  <rharinath@novell.com>

	* generics.2.cs (test_0_ldfld_stfld_mro): Use m.struct_field, not
	m.StructField.

2006-02-16  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Add some tests for generics ldfld/stfld wrappers.

Wed Feb 15 16:23:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-s390x.c, mini-s390.c, mini.c, mini-amd64.c, mini-arm.c,
	mini-ia64.c, mini-sparc.c, mini-x86.c, mini-ppc.c: fixed
	handling of instantiated generic valuetypes.

2006-02-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c mini-x86.h mini-x86.c: Get rid of 
	MONO_INIT_CONTEXT_FROM_CALLER, and use MONO_INIT_CONTEXT_FROM_FUNC
	instead.

	* generics.2.cs: Revert the nullable reftypes tests.

2006-02-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (MONO_INIT_CONTEXT_FROM_CALLER): Avoid
	using __builtin_frame_address (1) as it doesn't work in the presence
	of optimizations. Hopefully fixes #77273.

	* Makefile.am generics.cs generics.2.cs: Revert the generics.2.cs
	-> generics.cs change as it doesn't work with some automake versions.

Thu Feb 9 16:24:44 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle systems that sue a different way to
	retrieve the stack address of the current thread.

2006-02-09  Zoltan Varga  <vargaz@gmail.com>

	* Makefile.am generics.2.cs: Rename this to generics.cs and handle
	it specially in the makefile.

	* generics.2.cs: Add tests for nullable reference types.

Wed Feb 8 19:33:17 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: always handle the case when mono_jit_init()
	is called in a thread different from the main thread,
	confusing libgc (bug #77309).

Mon Feb 6 09:01:24 EST 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fix handling of exceptions in large methods (bug #74932).

Fri Feb 3 18:51:35 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: change optimize_branches () to use a single loop
	and introduce a new optimization to simplify some range checks.

2006-02-03  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c (debugger_thread_manager_thread_created): Removed
	and merged with debugger_thread_manager_add_thread().
	(mono_debugger_main): Call debugger_thread_manager_add_thread() to
	inform the debugger about the main thread.

2006-02-03  Zoltan Varga  <vargaz@gmail.com>

	* basic.cs: Add test for div.un/rem.un constant folding.

2006-02-03  Neale Ferguson <neale@sinenomine.net>

	* cpu-s390x.md: correct int_xor_imm length

2006-02-03  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: New test for #77442.

	* jit-icalls.c (helper_compile_generic_method): Check for null. Fixes
	#77442.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* tramp-x86.c, tramp-amd64.c: It's now safe to #include
	<mono/metadata/mono-debug-debugger.h>	

	* debug-mini.c: Don't #define _IN_THE_MONO_DEBUGGER.

2006-02-02  Martin Baulig  <martin@ximian.com>

	* debug-debugger.h: New header file for debug-debugger.c.

	* debug-debugger.c: Big API cleanup; don't run the managed Main()
	function is a separate thread anymore; add support for attaching.

2006-02-01  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c: Fix a warning.

2006-01-31  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Avoid hitting an assertion
	on very large methods.

	* aot.c (load_patch_info): Fix a warning.

Mon Jan 30 12:51:10 CET 2006 Paolo Molaro <lupus@ximian.com>

	* cpu-pentium.md, mini-x86.c, inssel.brg, inssel-x86.brg,
	mini-ops.h: alu membase optimizations.

Fri Jan 27 21:11:08 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini.c, inssel.brg, inssel-x86.brg: opcode
	to speedup StringBuilder.

2006-01-27  Zoltan Varga  <vargaz@gmail.com>

	* dominators.c (mono_compute_natural_loops): Fix detection of
	loop body start blocks.

	* mini-exceptions.c (mono_print_thread_dump): Fix non x86 builds.

2006-01-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c mini-exceptions.c: Add thread dump support. Fixes
	#75145.

2006-01-25  Massimiliano Mantione  <massi@ximian.com>

        * aliasing.c: Fixed aliasing issue on 64 bit archs.

2006-01-25  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Moved the `MonoDebuggerManager' and
	`MonoDebuggerThread' typedefs here from mono-debug-debugger.h and
	started to cleanup this file a little bit.

Tue Jan 24 18:20:48 CET 2006 Paolo Molaro <lupus@ximian.com>

	* mini.c: optimize a codepath frequently happening in generics code.

2006-01-23  Martin Baulig  <martin@ximian.com>

	* Makefile.am: Only compile debug-debugger.c on supported platforms.

	* debug-debugger.c: Kill the IO_LAYER() hack and use the io-layer
	functions directly.

	* driver.c: debug-debugger.c is only available if
	`MONO_DEBUGGER_SUPPORTED' is defined.	

2006-01-23  Martin Baulig  <martin@ximian.com>

	* debug-debugger.c: Only enable this on platforms where the Mono
	Debugger is working (x86 and x86_64).

2006-01-21  Martin Baulig  <martin@ximian.com>

	The Mono Debugger is now using the normal `mono' instead of the
	`mono-debugger-mini-wrapper' when executing managed code.

	* debug-debugger.c: New file; previously known as
	debugger/wrapper/wrapper.c.

	* debug-mini.c (mono_init_debugger): Removed.

	* driver.c (mono_main): Added new `--inside-mdb' command line
	argument which is used when running inside the debugger.

2006-01-20  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (mono_analyze_liveness): Remove some unused data
	structures.

2006-01-17  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Move mono_bitset_test_fast macro to monobitset.h where it belongs.

2006-01-16  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (mono_bitset_test_fast): Disable the 'fast' implementation which
	depends on implementation details of monobitset.

	* mini.c (mini_get_ldelema_ins): Fix handling of 1 dimensional arrays.
	Fixes #77271.

2006-01-15  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c: Update after monobitset changes.

2006-01-14  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (mono_arch_compute_omit_fp): Fix a leak.

2006-01-11 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390x.brg: Fix reg: OP_LDADDR(OP_S390_LOADARG) register setting.

	* mini-s390x.c: Remove warning messages.

2006-01-11  Ben Maurer  <bmaurer@andrew.cmu.edu>

	* mini.c: pass the jitinfo to mono_profiler_method_end_jit.

2006-01-10  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Add ldelem/stelem_any test.

2006-01-10 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix ATOMIC_ADD_I4 operation.

2006-01-07  Zoltan Varga  <vargaz@gmail.com>

	* inssel-long.brg: Fix int->long ovf conversion rules. Fixes #77172.
	
2006-01-06  Zoltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Reenable vtype tests.

	* inssel-x86.brg: Remove an icorrect valuetype rule.

2006-01-06 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, inssel-s390x.brg, cpu-s390x.md: Fix ATOMIC_I8 operations. Provide
	initial support for OP_ABS.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c (emit_float_to_int): Correct r8 to unsigned int algorithm.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c, mini-s390.h, inssel-s390.brg, cpu-s390.md: Fix r8 to unsigned int 
	conversion and implement LADD/LSUB.

	* exceptions-s390.c: Standardize mono_arch_find_jit_info to match other
	architectures.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h: Fix r8 to unsigned int conversion.

	* exceptions-s390x.c: Standardize mono_arch_find_jit_info to match other
	architectures.

2006-01-05 Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h, mini-s390.c, mini-s390.h: Fix lmf handling when 
	localloc is encountered.  Fixes crash in test-183.cs when using gmcs 
	(stack walk problem).

2006-01-04  Zoltan Varga  <vargaz@gmail.com>

	* aot.c (mono_aot_load_method): Fix a warning.

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.h, exceptions-s390x.c, inssel-s390x.brg: Fix compiler warnings

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Add test for #77148.

	* mini.c (mini_get_ldelema_ins): Handle arrays with rank 1 too. Fixes
	#77148.

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, inssel-s390x.brg: Remove debug statements

2006-01-03  Neale Ferguson <neale@sinenomine.net>

	* mini-s390x.c, mini-s390x.h, exceptions-s390x.c, tramp-s390x.c, inssel-s390x.brg,
	cpu-s390x.md, mini-codegen.c, Makefile.am: add 64-bit s390 support to JIT.

	* basic-long.cs: Add lconv-to-r4/r8 tests.

2006-01-03  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Fix DynamicMethod support in some opcodes.

	* mini-sparc.c (mono_arch_call_opcode): Use mono_class_value_size ()
	here as on other archs.

2005-12-29 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c (mono_arch_get_inst_for_method): Add memory_barrier support.

2005-12-29 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390.brg: Correct register assignment; Rework L[ADD|SUB]_OVF[_UN] for s390.
	
	* cpu-s390.md: Fix lengths of a couple of long instructions; Add memory_barrier.

	* mini-s390.c: Fix long add/sub overflow instructions; Fix displacement handling in
	instrument_prolog; Add memory_barrier instruction.

2005-12-26  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c mini-x86.h: Fix solaris/x86 exception handling.

2005-12-23  Zoltan Varga  <vargaz@gmail.com>

	* tramp-ia64.c (mono_arch_get_unbox_trampoline): Flush icache.

	* aliasing.c inssel.brg: Fix warnings.

	* inssel-ia64.brg (OP_MEMSET): Fix an optimization which previously
	could skip initialization of some parts of memory.

	* mini.c mini-ia64.c: Fix warnings.

	* inssel-sparc.brg: Add an implementation of lneg which actually works.

2005-12-22  Zoltan Varga  <vargaz@gmail.com>

	* aliasing.c (mono_build_aliasing_information): Add a workaround for
	a crash seen on sparc.

	* mini-sparc.c: Add implementation of Thread.MemoryBarrier.
	
	* cpu-sparc.md: Add memory_barrier opcode. Remove unused opcodes.

2005-12-21 Neale Ferguson <neale@sinenomine.net>

	* mini-ops.h: Add s390_backchain instruction

	* inssel-s390.brg: Use backchaining instruction for LOADARG/STKARG operations.

	* cpu-s390.md: Add s390_backchain instruction

	* mini-s390.c: Significant ABI changes

	* mini-s390.h: Cater for zero length structures

2005-12-20 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: ABI fixes

	* inssel-s390.brg: Remove debug statements

	* cpu-s390.md: Fix length of ATOMIC_xx operations

2005-12-19  Zoltan Varga  <vargaz@gmail.com>

	* basic-float.cs: Add float<->long conversion tests.

2005-12-16 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix LOCALLOC processing.

	* tramp-s390.c (s390_magic_trampoline): Fix base calculation.

2005-12-15  Zoltan Varga  <vargaz@gmail.com>

	* iltests.il: Add tests for some opcodes not covered by the other
	tests.

2005-12-15 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c: Fix ADDCC/SBB bug revealed by test_0_ulong_regress; Correct 
	register loading for Tail processing; Correct trace output.

	* inssel-s390.brg: Reimplement LSUB_OVF due to s390 implementation of signed math.

	* cpu-s390.md: Correct size of jmp instruction. 

2005-12-13 Neale Ferguson <neale@sinenomine.net>

	* mini-s390.c (mono_arch_emit_prolog): Remove some debugging bits.

2005-12-13 Neale Ferguson <neale@sinenomine.net>

	* inssel-s390.brg tramp-s390.c cpu-s390.md mini-s390.c mini-s390.h:
	  Bring s390 up to current level.

2005-12-12  Zltan Varga  <vargaz@gmail.com>

	* generics.2.cs: Disable the newly added tests as they do not work yet.
	
	* generics.2.cs: Add valuetype tests.

2005-12-09  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs: Add i4->u8 test.

	* objects.cs: Add tests for JIT intrinsic.

	* mini.c (mini_get_inst_for_method): Resurrect the array Rank/Length
	optimizations lost by a mistake.

2005-12-07  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs: Remove a test moved to objects.cs.

	* arrays.cs: Add more array tests.

2005-12-06  Zoltan Varga  <vargaz@gmail.com>

	* arrays.cs: Add new tests for multi-dimensional arrays.

2005-12-06  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (test_sources2): Add generics.2.cs.
	(EXTRA_DIST): Add test_sources2.

2005-12-05  Ben Maurer  <bmaurer@ximian.com>

	Support for boxing and unboxing nullable types as well as the
	isinst operation on nullables, per the CLI ammendment.

	* inssel.brg (CEE_ISINST): Special case for nullable

	* mini.c (handle_unbox_nullable): new method
	(handle_box): Special case for nullable types
	(mono_method_to_ir): Call handle_unbox_nullable in correct
	places.

	* generics.2.cs: New test suite

	* Makefile.am: Support for regression tests with generics.

2005-12-03  Zoltan Varga  <vargaz@gmail.com>

	* mini-amd64.c (emit_load_volatile_arguments): Add loading of arguments
	allocated to registers. Fixes #76800.

Thu Dec 1 12:59:40 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, inssel-ppc.brg: fix ABI issue (pinvoke3.cs).

2005-11-30  Zoltan Varga  <vargaz@gmail.com>

	* exceptions.cs: Disable test_0_long_cast () test, since it fails on a lot 
	of platforms.

2005-11-29  Zoltan Varga  <vargaz@gmail.com>

	* objects.cs basic-calls.cs: Move a test depending on valuetypes to
	objects.cs.

	* inssel-long32.brg (CEE_CONV_I8): Remove unused labels.
	
	* inssel-long32.brg (CEE_CONV_I8): Convert this to a branchless version.
Tue Nov 29 05:41:34 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: ensure a fp register is converted to
	single precision before storing to a single precision location.

2005-11-28  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (ILASM): Use profile-dependent location of ilasm.

2005-11-27  Zoltan Varga  <vargaz@gmail.com>

	* basic-long.cs basic-calls.cs objects.cs: Move some tests to the
	correct files.

	* basic.cs: Remove test_0_byte_compares test which was moved to
	objects.cs a long time ago.

2005-11-22  Massimiliano Mantione  <massi@ximian.com>

        * aliasing.c: Fixed aliasing issue on 64 bit archs.

2005-11-20  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c exceptions-ia64.c: Simplify the way filters/finally
	handlers are called.

	* mini-ia64.c (mono_arch_emit_exceptions): Optimize size of exception
	throwing code.

	 * mini-ia64.c: Add support for the throw->branch exception 
	optimization.	

	* driver.c (DEFAULT_OPTIMIZATIONS): Add MONO_OPT_EXCEPTION.

2005-11-18  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Enabled "fastpath" deadce :-)
	
2005-11-18  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added "fastpath" deadce (deadce without SSA), and a simple
	alias analysis pass to support it.
	* mini.h: Likewise.
	* ssa.c: Likewise.
	* liveness.c: Likewise (liveness computation can use aliasing
	information to be more accurate).
	* driver.c: Added an "ssa" option go tell the JIT to use SSA, and
	moreover made so that "--compile-all" uses the given optimization
	flags and not the default ones.
	* aliasing.c: Alias analysis (new file).
	* aliasing.h: Likewise.
	* Makefile.am: added "aliasing.c" and "aliasing.h".
	
2005-11-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h: Add missing OP_I opcodes so it is in synch with the
	OP_L opcodes.

2005-11-13  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_exception_internal): Remove the 
	fp >= end_of_stack exit condition, as it is not needed, and it might
	become true for fp eliminated frames.

2005-11-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_epilog): Use G_STRUCT_OFFSET instead of hard
	coded offsets.

Tue Nov 8 11:28:20 GMT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed alignment of doubles/longs to match
	the C ABI (bug #76635).

Mon Nov 7 16:13:21 CET 2005 Paolo Molaro <lupus@ximian.com>

	* aot.c: fix compilation with --enable-minimal=aot.

Fri Nov 4 12:34:15 GMT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: fixed compatibility with the new
	floating point emulator package for compares.

2005-11-03  Atsushi Enomoto  <atsushi@ximian.com?

	* mini.c : reverted sig->pinvoke changes (r51396-51397).

2005-11-01  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (print_stack_frame): Output to stderr.
	(mono_handle_native_sigsegv): Ditto.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Remove unused
	OP_LCONV_TO_OVF_I implementation.

	* mini-amd64.c: Add support for the throw->branch exception 
	optimization.

	* branch-opts.c (mono_branch_optimize_exception_target): Allow the case
	when the catch clause catches a more general exception, i.e. Object.

2005-10-30  Zoltan Varga  <vargaz@gmail.com>

	* cpu-ia64.md: Remove unused opcodes.

	* mini.c (GET_CONTEXT): Simplify this somewhat by removing arch
	specific defines for architectures defining USE_SIGACTION.

	* mini-ia64.c: Fix some warnings.

	* exceptions-ia64.c (mono_arch_ip_from_context): Fix this, the previous
	version seemed to skip a frame.

2005-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Clean up the usage of sig->pinvoke flag. Now
	only calls which are made to native code use this flag.

2005-10-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_compute_omit_fp): Disable fp elimination for
	varargs methods as well.
	
	* mini-amd64.c exceptions-amd64.c: Allow fp elimination in methods
	which have save_lmf set. Reorganize methods prologs a bit.

	* mini-amd64.c (mono_arch_compute_omit_fp): Move the check for the
	debugger to the proper place.

2005-10-29  Martin Baulig  <martin@ximian.com>

	* mini-amd64.c (debug_omit_fp): Temporarily disable fp elimination
	when running inside the debugger until the debugger has support
	for it.

2005-10-26  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Fix a warning.

2005-10-24  Miguel de Icaza  <miguel@novell.com>

	* mini.c (mono_pmip): Just a wrapper for get_method_from_ip which
	we expose publicly, this returns the string.

2005-10-22  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-amd64.c (mono_arch_find_jit_info): Fix some corner cases
	with fp elimination.

2005-10-21  Zoltan Varga  <vargaz@gmail.com>

	* mini-exceptions.c (mono_handle_native_sigsegv): Try to print a
	native stacktrace using the glibc 'backtrace' function if available.

2005-10-20  Zoltan Varga  <vargaz@gmail.com>

	* mini.h (MonoDebugOptions): Remove 'abort_on_sigsegv' option.

	* mini-exceptions.c (mono_handle_native_sigsegv): New function to 
	handle SIGSEGVs received while in native code.

	* mini.c (sigsegv_signal_handler): If the SIGSEGV happened in native
	code, call mono_handle_native_sigsegv which will abort the runtime
	after printing some diagnostics, instead of converting it into a
	confusing NullReferenceException.

2005-10-18  Zoltan Varga  <vargaz@gmail.com>

	* cpu-pentium.md: Remove unused opcodes.

2005-10-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h (MonoLMF): Add rsp field.

	* mini-amd64.c exceptions-amd64.c tramp-amd64.c: Save the sp reg into
	the lmf too.

2005-10-17  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (get_register_spilling): Fix some warnings.

2005-10-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h mini-amd64.c exceptions-amd64.c: Add support for fp
	elimination during exception handling. Enable fp elimination by
	default.

	* mini-amd64.h mini-amd64.c: Add preliminary support for frame pointer
	elimination.

2005-10-16  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c
	(mono_debugger_run_finally): New public method for the debugger.

2005-10-10  Zoltan Varga  <vargaz@gmail.com>

	* debug-mini.c (mono_debug_init_method): Fix warning.

	* mini.h branch-opts.c (mono_branch_optimize_exception_target): Make
	the 'exname' parameter const to fix some warnings.

2005-10-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_handle_exception_internal): Fix another bug
	introduced by the previous patch.

2005-10-08  Zoltan Varga  <vargaz@gmail.com>

	* basic-float.cs: Add test for precision of float arithmetic.

	* mini-ia64.c (mono_arch_output_basic_block): Convert to/from doubles
	when loading/storing single values from/to memory.

	* mini.c (mono_jit_compile_method_with_opt): Create the function
	pointers in the correct domain.

2005-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_handle_exception_internal): Fix bug 
	introduced by previous patch.
	
	* mini-exceptions.c (mono_handle_exception_internal): Handle the case
	when out_filter_idx is NULL.

	* mini-exceptions.c: Don't run filter clauses twice during exception
	handling. Fixes #75755.

2005-10-07  Zoltan Varga  <vargaz@gmail.com>

	* aot.c: Add support for ldflda wrappers.

	* mini.c (mono_method_to_ir): Use ldflda wrappers for CEE_LDFLDA. Fixes
	#75902.

Tue Oct 4 20:23:25 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h: do not consider exception handlers blocks when
	setting up interface variables.

2005-10-04  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (emit_section_change): Fix emitting of sections on win32. Fixes #76322.

2005-10-03  Zoltan Varga  <vargaz@gmail.com>

	* liveness.c (mono_analyze_liveness): Revert parts of r51051 since it
	causes a regression.

	* mini.c (mini_thread_cleanup): Fix reading of freed memory.

2005-10-02  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h (OP_PCONST): Move the definition of OP_PCONST into the rest
	of the OP_P definitions.

	* TODO: Add a proposal for dealing with the CEE/OP mess.

	* mini-amd64.c (mono_arch_output_basic_block): Merge mul_imm 
	optimizations from the x86 port.

	* cpu-amd64.md: Ditto.

	* basic.cs basic-long.cs: Add tests.

Fri Sep 30 20:07:20 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, driver.c, mini-x86.c, mini.c, mini.h, branch-opts.c:
	Patrik Torstensson's implementation of my exception-handling
	optimization idea, when the exception object is not used
	(bug #62150).

Fri Sep 30 19:10:29 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c, cpu-pentium.md: Patrik Torstensson's port
	of the mul_imm optimizations from the old jit.

Fri Sep 30 11:37:51 EDT 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, liveness.c: patch by Patrik Torstensson and
	Zoltan Varga to improve performance in methods with
	exception clauses.

2005-09-30  Zoltan Varga  <vargaz@gmail.com>

	* driver.c: Remove 'Globalization' entry from --version.

2005-09-28  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_jit_compile_method_inner): Do not load AOT code when
	there is a profiler interested in JIT events.

	* aot.c: Load profile files produced by the AOT profiling module, and
	reorder methods based on the profiling info. Add a 'method_order' table
	to the AOT file to make mono_aot_find_jit_info work with the reordered
	methods.

	* mini.h: Bump AOT file version info.

Wed Sep 28 17:12:48 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h: work around what looks like a gcc bug when optimizations
	are enabled.

2005-09-28  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (AM_CFLAGS): Don't use += to append inside
	conditionals.  Use ...
	(PLATFORM_CFLAGS, ARCH_CFLAGS): ... these.

2005-09-27  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_call_opcode): Use mono_class_value_size ()
	to determine the amount of memory to copy when passing valuetypes.

	* inssel-amd64.brg: Remove PUSH(LDIND4) rules since they convert an
	4 byte load into a 8 byte load. Fix aligning of size in OP_OUTARG_VT.

2005-09-27  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c aot.c: Add infrastructure to collect pagefault 
	information about aot.

2005-09-27  Ben Maurer  <bmaurer@ximian.com>

	* *.c: Replace the use of {Enter,Leave}CriticalSection with
        macros. This will allow a deadlock debugger to easily be plugged
        in.

Tue Sep 27 09:32:11 EDT 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: added memory barrier instruction.

2005-09-27  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (AM_CFLAGS): Rename from INCLUDES.
	(AM_CFLAGS) [PLATFORM_WIN32): Append to it, don't set it.
	(AM_CFLAGS) [ARM]: Add arch/arm directory from the build tree.
	($(arch_built)) [CROSS_COMPILING]: Error out.

2005-09-26  Zoltan Varga  <vargaz@gmail.com>

	* aot.c: Add support for the no_special_static flag for classes.

2005-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* Reapply reverted patches.

	* *: Revert r50174 as well.

	* mini-amd64.c cpu-amd64.md inssel-amd64.brg: Revert r50170 as well.

2005-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c: Revert r50342 to see if this fixed buildbot.

2005-09-23  Miguel de Icaza  <miguel@novell.com>

	* mini.c (SIG_HANDLER_SIGNATURE): Only dereference info if it is
	part of the SIG_HANDLER_SIGNATURE.  

2005-09-23  Zoltan Varga  <vargaz@gmail.com>

	* mini.h mini.c: Add a new MONO_DEBUG option to collect metadata pagefault
	statistics.

	* mini-x86.c (mono_arch_call_opcode): Fix vararg calling convention 
	introduced by previous patch.

2005-09-21  Zoltan Varga  <vargaz@gmail.com>

	* tramp-x86.c (mono_arch_create_trampoline_code): Restore caller
	saved registers too.

	* mini-x86.c (mono_arch_allocate_vars): Rewrite this so it works based 
	upon the information returned by get_call_info ().
	
	* mini-x86.c (add_float): Fix stack size calculation.
	(mono_arch_call_opcode): Rewrite this so it works based up the
	information returned by get_call_info ().
	(mono_arch_get_this_vret_args): Ditto.

2005-09-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_emit_this_vret_args): Use the information
	in cinfo to determine the registers which need to be used.

2005-09-20  Miguel de Icaza  <miguel@novell.com>

	* driver.c (mono_main): Add --server and --desktop flags. 

2005-09-16  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.h: Make register masks 64 bit. Don't treat argument
	registers as global registers.

	* inssel-ia64.brg (stmt): Remove OP_OUTARG_REG () rules which are no 
	longer needed with the new register allocator.

	* mini-ia64.c: Use OP_MOVE instead of OP_SETREG for reg-reg moves.

	* cpu-ia64.md: Remove unused opcodes.
	
	* regalloc.c mini-codegen.c: Make register masks 64 bit on ia64.
	
2005-09-16  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Remove unused opcodes.

	* inssel-amd64.brg: Remove OP_OUTARG_REG () rules which are no longer
	needed with the new register allocator.

	* inssel-amd64.brg mini-amd64.c: Use OP_MOVE instead of OP_SETREG for
	reg-reg moves.

2005-09-16  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (check-local): Don't invoke semdel-wrapper.

2005-09-16  Martin Baulig  <martin@ximian.com>

	* exceptions-amd64.c
	(throw_exception): Don't call mono_debugger_throw_exception() if
	we're a rethrow - see the FIXME in the code.

2005-09-15  Geoff Norton  <gnorton@customerdna.com>

	* mini.c (mono_init_exceptions): This only works on some architectures.
	
2005-09-15  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_method_to_ir): Add OP_LMUL imm -> OP_LMUL_IMM conversion
	on ia64.

	* inssel-long.brg mini-ia64.c: Add OP_LMUL_IMM rules.

	* mini-ia64.h mini-ia64.c: Remove the altstack support code which is
	now in mini-exceptions.c.

2005-09-15  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h mini-am64.c: Remove the altstack support code which is
	now in mini-exceptions.c.

2005-09-15  Zoltan Varga  <vargaz@gmail.com>

	* exceptions-x86.c: Applied patch from Patrik Torstensson 
	<patrik.torstensson@gmail.com>. Add stack overflow handling support for win32.

	* mini-exceptions.c mini-x86.c mini.c: Move the altstack setup/teardown
	code into mini-exceptions.c. Add some assertions to it.

2005-09-12  Zoltan Varga  <vargaz@gmail.com>

	* aot.c (emit_section_change): Applied patch from "The Software Team" 
	(<software@solmersa.com>). Fix as errors on windows.

2005-09-11  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (mono_arch_create_trampoline_code): Fix saving of
	method info into the LMF.

2005-09-11  Zoltan Varga  <vargaz@gmail.com>
	
	* mini-ia64.c: Add proper unwind info for method epilogs.

	* exceptions-ia64.c: Add some code to help debugging.
	
	* mini-ia64.c mini-ia64.h: Add sigaltstack support.

	* mini-exceptions.c: Fix warning.

2005-09-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Really fix build.

	* mini-x86.c mini-amd64.c: Fix build.

2005-09-11  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c inssel-ia64.brg: Add InterlockedExchange instrinsics.

	* mini-ops.h cpu-ia64.md inssel-ia64.brg mini-ia64.c: Implement
	some Interlocked methods as intrinsics.

	* mini.c (mini_get_inst_for_method): Call arch_get_inst_for_method
	for Thread methods as well.

	* mini-ops.h: Add OP_MEMORY_BARRIER opcode.

	* inssel.brg: Add rule for OP_MEMORY_BARRIER.

	* mini-ia64.c mini-x86.c mini-amd64.c 
	cpu-ia64.md cpu-pentium.md cpu-amd64.md: Add implementation of 
	OP_MEMORY_BARRIER.
	
	* mini.c (mono_init_exceptions): Fix build breakage.

2005-09-10  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c exceptions-ia64.c tramp-ia64.c: Remove 'manual' emitting
	of instructions. Use the new ia64_unw_op macros for emitting unwind
	info.

	* mini.c (mono_init_exceptions): Initialize exception handling
	related trampolines at startup.

Fri Sep 9 19:30:37 BST 2005 Paolo Molaro <lupus@ximian.com>

	* cpu-arm.md, mini-arm.c: fix for dynamic code (Gtk# apps).

2005-09-09  Zoltan Varga  <vargaz@gmail.com>

	* mini.c: Handle type loading errors gracefully during compilation and
	throw the appropriate exception.

Fri Sep 9 09:49:14 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* ldscript.mono, Makefile.am: use anonymous versions in the ldscript
	for the mono binary.

2005-09-09  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): Comment out the G_BREAKPOINT()'s for
	the release.

Thu Sep 8 14:53:45 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.h: use emulation for conv.r.un for the release.

Thu Sep 8 11:28:45 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, objects.cs: more fixes and tests for them.

Wed Sep 7 17:14:26 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c: align structures to at least 4 bytes to be able
	to keep our current optimized memcpy.

Tue Sep 6 22:51:08 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, cpu-arm.md, inssel-arm.brg: bugfixes.

2005-09-05 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: ignore SIGPIPE.

2005-09-04  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_lowering_pass): Convert 'and_imm 255' to zext1.

	* mini-ia64.h mini-ia64.c: Add some minor optimizations.

2005-09-02  Zoltan Varga  <vargaz@gmail.com>

	* mini.h: Add prototype for mono_allocate_stack_slots_full.

Thu Sep 1 21:05:26 BST 2005 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c, mini.c, mini-arm.c, mini-arm.h:
	exception handling support.
	* mini-arm.c, mini-arm.h: bigendian fixes (partially from a
	patch by Brian Koropoff <briank@marakicorp.com>).

Thu Sep 1 10:22:44 EDT 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: revert another 'optimization' which breaks when
	items on the eval stack need to be saved at a basic block end
	(bug #75940).

Wed Aug 31 17:29:32 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c: for arrays, ensure we always provide
	lower bounds.

2005-08-30  Zoltan Varga  <vargaz@gmail.com>

	* mini.c (mono_allocate_stack_slots_full): Fix ia64 build.
	
	* mini.c (mini_get_inst_for_method): Special case Object:.ctor as well.

2005-08-29  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.h mini-ia64.c: Implement frame pointer elimination. Keep
	arguments in their original register.

2005-08-28  Zoltan Varga  <vargaz@gmail.com>

	* mini-ops.h cpu-ia64.md inssel-ia64.brg mini-ia64.c: Optimize
	memset/memcpy.

	* mini.c (mono_method_to_ir): Disable the MUL->MUL_IMM optimization
	when ssapre is enabled.

	* inssel-long.brg: Fix bug in previous patch.

	* mini-ia64.c mini-ia64.h mini.c inssel-long.brg: Optimize 
	multiplication by a constant.

2005-08-27  Zoltan Varga  <vargaz@gmail.com>

	* mini-ia64.c (mono_arch_setup_jit_tls_data): Add support for intel
	icc.

	* tramp-ia64.c (mono_arch_create_trampoline_code): Use st8.spill for
	saving registers.

Fri Aug 26 11:09:28 BST 2005 Paolo Molaro <lupus@ximian.com>

	* inssel-arm.brg: apply changes tested by Brian Koropoff
	<briank@marakicorp.com>.

2005-08-25  Zoltan Varga  <vargaz@gmail.com>

	* mini-x86.c (mono_arch_emit_prolog): Fix calling of mono_jit_thread_attach () under windows.
	
2005-08-24  Zoltan Varga  <vargaz@gmail.com>

	* mini-codegen.c (mono_local_regalloc): Avoid allocating dreg and sreg1/2
	to the same register if dreg is just a base register.
	(print_ins): Improve printing of membase opcodes.

	* inssel-x86.brg: Add optimized ldind(reg) rules.

	* mini-x86.c cpu-pentium.md: Changes required to support the new rules.

Wed Aug 24 19:39:36 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: when running under valgrind, set the stack bottom for
	the GC at the actual approximate stack for the app (fixes running
	mono with valgrind).

Tue Aug 23 21:38:50 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: do no break at the first valuetype to init found
	(fixes bug #75791).

Tue Aug 23 16:53:21 BST 2005 Paolo Molaro <lupus@ximian.com>

	* cpu-arm.md, mini-arm.c: more fixes and LMF support.

Tue Aug 23 15:11:44 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* cpu-g4.md: fixed instruction length exposed by the nemerle compiler.

2005-08-23  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-amd64.brg inssel-x86.brg: Fix the fcall rules.

2005-08-22  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-x86.brg: Fix assert in patch_delegate_trampoline.

	* tramp-x86.c (mono_arch_patch_delegate_trampoline): Add some debug
	code.

	* tramp-amd64.c (mono_arch_patch_delegate_trampoline): Add some debug
	code.

	* mini.c (optimize_branches): Don't quit after 1000 iterations on large
	methods.

Mon Aug 22 19:16:29 BST 2005 Paolo Molaro <lupus@ximian.com>

	* tramp-arm.c: allocate less memory for the trampoline and fix typo.

2005-08-22  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Remove instructions inserted after a branch
	in the tail recursion optimization.

	* mini.h helpers.c (mono_disassemble_code): Emit starts of basic blocks as 
	debug info into the assembly file.

	* iltests.il: Add test for filter regions.

	* mini.c (mono_method_to_ir): Fix handling of nested FILTER clauses. Fix
	initial stack of filter regions. Fixes #75755.

Mon Aug 22 17:49:16 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-arm.c, cpu-arm.c: fixes and support for methods with bigger
	stack requirements.

2005-08-22  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_create_delegate_trampoline): Fix memory leak. Put back
	the check for an already compiled method on non-ia64 platforms.
	(mono_create_jump_trampoline): Store the MonoJitInfo structure into the
	proper domain.

	* mini-x86.h tramp-x86.c: Add support for delegate trampolines.

	* inssel-x86.brg: Add some optimized call rules.

2005-08-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_create_delegate_trampoline): Do not return an already compiled
	method here.

	* mini.h mini-trampolines.c: Pass the trampoline argument to 
	mono_arch_patch_delegate_trampoline.

	* mini-ia64.h mini-ia64.c tramp-ia64.c: Add support for delegate trampolines.

	* mini-trampolines.c: Fix build.

	* mini-amd64.h: Add delegate trampolines.

	* mini.h mini.c mini-trampolines.c tramp-amd64.c: Add delegate trampolines.

	* inssel-amd64.brg: Add optimized call rules.
	
	* mini-ia64.c tramp-ia64.c: Improve instruction scheduling.

	* inssel-ia64.brg: Add optimized ldind(reg) rules.

2005-08-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_create_class_init_trampoline): Fix bug caused by last
	change.

	* mini-ia64.c: Remove LMF fixmes.

	* mini-ia64.h: Remove most fields from LMF.

	* inssel-ia64.brg (stmt): Fix unaligned access errors.

	* mini-trampolines.c: Add support for IA64 function descriptors.

	* mini.h mini.c jit-icalls.c exceptions-ia64.cdriver.c: Add support
	for IA64 function descriptors.

Sat Aug 20 16:51:44 BST 2005 Paolo Molaro <lupus@ximian.com>

	* tramp-arm.c: patch the vtable for virtual calls. Added
	support code to register/unregister the LMF.
	* mini-arm.c, mini-arm.h: warning fixes, fixes, speedups,
	more LMF work.

2005-08-19  Dick Porter  <dick@ximian.com>

	* mini.c: Use a gsize to store the thread ID, so it can hold a 64
	bit value if needed.

2005-08-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mini_get_method): Move handling of wrapper data here.

	* mini.c (mono_method_to_ir): Add support for dynamic methods.

	* mini.c (mono_method_to_ir): Convert nonvirtual calls to abstract methods into
	virtual.

	* mini.c (mono_method_to_ir): Emit IR for CEE_NOP as well, so 
	bblock->code does not remain empty.

2005-08-17  Zoltan Varga  <vargaz@freemail.hu>

	* arrays.cs: Add regression test for #75832.

	* inssel-amd64.brg cpu-amd64.md mini-amd64.c: Fix LDELEMA optimization
	rules. Fixes #75832.

	* mini-ia64.c tramp-ia64.c exceptions-ia64.c: Implement improved
	instruction scheduling.

2005-08-12  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (ves_icall_get_frame_info): Fix IA64 build.

2005-08-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c mini-x86.h: Move VC stuff into macros in mini-x86.h.

	* mini-codegen.c: Fix VC build.

	* cpu-pentium.md: Increase length of atomic_exhange_i4.

2005-08-09 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.h: fix signature for mono_register_opcode_emulation.

2005-08-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Get rid of most of the helper_sig_... constants using
	mono_create_icall_signature ().

2005-08-08  Zoltan Varga  <vargaz@freemail.hu>

	* jit-icalls.c (helper_ldstr): New helper function.

	* mini.c (get_basic_blocks): Set out_of_line for bblocks containing a throw.

	* mini.c (mono_method_to_ir): If an LDSTR instruction is in a bblock with a
	throw, load the string using a helper call instead of creating a string object.

	* aot.c: Update after LDSTR changes.

	* mini.h: Bump AOT file version.
	
	* aot.c: Save class size info into the AOT file. Print more statistics during
	compilation.

	* mini.h: Bump AOT file version.

	* tramp-amd64.c (mono_arch_nullify_class_init_trampoline): Fix
	ordering of disasm cases. Fixes #74957.

Thu Aug 4 19:47:24 BST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini-arch.h, inssel.brg, mini.c, mini.h,
	jit-icalls.c, mini-codegen.c, Makefile.am: changes in
	the generic code needed for the ARM port.

Thu Aug 4 19:42:54 BST 2005 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c, tramp-arm.c, mini-arm.c, mini-arm.h, cpu-arm.md,
	inssel-arm.brg: more ARM features and fixes.

Mon Aug 1 18:37:38 BST 2005 Paolo Molaro <lupus@ximian.com>

	* tramp-arm.c, mini-arm.c, cpu-arm.md, inssel-arm.brg: more
	ARM port work in progress.

2005-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c (mono_arch_call_opcode): Ongoing IA64 work.

	* mini-exceptions.c mini-ia64.h: Ongoing IA64 work.

	* mini-ia64.c (ia64_emit_bundle): Ongoing IA64 work.

	* inssel.brg (mini_emit_memset): Add support for unaligned access.

	* *-ia64.*: Ongoing IA64 work.
	
	* mini-ia64.c exceptions-ia64.c: Ongoing IA64 work.

2005-07-28  Zoltan Varga  <vargaz@freemail.hu>

	* TODO: Remove out-of-data todo stuff.

	* mini.h mini.c (mono_create_jit_trampoline_from_token): Remove some
	dead code.

	* aot.c: Save/load MonoCachedClassInfo->has_nested_classes.

	* mini.h: Bump corlib version.

2005-07-27  Martin Baulig  <martin@ximian.com>

	* mini-codegen.c
	(create_copy_ins): Added `const unsigned char *ip' argument; set
	`copy->cil_code' from it.

2005-07-27  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c (mono_handle_exception): Don't call
	mono_debugger_handle_exception() for filters.

2005-07-27  Zoltan Varga  <vargaz@freemail.hu>

	* mini-trampolines.c (mono_aot_trampoline): Handle AppDomain:InvokeInDomain
	as well.

2005-07-26  Martin Baulig  <martin@ximian.com>

	Committing a patch from Michal Moskal <michal.moskal@gmail.com>.

	* mini.c (mono_method_to_ir): In `CEE_CALLI', only use
	helper_compile_generic_method() if the method is actually virtual
	and non-final.

2005-07-26  Martin Baulig  <martin@ximian.com>

	* mini.c
	(trampoline_code): Renamed to `mono_trampoline_code' and made it
	public; this is now accessed directly by the debugger.
	(mono_generic_trampoline_code): Removed.

	* debug-mini.c
	(mono_debug_init_method): Also add interncalls and wrappers.

2005-07-23  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c mini-ia64.h: Add support for tracing/profiling.

2005-07-22  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_aot_get_method_from_token): Fix a potential crash here.

2005-07-21  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (load_patch_info): Fix handling of stfld_remote wrapper.

2005-07-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_setup_jit_tls_data): Use the nice way of
	getting TLS offsets on AMD64 too.

2005-07-20  Kornél Pál <kornelpal@hotmail.com>

	* driver.c: Detach console when executing IMAGE_SUBSYSTEM_WINDOWS_GUI on win32

Wed Jul 20 18:05:19 BST 2005 Paolo Molaro <lupus@ximian.com>

	* exceptions-arm.c, mini-arm.c, tramp-arm.c, cpu-arm.md,
	inssel-arm.brg,	mini-arm.h: ARM port work in progress.

2005-07-20  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (mono_arch_create_specific_trampoline): Fix build.

	* mini.h mini.c mini-*.h tramp-*.c: Move more cross platform trampoline code
	to mini.c.

	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Call 
	mono_sparc_is_virtual_call ().
	
	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Fix warning.

	* tramp-sparc.c (mono_arch_create_trampoline_code): Fix order of
	trampoline parameters.

	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Fix signature.
	
	* mini-sparc.c (mono_arch_get_vcall_slot_addr): Rename this
	to mono_arch_get_vcall_slot_addr.

	* Makefile.am tramp-sparc.c: Update the sparc port to use the generic
	trampoline code.

	* *-sparc.*: Merge the mini-xp-regalloc branch for sparc.

2005-07-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.h mini-ia64.c: Finish pinvoke support.

2005-07-19  Martin Baulig  <martin@ximian.com>

	* exceptions-amd64.c (throw_exception): Call
	mono_debugger_throw_exception() here like we're doing it on i386.

2005-07-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c: Add optimized TLS access support.

2005-07-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c: Ongoing IA64 work.

	* mini-ia64.c inssel-long.brg: Ongoing IA64 work.

	* mini.c: Use the default optimization set when embedding. Fixes
	#75194.

2005-07-11  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c tramp-ia64.c Makefile.am: Move arch independent parts 
	of trampolines to a separate file.

	* mini-trampolines.c: New file.

	* mini.h tramp-x86.c: Move arch independent parts of trampolines to a 
	separate file.
	
	* tramp-x86.c: Reorganize the trampoline code to be similar to the 
	amd64/ia64 code.

	* mini-codegen.c: Fix cygwin build.

2005-07-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Add some minor changes needed by the IA64 port.

	* *-ia64.*: Ongoing IA64 work.

2005-07-09  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c mini-amd64.c: Update after latest AOT changes. Split 
	trampolines into arch-independent and arch-dependent parts.

	* mini-amd64.c (mono_arch_lowering_pass): Fix store_membase_imm -> store_membase_reg rule.

2005-07-08  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Merge the xp-regalloc-branch for amd64.

	* mini-ops.h mini-amd64.h mini-amd64.c inssel-amd64.brg Makefile.am: Merge
	the xp-regalloc-branch for amd64.

	* mini-x86.h mini-x86.c cpu-pentium.md Makefile.am: Merge the
	xp-regalloc-branch for x86.

2005-07-07  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg (OP_THROW_OR_NULL): Allways rethrow the abort exception.

2005-07-06  Martin Baulig  <martin@ximian.com>

	* mini.c
	(mono_jit_compile_method_inner): Call mono_get_inflated_method().
	(mono_jit_runtime_invoke): Likewise.

2005-07-05  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Allocate the GOT in the .bss segment
	on x86 too.
	
	* aot.c: Add new mono_aot_get_method_from_token () function to load AOT methods
	without loading their metadata. Reorganize the file format so exception handling+
	debug info is kept separate from normal method info. Create MonoJitInfo 
	structures for methods lazily.

	* tramp-x86.c (x86_aot_trampoline): Use the new from_token method to avoid
	loading metadata.
	(x86_class_init_trampoline): Patch AOT class init trampolines too.

	* mini.c (mini_init): Install the new mono_aot_find_jit_info hook.

	* mini.c (mono_method_to_ir): Reduce the number of class init trampoline calls
	in AOT code.

	* mini.h: Bump AOT file version.

2005-07-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (peephole_pass): Fix the loadi1/loadi2 rules.

2005-07-01  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (check-local): Call semdel-wrapper.

2005-06-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c: Revert the last change as it seems to break the build..

2005-06-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (peephole_pass): Fix the loadi1/loadi2 rules.
	
	* mini-x86.c (mono_arch_cpu_init): Fix setting of fp precision in the VC build.

2005-06-27  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (NEW_AOTCONST): make sure to call mono_get_got_var
	outside of the macro, so strange stuff doesn't happen with gcc4
	(NEW_AOTCONST_TOKEN): Likewise.

2005-06-28  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_class_is_system_array): New static method; use this
	instead of `klass->parent == mono_defaults.array_class' everywhere
	since this also works for the new generic array class.

2005-06-26  Ben Maurer  <bmaurer@ximian.com>

	* inssel.brg: Remove warnings.

2005-06-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c: Ongoing IA64 work.

	* basic-float.cs: Add float->i1 conversion test.

	* iltests.il: Add conv.u4 test.

2005-06-23  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long.brg: Fix bug caused by last change.

2005-06-23  Geoff Norton  <gnorton@customerdna.com>

	* mini-x86.h: Add __APPLE__ to the SC_* redefines with the other 
	BSDs.  Allows the x86 JIT to work on OSX86

2005-06-22  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long.brg: Use OP_LSHR_UN_IMM instead of OP_SHR_UN_IMM in
	u4->i8 conversion.

	* mini-ia64.c: Ongoing IA64 work.

2005-06-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c: Ongoing IA64 work.

	* driver.c: Clean up jit_code_hash as well when using --regression.

	* inssel-long.brg: Fix long->i4/u4 conversion rules.

	* basic-long.cs: Add tests for long->u4 conversion.

2005-06-18  Ben Maurer  <bmaurer@ximian.com>

	* mini.c: Take mono_get_domainvar out of macros. This makes sure
	that we do not depend on undefined C behavior: the order stuff
	gets evaluated within an expression. Fixes mono when compiled on
	GCC 4.

2005-06-18  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.

	* aot.c: Lower memory usage while loading AOT methods.

	* tramp-x86.c: Avoid allocating+freeing MonoJitInfo structures.

	* mini.h: Bump AOT file format version.

2005-06-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Allow STACK_PTR as input to SWITCH.

2005-06-16  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Fixed APTC to check for FullTrust on caller assembly (and
	not on callee assembly). Fixed some comments.

2005-06-16  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Mark the "methods" symbol as a function so
	it gets proper disassembly.
	(emit_method_info): Remove some dead code.

	* mini.c (mini_method_compile): Allways allocate the GOT var in
	mono_method_to_ir for emulating opcodes.

2005-06-13  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_free_method): Remove the method from the JitInfo table
	before freeing the code memory. Fixes #74990.

	* objects.cs: Add regression test for #74992.

	* liveness.c: Extend live ranges of arguments to the beginning of the
	method. Fixes #74992.

	* exceptions-ia64.c mini-ia64.h: Modify ip during exception handling
	so it points into the faulting instruction.

2005-06-12  Zoltan Varga  <vargaz@freemail.hu>

	* jit-icalls.c (mono_imul_ovf): Add exception handling.

	* *-ia64.*: Ongoing IA64 work.

	* mini.c (mini_init): Fix signature of mono_delegate_ctor.

2005-06-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.h exceptions-ia64.c: Ongoing IA64 work.

	* *-ia64.*: Ongoing IA64 work.

2005-06-10  Zoltan Varga  <vargaz@freemail.hu>

	* basic-long.cs: Add tests for add/sub.ovf.

	* basic.cs: Add tests for sub.ovf.

	* *-ia64.*: Ongoing IA64 work.

2005-06-09  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.

	* basic.cs: Add conv.ovf.i4.un test.

2005-06-09  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: (remove_block_if_useless) Fixed bug 75061.
	
2005-06-08 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: no SIGUSR2 on windows. Remove it for PLATFORM_WIN32.

2005-06-07  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.

2005-06-07 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* trace.[ch]:
	* mini.c: added the ability to toggle trace on/off using SIGUSR2.

2005-06-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c mini-ia64.h: Fix cleanup of memory stack.

2005-06-03  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (emit_call): Fix yet another bug in the near call optimization.

	* mini-amd64.c (amd64_patch): Add an assert to check that the destination
	of a call is callable by a near call.

2005-05-31  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ia64.c: Ongoing IA64 work.

2005-05-29  Zoltan Varga  <vargaz@freemail.hu>

	* genmdesc.c: Make the generated array non-static.

	* inssel-long.brg: Fix LSHR_IMM rule.

	* *-ia64.*: Ongoing IA64 work.

	* *-ia64.*: Ongoing IA64 work.

2005-05-28  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.

	* *-ia64.*: Ongoing IA64 work.
	
	* mini-ia64.c: Ongoing IA64 work.

	* *-ia64.* jit-icalls.c mini-codegen.c: Ongoing IA64 work.

2005-05-28  Zoltan Varga  <vargaz@freemail.hu>

	* objects.cs basic-calls.cs: Move some tests to objects.cs.
	
	* objects.cs basic-long.cs: Move some tests to objects.cs.

2005-05-26  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.

	* iltests.il: Add a new test.

	* mini.c (mono_method_to_ir): Initialize valuetypes when created using
	newobj. Fixes #75042.

2005-05-22  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Ongoing IA64 work.
	
	* *-ia64.*: Ongoing IA64 work.
	
	* *-ia64.*: Ongoing IA64 work.

	* basic.cs objects.cs: Move tests accessing static variables as well.

	* basic.cs objects.cs: Move test_0_pin_string to objects.cs.

2005-05-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (SIG_HANDLER_SIGNATURE): Fix warning.

	* driver.c: Always print failed tests.

	* mini-codegen.c: Use cfg->frame_reg instead of a macro for the
	frame pointer.

	* *ia64*: Ongoing IA64 work.

2005-05-20  Zoltan Varga  <vargaz@freemail.hu>

	* basic.cs: Add tests for add.ovf. Fix warnings.

2005-05-18  Miguel de Icaza  <miguel@novell.com>

	* driver.c (mono_main): Avoid crash if no argument is passed to
	--break;  Do not use g_error, but f_printf.   And fix all other
	ocurrences of the same crash.

2005-05-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c: Generalize the existing uses of the MONO_DEBUG env variable
	and add a new one: aborting when a SIGSEGV is raised while in unmanaged code.
	Fixes #74742.

2005-05-14  Zoltan Varga  <vargaz@freemail.hu>

	* *-ia64.*: Add beginnings of IA64 backend.

	* Makefile.am mini-arch.h mini-codegen.c: Add IA64 support.	

2005-05-13  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long.brg: Add missing ulong->{i1, i2} checked conversions.
	Fixes #74925.

	* basic-long.cs exceptions.cs: Add new tests. Fix some warnings.

	* mini-amd64.c: Fix a warning.

2005-05-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Fix stack space leakage
	in float_neg. Fixes #74897.

	* mini-amd64.c (emit_call): Fix another near call bug.

2005-05-06  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Keep the appdomain information in the structure. Added a 
	missing "return	FALSE" for Unmanaged if FullTrust is set (or else the
	value gets overwritten).
	* declsec.h: Set the default MonoArray for the the stack to 6. Added
	an MonoAppDomain member to MonoSecurityFrame.
	* mini-exceptions.c: Do not use a glist to keep GC allocated objects
	used in the stack walk. Now use a MonoArray which grow (double) when
	it gets full.

2005-05-05  Lluis Sanchez Gual  <lluis@novell.com>

	* mini.c: Re-enabled runtime cleanup, since running threads should
	now properly stop when exiting.

2005-05-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini-codegen.c: New file contaning the arch-independent local
	register allocator. Not used by any architectures yet.

	* mini.h linear-scan.c: Merge some changes from the 
	mini-xp-local-regalloc branch.

2005-04-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (emit_call): Fix calls to native functions when the
	runtime is compiled as a shared library. Fixes #74756.

	* mini.c (mono_method_to_ir): Assert if ldsfld and friends are used
	on a literal field. Fixes #74751.

2005-04-25  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (RUNTIME): Add MONO_CFG_DIR.

2005-04-23  Zoltan Varga  <vargaz@freemail.hu>

	* objects.cs: Add missing null casting test.

2005-04-22  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_find_jit_info): Fix native offset calculation
	in wrapper methods. Also rename 'address' variable to 'offset'.

2005-04-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c debug-mini.c aot.c tramp-x86.c driver.c: Fix some gcc 4.0
	warnings.
	
	* Makefile.am (MCS): Use -unsafe instead of --unsafe.

	* aot.c: Applied patch from "The Software Team" <software@solmersa.com>. Make AOT compilation
	work on windows.

Mon Apr 18 16:20:32 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: update code to handle stack traces (fixes bug #74452).

2005-04-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_emit_stack_alloc): Initialize the whole allocated area not
	just the last bytes.

2005-04-17  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Fix warning.

	* mini-exceptions.c (ves_icall_get_frame_info): Fix bug introduced
	by the _MSC_VER stuff.

2005-04-16  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long.brg: Fix #74588.

	* cpu-amd64.md: Fix #74591.

	* iltests.il: Add new regression tests.

2005-04-13  Zoltan Varga  <vargaz@freemail.hu>

	* trace.c (mono_trace_enter_method): Print enums as an int, not as a
	valuetype.

2005-04-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (setup_stack): Unconditionally call pthread_attr_init ().

	* exceptions-x86.c mini-x86.h mini-x86.c: Applied some freebsd patches 
	from Bill Middleton <flashdict@gmail.com>.

2005-04-10  Zoltan Varga  <vargaz@freemail.hu>

	* arrays.cs: Add new regression test. Fix warnings.

2005-04-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Fix stack alignment
	and leakage in CKFINITE.

	* exceptions-amd64.c (mono_arch_get_throw_exception_by_name): Change
	this to a null op since it is called on amd64 too.

	* exceptions-amd64.c (get_throw_trampoline): Align stack.

	* exceptions-amd64.c (mono_arch_get_throw_exception_by_name): Remove
	body since this is not used on amd64.
	
	* mini-amd64.h (MONO_ARCH_NO_EMULATE_LONG_SHIFT_OPS): Remove duplicate define.

	* mini-amd64.c: Remove obsolete fixmes.

	* mini.c (print_method_from_ip): Fix debugging support.

2005-2-1  Massimiliano Mantione  <massi@ximian.com>

	* ssapre.c: Fix a subtle bug about availability, and limit SSAPRE
	so that expressions that don't give much gain are not reduced.
	* ssapre.h: Likewise.

2005-04-04  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-x86.c (mono_arch_find_jit_info): Remove last SC_EBP reference.

	* mini-x86.c (mono_emit_stack_alloc): Fix localloc under windows.

	* mini-x86.h exceptions-x86.c: Hopefully fix compilation on *BSD.

2005-04-01  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c mini-sparc.h: Add asserts when running with sigaltstack.

	* exceptions-x86.c (mono_arch_monoctx_to_sigctx): Fix cygwin build.

2005-03-31  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c: If sigaltstack support is enabled, perform win32 style
	stack touching.

	* mini.h (mono_arch_sigctx_to_monoctx): New arch-specific function.

	* mini.h (mono_arch_monoctx_to_sigctx): New arch-specific function.

	* mini.c: sigaltstack support requires MONO_ARCH_USE_SIGACTION.

	* mini-x86.h mini-x86.c exceptions-x86.c: Add support for 
	MONO_ARCH_USE_SIGACTION. Fixes #74252.

	* mini-x86.h: Enable MONO_ARCH_USE_SIGACTION on linux.

	* mini-x86.c: Fix up stack overflow handling.	

	* exceptions.cs: Add new regression test.

2005-03-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_emit_prolog): Adjust stack after calls to
	mono_jit_thread_attach.

	* mini.c (mono_method_to_ir): Verify called method is not abstract.

2005-03-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Applied Ben's patch from bug #61441 to
	avoid calling constructors using callvirt.

	* inssel.brg: Fix #74073.

2005-03-29  Sebastien Pouliot  <sebastien@ximian.com>

	* aot.c, mini.h: Added mono-compiler.h header to allow/ease 
	compilation with non-GCC compilers.
	* mini-exceptions.c, mini-x86.c|h: Patches to make compilation of mono
	possible using VS.NET. Adapted from the work of J Lothian (for VC6).

Tue Mar 29 11:43:01 CEST 2005 Paolo Molaro <lupus@ximian.com>

	* inssel.brg, arrays.cs: fix long standing 64 bit issue in access to
	klass->interface_offsets (will likely fix bug#74073).

2005-03-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_is_int_overflow): Fix rex handling.

2005-03-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Fix order of parameters
	to amd64_div_reg_size ().
	
	* mini-amd64.c (mono_arch_emit_exceptions): Emit a near call here too.

2005-03-27  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md (store_membase_reg): Fix length of storer8 opcodes.

2005-03-24  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c: Turn off automatic command line globbing under windows. Fixes #73763.

2005-03-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Remove debugging stuff left in by mistake.
	
	* mini.c (mono_precompile_assembly): Load and precompile referenced
	assemblies as well. Fixes #74015.

2005-03-23  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md (sin): Fix up maximum lengths of some opcodes.

2005-03-23  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Skip linkdemand checks for intra-corlib calls. This skips
	a lot of checks	and (anyway) permissions cannot work until corlib is 
	loaded.

Wed Mar 23 14:29:49 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixed ABI issue on sysv/ppc.

Tue Mar 22 19:03:17 CET 2005 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c, exceptions-ppc.c: added missing icache flush
	calls (fixes bug#72824).

Tue Mar 22 16:28:48 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix tail recursion elimination (see test in bug#73936).

2005-03-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Add inline versions of
	some fp functions in sse2 mode.

2005-03-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (emit_tls_get): Move tls handling into a separate helper function.

2005-03-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c: Add mono_get_jit_tls_key ().

	* mini-x86.c: Enable fast TLS support on windows.

2005-03-17  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Renamed aptc to allowpartiallytrustedcallers.
	* mini.c: Check for p/invoke method when generating code. If a
	p/invoke method, or it's class, isn't decorated with [Suppress
	UnmanagedCodeSecurity] then generate code to call System.Security.
	UnmanagedDemand (only if the security manager is active).

2005-03-16  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (create_specific_trampoline): Revert parts of the 
	last change as it seems to cause strange crashes.
	
Wed Mar 16 16:24:11 CET 2005 Paolo Molaro <lupus@ximian.com>

	* *.c: handle unsafe function pointers where needed.

2005-03-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_free_method): Remove the fixme too.

2005-03-15  Miguel de Icaza  <miguel@novell.com>

	* mini.c: As discussed, make the code actually free the delegate
	thunk now, to enable the debugging of delegate problems, use
	MONO_DEBUG=1 when running Mono. 

	This takes also care of parts of the leaks as seen by Joe.

2005-03-15  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_setup_jit_tls_data): Enable 
	thread_tls_offset calculation.

2005-03-14  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Reworked linkdemand checks for icall. The previous code
	was using the declaration code (untrusted) and didn't work as expected
	with the CLR 2.0. We're now more compatible with 2.0 than 1.x for this
	specific case.

2005-03-13  Zoltan Varga  <vargaz@freemail.hu>

	* iltests.il: Add new localloc test.

	* mini-amd64.c: Handle large stack allocations the same way as on
	windows if stack overflow handling is working.
	
	* mini-amd64.c: Allocate the signal stack using mmap.

	* mini.c (sigsegv_signal_handler): Fix reading of context.

	* mini-exceptions.c: Fix up stack overflow handling.

	* mini-amd64.h mini-amd64.c: Fix up stack overflow handling.

	* tramp-amd64.c (create_specific_trampoline): Optimize trampoline size.

	* exceptions-amd64.c (mono_amd64_exceptions_init): Remove this.

	* mini.h mini.c tramp-*.c: Move common trampoline code to mini.c.

	* mini-x86.h mini-x86.c mini-amd64.h mini-amd64.c: Get rid of the
	tramp_init functions as they are no longer needed.

2005-03-12  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (mono_amd64_tramp_init): Fix typo.
	
	* tramp-amd64.c (mono_amd64_tramp_init): Init AOT trampoline as well.

	* mini-amd64.h mini-amd64.c (mono_amd64_exceptions_init): Remove this.
	
	* mini.c mini-*.h: Remove OUT_OF_LINE_BBLOCK defines since all arches
	support that now.

	* mini-ops.h: Add OP_LMUL_IMM.

	* mini.c jit-icalls.cmini-amd64.h mini-amd64.c cpu-amd64.md: Implement
	long mul/div opcodes as intrinsic.

	* mini-amd64.c (emit_call): Handle the case when the callee might be
	an AOT method.

2005-03-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Reorder cases to be
	extra safe.
	
	* mini-amd64.c (mono_arch_get_vcall_slot_addr): Fix ordering of cases.

	* aot.c (mono_aot_load_method): Get rid of bogus make_writable call.

2005-03-09  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (mono_codegen): Don't leak here, to help people running
	monogrind.

2005-03-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Fix int->float 
	conversions in sse2 mode.

	* basic-float.cs: Add regression test.
	
	* mini-amd64.c: Reenable sse2.

2005-03-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c: Disable sse2 until some regressions are fixed.

2005-03-07	Joerg Rosenkranz <joergr@voelcker.com>

	* driver.c: Copyright text should include 2005.
	
2005-03-07  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md (load_membase): Fix more max lengths.

2005-03-06  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md (load_membase): Fix max length.

	* mini-ops.h: Add OP_F<xx>_MEMBASE opcodes.

	* inssel.brg: Add MONO_EMIT_BIALU_MEMBASE macro.

	* cpu-amd64.md inssel-amd64.brg mini-amd64.h mini-amd64.brg: Finish SSE2
	support and enable it by default. Also add OP_F<xxx>_MEMBASE opcodes.

	* basic-float.cs: Add rounding regression test.

	* mini-amd64.c (INST_IGNORES_CFLAGS): Add more instructions.

2005-03-04  Neale Ferguson <NealeFerguson@earthlink.net>

	* inssel-s390.brg, mini-s390.c: Add support for passing/returning small
        structures in registers for pinvoke wrappers.

2005-03-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (ves_icall_get_trace): Return wrapper info as well.

2005-03-03  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c mini-x86.c: Pass the domain of the native->managed
	wrapper to mono_jit_thread_attach.

	* mini.c (mini_jit_thread_attach): New jit icall.

	* mini-x86.c (mono_arch_emit_prolog): Attach to the VM in 
	native->managed wrappers.

	* exceptions.cs: Add new regression test.

	* mini.c (optimize_branches): Check regions in the cbranch to throw
	block case as well. Fixes #73242.

Tue Mar 1 18:35:27 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: thread safety fixes.

2005-02-27  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (amd64_magic_trampoline): Disable the method_ptr
	patching stuff, since delegates use jump trampolines so there is
	no caller.

	* tramp-amd64.c (create_trampoline_code): Pass NULL as 'code' in 
	jump trampolines.
	
	* tramp-amd64.c: Fix build.

	* mini-x86.c tramp-x86.c: Moved get_vtable_slot_addr into mini-x86.c and rename
	it to mono_arch_.... Add get_delegate_method_ptr implementation for x86.

	* mini-amd64.h mini.h mini-amd64.c tramp-amd64.c (mono_amd64_get_vcall_slot_addr):
	Rename this to mono_arch....
	(mono_amd64_get_delegate_method_ptr_addr): Ditto.

	* mini-amd64.c (mono_amd64_get_delegate_method_ptr_addr): New helper function.

	* mini-amd64.c (emit_call): If both the caller and the callee is
	guaranteed to have 32 bit addresses, emit a normal call.

	* tramp-amd64.c: Adapt to changes in mini-amd64.c.

	* tramp-amd64.c (amd64_magic_trampoline): Remove patching of trampolines. 
	* tramp-amd64.c (amd64_magic_trampoline): Add support for patching the
	method_ptr inside delegates.

2005-02-26  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_free_method): Free the method info even if the native code is
	invalidated. Fixes #73001.

	* mini.c: Add a proper icall wrapper for mono_delegate_ctor.

	* mini-x86.c: Only use stdcall for pinvokes on windows.

Thu Feb 24 15:22:30 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h: make mono_lmf_addr a fast-access thread var.
	* mini-x86.c: remove unreliable __thread var offset detection,
	use the correct accessors and enable by default.

2005-02-23  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_free_method): Fix memory leak.

2005-02-22  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Allocate a GOT var for THROW and RETHROW. 

2005-02-21  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Fix lengths of atomic opcodes.

Mon Feb 21 16:52:20 CET 2005 Paolo Molaro <lupus@ximian.com>

	* driver.c: try to not imply using ICU is any good.

2005-02-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_get_inst_for_method): Implement more 
	functions as inline ops.

	* mini-ops.h inssel-amd64.brg cpu-amd64.md mini-amd64.c: Implement
	some Interlocked functions as inline ops.

	* mini.c (move_basic_block_to_end): Fix bug in last patch.

	* mini.h (MonoBasicBlock): Reorganize fields a bit.

	* mini-ops.h inssel.brg: Add OP_NOT_REACHED.

	* mini.c: Add support for OP_NOT_TAKEN.

	* mini-amd64.h mini-amd64.c: Add support for passing/returning small 
	structures in registers for pinvoke wrappers.

	* mini-amd64.c: Fix warnings.

2005-02-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h (MonoCompile): Add 'ret_var_is_local' field.

	* mini.h mini.c (mono_arch_create_vars): Add new arch specific hook.

	* mini.c (NEW_RETLOADA): If the ret variable is a local, use its 
	address instead of loading the address from it.

	* mini-x86.c: Add support for returning small structs in registers
	on Win32. Fixes part of #70864.
	
2005-02-18  Zoltan Varga  <vargaz@freemail.hu>

	* trace.c (get_token): Improve error checking.

2005-02-17  Zoltan Varga  <vargaz@freemail.hu>

	* jit-icalls.c (mono_ldvirtfn): Explicitly check for a NULL obj here.

2005-02-17  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* mini.h: Moved MONO_EXCEPTION_* enum to metadata/class-internals.h so
	it can be reused for MonoClass.
	* mini.c: Renamed MONO_EXCEPTION_SECURITY to MONO_EXCEPTION_SECURITY
	_LINKDEMAND.

2005-02-15  Sebastien Pouliot  <sebastien@ximian.com>

	* mini.c: Fixed 2 cases where I sent a MonoMethod to managed code 
	instead of a MonoReflectionMethod. The method information wasn't used
	when displaying SecurityException details (but will be now).

2005-02-15  Atsushi Enomoto  <atsushi@ximian.com>

	* Makefile.am : windows build fix.

2005-02-14  Zoltan Varga  <vargaz@freemail.hu>

	* iltests.il: Add new regression test.

	* mini.c (mono_method_to_ir): Allocate a GOT var in CEE_NEWOBJ. Fixes
	#72522.

2004-02-13  Sebastien Pouliot  <sebastien@ximian.com> 
 
	* mini.c: Moved linkdemand check into helper function check_linkdemand
	to allow reuse for all intructions (CALL, CALLVIRT, NEWOBJ, JMP, 
	LDFTN, LDVIRTFTN).

2004-02-13  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Added statistics counter for different kinds of 
	LinkDemands.
	* mini.h: Added CAS statistic counters to MonoJitStats. Removed unused
	(and commented) declaration.
	* mini.c: Added statistics counter for security Demand code 
	generation. Added display of security statistics.

2005-02-13  Zoltan Varga  <vargaz@freemail.hu>

	* declsec.c (mono_declsec_linkdemand_aptc): Applied patch from Robert Jordan (robertj@gmx.net).
	Fix compilation errors under gcc-2.95.

2005-02-12  Ben Maurer  <bmaurer@ximian.com>

	* mini.c, driver.c: Use the new jit trampoline hashtable

Fri Feb 11 18:47:11 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c: use the managed implementation of memcpy, too.

2005-02-11  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debug_close_method): Free the line number array.

2005-02-10  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Break up large methods into smaller ones. Share GOT slots for
	icalls.

	* mini.h: Bump AOT file format version.	

2005-02-10  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Added LinkDemand support and it's special cases for ECMA,
	APTC and P/Invoke.
	* declsec.h: Added macros to get/set lazyly initialized security 
	informations about assemblies. Added new enum for different type of
	possible LinkDemand violation. Added function to check LinkDemands.
	* mini.h: Added a field to MonoCompile to hold any security violation
	detected when JITting a method (so it can be thrown later).
	* mini.c: Added LinkDemand checks in mono_method_to_ir for CEE_CALL 
	and CEE_CALLVIRT. Added code to throw exception at the end of
	mini_method_compile (note: the exception is unhandled right now).

Thu Feb 10 15:49:44 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, jit-icalls.c: use the managed implementation of
	memset for initobj and memset, to avoid managed <-> unmanaged
	transitions.

2005-02-10  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg (mini_emit_virtual_call): Disable the virtual->nonvirtual
	optimization if it would need a GOT var.

	* basic.cs: Add tests for constant propagation and switch statements.

	* ssa.c: Fix out-of-range constant propagation and switch statements.

2005-02-09    <vargaz@freemail.hu>

	* inssel-x86.brg (reg): Align the allocation size in the localloc(imm) case too.

2005-02-08  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md (load_membase): Fix max length of load_membase.

Tue Feb 8 18:21:11 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: update to new signature of mono_class_get_allocation_ftn().

2005-02-06  Neale Ferguson <NealeFerguson@earthlink.net>

	* cpu-s390.md,  mini-s390.c: Correct bug with register usage on certain 
	arithmetic operations.

Sun Feb 6 07:10:12 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: add a workaround for broken user code that
	DllImports vararg functions with non-vararg signatures.

2005-02-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_compile_method_inner): Add detection and a 
	meaningfull error message for assemblies written in Managed C++.

	* tramp-amd64.c mini-amd64.h: Add support for 
	create_trampoline_from_token ().

	* aot.c mini-x86.c abcremoval.c: Applied patch from
	Robert Jordan (robertj@gmx.net). Fix compilation errors under gcc-2.95.

2005-02-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c mini-x86.h tramp-x86.c: Add a new kind of trampoline 
	which takes a MonoImage/token as parameter instead of a MonoMethod.

	* aot.c: Use the new trampoline for initializing vtables.

	* aot.c: Add support for ldfld/stfld_remote wrappers.

	* mini-ops.h cpu-pentium.md inssel-x86.brg mini-x86.c: Add optimized
	rules for compare <MEM>, IMM.

	* mini.h (MONO_AOT_FILE_VERSION): Bump it.

	* aot.c: Handle inherited finalizers correctly.

2005-02-03  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg (stmt): Add a missing _setup_... ().

	* aot.c: Save some parts of the class state to the AOT file and use it
	to recompute that state when a class is initialized.

	* mini.c: Install AOT hooks into the runtime.

	* mini.h: Bump AOT file format version.
	
	* mini.c (mono_method_to_ir): Initialize pointer type locals correctly.
	Fixes #72148.

	* iltests.il: Add new test.

Wed Feb 2 16:53:59 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: fix typo.

Wed Feb 2 16:37:13 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: setup the statistical profiler in the thread attach
	callback to cope with the new single thread code.

Wed Feb 2 15:43:58 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: ensure we have enough room for the profiler
	calls (fixed bug#72084).

2005-02-02  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Get rid of the MonoAotMethod structure and the hashtable holding 
	it.

2005-2-1  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Re-enabled SSAPRE (two commits, I was just dumb).

2005-2-1  Massimiliano Mantione  <massi@ximian.com>

	* ssapre.c: Fixed an issue with down safety (this allows IronPython
	to succesfully execute parrotbench).
	* ssapre.h: Likewise.

2005-2-1  Massimiliano Mantione  <massi@ximian.com>

	* ssa.c: In mono_ssa_rename_vars, forced the creation of a new SSA
	variable for stores to method arguments (fixes a SSAPRE issue).

Tue Feb 1 15:52:26 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle value types in dup, fixes gen-112.cs.

Tue Feb 1 11:45:19 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md, tramp-ppc.c: use a slower code
	sequence for calls in dynamic methods to avoid thunks.

Tue Feb 1 11:44:01 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: correctly remove dynamic methods from the hashtable.

2005-1-20  Massimiliano Mantione  <massi@ximian.com>

	* driver.c: Disabled SSAPRE until fix the bug that appears
	in IronPython's parrotbench.

2005-01-31  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Get rid of Skip (other) messages.

	* mini.c (mono_method_to_ir): Revert the previous change.
	
	* mini.c (mono_method_to_ir): Do not inline ldfld and stfld wrappers
	when AOT compiling.

	* tramp-x86.c (x86_magic_trampoline): Avoid calls to 
	mono_jit_info_table_find () etc. when running under valgrind.

	* inssel.brg: Fix warnings.

	* mini-exceptions.c: Fix warnings.

2005-01-31  Martin Baulig  <martin@ximian.com>

	* driver.c (compile_all_methods_thread_main): Don't try to compile
	generic methods or anything which has type parameters.

2005-01-30  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Avoid costly calls to mono_method_full_name in tracing code and fix memory leaks.

	* TestDriver.cs: Add --verbose flags.

	* graph.c ssa.c: Fix 64 bit warnings.
	
	* abcremoval.h ssapre.h abcremoval.c ssapre.c mini.c tramp-amd64.c 
	trace.c mini-exceptions.c linear-scan.c inssel-amd64.brg inssel.brg:
	Fix 64 bit warnings.

	* mini-amd64.c (mono_arch_output_basic_block): Fix uninitialized
	variable not spotted by gcc.
	
	* mini-amd64.c inssel-amd64.brg: Applied patch from  
	Willibald Krenn <Willibald.Krenn@gmx.at>. Clean up usage of 
	X86_COMPARE_MEMBASE opcodes.

	* exceptions-amd64.c (mono_arch_find_jit_info): Fix AMD64 build.

2005-01-29  Ben Maurer  <bmaurer@ximian.com>

	* *: MonoMethod->signature might be NULL now. You *MUST* use
        mono_method_signature.

2005-01-28  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c (compile_all_methods_thread_main): Compile the methods
	without invoking cctors.

Fri Jan 28 18:28:26 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: remove ben's "optimizations" to dup+stloc (bug #71905).
	* basic-calls.cs: test for the above.

2005-01-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c mini-exceptions.c aot.c exceptions-*.c: Update after 
	MonoJitInfo changes.

2005-01-27  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_handle_exception): Compute the stack trace
	eagerly if it contains dynamic methods.
	
	* mini-exceptions.c (ves_icall_System_Exception_get_trace): New icall.

	* mini-exceptions.c (mono_handle_exception): Avoid computing the stack
	trace, it is now computed by an icall from trace_ips.
	
	* mini-exceptions.c: Fix a warning.

Thu Jan 27 13:38:34 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c: don't bother getting stack trace info if
	it's not going to be used.

2005-01-27  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (common_sources): Add ssapre-cee-ops.h and
	ssapre-mini-ops.h.

2005-01-26  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (remove_block_if_useless): Only print debug stuff with -v -v.

	* aot.c: Avoid calling mono_method_get_header () if not needed.

	* mini.h: Bump AOT file format version.
	
	* mini.c (mono_emit_native_call): Allocate a GOT var here.

	* mini.c (mono_print_tree): Print more info for calls.

2005-01-26  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.h: Remove warning by adding missing include for marshal.h

2005-01-26  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_UNBOX_ANY, don't increase
	`ip' twice.

2005-01-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_call_opcode): Add missing MONO_SSA_LOAD/STORE
	flags.

	* ssa.c (mono_ssa_compute): Fix crashes when using AOT.

	* aot.c (mono_compile_assembly): Fix a warning.

2005-01-25  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Look for security attributes on the original MonoMethod 
	(and not the wrapped one). This fix permissions on icalls.

2005-01-23  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_allocate_vars): Use mono_allocate_stack_slots ().

	* mini.c (mono_allocate_stack_slots): Add a fixme.

	* mini-x86.c (mono_arch_allocate_vars): Use mono_allocate_stack_slots ().

Sun Jan 23 16:16:48 CET 2005 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: optimize casts of sealed types (more
	optimizations waiting for fixes in remoting).

2005-01-23  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg (stmt): Add another dummy rule.

	* driver.c: Fix warnings.

	* driver.c (mono_main): If running under valgrind, instruct glib to use
	the system allocation functions so valgrind can track the memory
	allocated by the g_... functions.

	* inssel.brg (stmt): Add DUMMY rule for OP_DUMMY_STORE.

	* mini-ops.h: Add OP_DUMMY_STORE opcode.

	* mini.h (MONO_BBLOCK_IS_IN_REGION): New helper macro.

	* liveness.c: Handle OP_DUMMY_STORE. Enable register allocation for
	variables in try regions.

	* mini.c (mini_method_compile): Don't disable optimizations on large
	methods when AOT compiling.

	* mini.c (mono_allocate_stack_slots): New arch independent method to 
	allocate stack slots. Not yet used.

2005-01-22  Ben Maurer  <bmaurer@ximian.com>

	* debug-mini.c (mono_debug_close_method): Plug some leaks.

Sat Jan 22 13:41:51 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: make the branch info relative as the code
	buffer can be reallocated.

2005-01-22  Sebastien Pouliot  <sebastien@ximian.com>

	* aot.c: Allow decoding of the new  MONO_PATCH_INFO_DECLSEC.
	* driver.c: Removed the AOT/security restriction. Now initialize the
	security manager (in metadata) if --security is used.
	* mini.c|h: Add the MONO_PATCH_INFO_DECLSEC code to use the index,
	rather than the pointer to declarative security, when AOT is used.

Sat Jan 22 09:35:19 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-ppc.h, mini-ppc.c: updated to use out of line
	basic blocks, reduced intrinsic exception throwing code size.

2005-01-22  Miguel de Icaza  <miguel@ximian.com>

	* driver.c (mini_usage): Reorder the usage screen.

2005-01-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_resolve_patch_target): Fix warning.

2005-01-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_local_regalloc): Fix bug introduced by
	previous patch.

	* mini-amd64.c (mono_arch_local_regalloc): Ditto.	

	* mini-amd64.c (mono_arch_local_regalloc): Revert last patch as it
	breaks the amd64 build.

	* mini-x86.c (mono_arch_local_regalloc): Fix bug in div/rem 
	register allocation. Fixes #71454.

	* mini-amd64.c (mono_arch_local_regalloc): Ditto.	

	* arrays.cs: Add new regression test.	

2005-1-20  Massimiliano Mantione  <massi@ximian.com>

	* ssapre.c: Turned usage of snprintf to GString.
	* ssapre.h: disabled MONO_APPLY_SSAPRE_TO_SINGLE_METHOD
	(I left it on by mistake in my previous commit).

Thu Jan 20 12:00:45 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c, cfold.c, basic-calls.cs: preserve side effects
	on cond branch optimization (fixes bug# 71515).

2005-1-20  Massimiliano Mantione  <massi@ximian.com>

	* abcremoval.c: Fixed bug 71062.
	* abcremoval.h: Likewise.

2005-1-20  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added a new functionality to optimize_branches, the removal
	of useless basic blocks, and fixed some problem in the removal of
	critical edges; some utility functions added for both purposes.
	* ssapre.c: Added complex expression support, and fixed bug 70637.
	* ssapre.h: Likewise.
	* ssapre-cee-ops.h: Added file with list of "CEE_*" opcodes
	enabled in SSAPRE.
	* ssapre-mini-ops.h: Likewise, but for "OP_*" opcodes.
	* driver.c: Re-enabled SSAPRE.

2005-01-19  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): Call mono_get_inflated_method() on
	the result of mono_get_method_constrained().

2005-01-18  Neale Ferguson <NealeFerguson@earthlink.net>

	* exceptions-s390.c tramp-s390.c: Allocate code using the global code
	manager.

2005-01-18  Geoff Norton  <gnorton@customerdna.com>

	* jit-icalls.c (mono_llmult_ovf): Fix other overflow conditions to
	be detected.  Fixes #59296.

2005-01-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Remove some assertions
	which can happen. Fixes #71361.

2005-01-18  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-sparc.c tramp-sparc.c: Allocate code using the global code
	manager.

2005-01-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_create_jump_trampoline): Revert last change as it causes
	appdomain-unload.exe to fail.
	
	* mini.c: Fix some memory leaks.

Mon Jan 17 16:16:23 CET 2005 Paolo Molaro <lupus@ximian.com>

	* inssel.brg: handle the new size of rank, idepth, max_interface_id.
	Fixed bug and sped up some codepaths.

2005-01-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Fix some memory leaks.

	* exceptions.cs basic-long.cs: Add test for checked ulong->int 
	conversion.

	* inssel-long.brg: Implement long_conv_to_ovf_i4_un. Fixes #71319.

	* inssel-long.brg: Fix conv.ovf.i8 when run on an int32. Fixes
	#71320.

	* iltests.il: Add regression test for #71320.

2005-01-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_codegen): Fix installation of profiler hooks.

	* mini-sparc.c mini-amd64.c: Don't allocate stack space for dead vars.

Sun Jan 16 12:19:35 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini.c, cfold.c: optimize access to enum
	readonly fields, too. Eval conditional branches if possible
	to perform unreachable code removal in more cases.

2005-01-15  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c exceptions-amd64.c: Use the new global code manager.

	* mini.c (mono_global_codeman_reserve): New function to allocate code memory from a global
	code manager.

	* tramp-x86.c mini-x86.c exceptions-x86.c: Allocate all code memory so mono works with
	WinXP DEP. Fixes #71244.

2005-01-14  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg: Allways convert CEE_CONV_OVF_I4 to a move on 64 bit platforms. Fixes #71236.

2005-01-13  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_output_basic_block): Fix OP_ATOMIC_ADD_NEW_I4.

2005-01-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c exceptions-ppc.c aot.c: Cope with MonoJitInfo 
	changes.

	* mini.h: Bump AOT version.

	* mini.h (MonoCompile): Change exvar to a hash table.

	* mini.c: Allocate a separate exvar for each handler block.

	* mini.c: Get rid of the computation of filter_lengths, its not needed.

	* mini.c inssel.brg: Change OP_THROW_OR_NULL to compare the current
	ex var with the pending exception and only throw if the two are equal.
	Fixes #68552.
	
	* exceptions.cs: Add tests for rethrow and nested catch clauses.

	* mini-x86.c: Fix warnings.

	* Makefile.am (common_sources): Move mini-exceptions.c here as it is
	used by all the ports now.

	* aot.c: Add write-symbols and save-temps options.

2005-01-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c: Add support for returning structs in registers from pinvoke functions on WIN32.

Mon Jan 10 16:11:16 EST 2005 Neale Ferguson <nealeferguson@earthlink.net>

	* mini-ops.h, inssel-s390.brg, cpu-s390.md: Support OP_ATOMIC__xxx 
	operations.

	* tramp-s390.c: Check vtable slot belongs to the domain.

	* mini-exceptions.c, exceptions-s390.c: Standardize exception handling
	as per other platforms.

	* mini-s390.c, mini-s390.h: Enable out-of-line bblock support.

Mon Jan 10 18:53:05 CET 2005 Paolo Molaro <lupus@ximian.com>

	* driver.c: we don't run the Main() code in a subthread anymore.

Mon Jan 10 17:54:16 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: added experimental rtc support in the statistical
	profiler: if the user has the permission, more accurate statistics
	are gathered. Run with: MONO_RTC=4096 mono --profiler=default:stat ....
	The MONO_RTC value must be restricted to what the linux rtc allows:
	power of two from 64 to 8192 Hz.

2005-01-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_emit_exceptions): Fix #71121.

Mon Jan 10 05:20:49 EST 2005 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: better icache flush for smp.

2005-01-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (emit_move_return_value): Fix memory leak.

	* mini-x86.c (get_call_info): Add the get_call_info () code from the
	amd64 port, not yet used.

2005-01-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Disable inlining of ldfld wrappers with
	a struct type.

2005-01-07  Sebastien Pouliot  <sebastien@ximian.com>

	* driver.c: Added --security option to activate the security manager.
	Right now this will allow code generation for declarative demands and
	is disabled when AOT is specified.
	* mini.c: Add code generation for declarative security demands.
	* mini.h: Add mono_use_security_manager as an extern gboolean.

2005-01-07  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Speed up compilation a bit by
	emitting more dense assembly code.

	* mini-sparc.c mini-sparc.h exceptions-sparc.c: Enable optimized corlib
	exception throwing stuff.

2005-01-06  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_emit_exceptions): Fix typo in previous patch. Remove
	dead code.

	* mini-amd64.c (mono_arch_emit_exceptions): Remove duplicate epilog stuff
	left in by mistake.

	* driver.c (EXCLUDED_FROM_ALL): Disable SSAPRE until bug #70637 is 
	fixed.

	* mini-sparc.h mini-sparc.c: Enable out-of-line bblock support.

	* tramp-*.c: Only patch vtable slots if the object is in the current
	domain. Fixes appdomain-unload.exe.

	* mini-amd64.c mini-amd64.h: Enable out-of-line bblock support.
	
	* mini-amd64.c (mono_arch_local_regalloc): Port regalloc fix from
	x86 branch.

2005-01-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (reverse_branch_op): New helper function.

	* mini.c (optimize_branches): Run the new optimization only on 
	platforms which support it. Also reverse all kinds of branches.

	* mini.h (MonoBasicBlock): Add 'out_of_line' field.

	* mini.c (mono_method_to_ir): Set 'out_of_line' for bblocks which have
	a throw statement.

	* mini.c (optimize_branches): Reverse not-equals branches if the false
	bblock is a throw. This happens a lot of time with argument checking in
	corlib.

	* mini.c (mono_codegen): Add support for placing basic blocks after
	the function epilogue.

	* mini-x86.c mini-x86.h: Add support for placing basic blocks after the
	function epilogue.
	
2005-01-05  Miguel de Icaza  <miguel@ximian.com>

	* mini.c (setup_stat_profiler): Only set this up if the platform
	supports ITIMER_PROF.

2005-01-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_local_regalloc): Fix a bug introduced by the
	previous patch.

	* inssel.brg: Fix a warning.

Wed Jan 5 16:40:18 CET 2005 Paolo Molaro <lupus@ximian.com>

	* mini.c: added support for statistical profiler 
	(run with: --profile=default:stat).

2005-01-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.h (MONO_ARCH_ENABLE_EMIT_STATE_OPT): Enable this on x86.

	* mini-x86.c cpu-pentium.md: More fixes for usage of global registers.

	* mini-amd64.c (mono_arch_local_regalloc): Port some regalloc fixes 
	related to global registers from the amd64 port.

2005-01-03  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Handle MONO_CLASSCONST.

	* mini-amd64.c (mono_arch_local_regalloc): Fix some regalloc problems
	with global registers.
	(mono_arch_output_basic_block): Fix SWITCH in the AOT case.

	* aot.c (emit_method_code): Fix the 'method emitted as' messages.

2004-12-31  Zoltan Varga  <vargaz@freemail.hu>

	* debug-mini.c (encode_value): Fix off-by-one.

	* aot.c (encode_value): Likewise.

	* mini.c (mono_method_to_ir): Disable AOT for methods containing LDPTR.

2004-12-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c linear-scan.c: Add a workaround for the mcs crash when using 
	AOT.

	* aot.c (mono_aot_load_method): Free up patch info if no longer needed.
	
	* aot.c (emit_method_info): Increase size of temp buffer.

	* mini-x86.c cpu-pentium.md mini.c: Load fp constants differently in 
	the AOT case.

2004-12-28  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (emit_method_info): Fix build.
	
	* aot.c: Further rework of the AOT file format to reduce the size of
	the method info data.

	* mini.h: Bump AOT file format version.

2004-12-27  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_get_method): New static method; call
	mono_get_method_full() and mono_get_inflated_method().
	(mono_method_to_ir): Use mini_get_method() instead of
	mono_get_method_full().	

2004-12-26  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini-x86.c (atomic ops): fixed bug interlocked bug #70784. 

2004-12-25  Zoltan Varga  <vargaz@freemail.hu>

	* inssel.brg (ldind_to_load_membase): Handle CEE_LDIND_I8.

	* inssel-amd64.brg: Add some optimization rules.

2004-12-24  Ben Maurer  <bmaurer@ximian.com>

	* aot.c: Remove the use of MonoGHashTable and other GC stuff. The
	standard not GC'd stuff is fine.

2004-12-24  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Rework the AOT file format to get rid of most of the global
	symbols. This reduces the size of the mscorlib.dll.so by 1MB.

	* mini.h: Bump AOT file format version.
	
2004-12-23  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h: Bump AOT file format version.

	* aot.c (mono_aot_is_got_entry): New function to determine if an 
	address is inside a GOT.

	* aot.c mini-x86.c tramp-x86.c: Make all patches use the GOT.

	* cpu-pentium.md: Increase the maximum size of some instructions which
	might involve a got access.
	
	* mini.c (get_method_from_ip): Another debug helper function.

	* mini.c: Call mono_get_got_var () in a couple places. Handle the case
	when got var accesses are created during the decompose phase.

	* mini-sparc.c: Change mono_compile_aot to cfg->compile_aot.

	* mini.h mini.c mini-x86.c aot.c mini-sparc.c: Add a 'compile_corlib'
	argument mini_compile_method and to MonoCompile, and use this to
	determine whenever a given method is compiled for AOT. This allows the
	other methods compiled during AOT compilation to be free of AOT stuff,
	so the backends does not need to add special support for them by
	creating a fake GOT etc.

	* mini-x86.c (mono_arch_patch_code): Remove fake got stuff as it is no
	longer needed.

2004-12-21  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (mono_method_to_ir): It turns out that some of the
	x-appdomain wrappers are lax with types, so just ignore this for
	all wrappers.

	* inssel.brg (OP_CHECK_ARRAY_TYPE): Optimize this by only looking
	at the vtable->klass. If it is non-shared code we can just use the
	vtable.

Tue Dec 21 17:43:06 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: access MonoDomain from tls, too.

2004-12-21  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c: Removed unused variable (and related warning ;-)

2004-12-21  Ben Maurer  <bmaurer@ximian.com>

	* iltests.il: New test for LDELEMA on an array of ref types.

	* mini.c (CEE_LDELEMA): We need to emit OP_CHECK_ARRAY_TYPE for
	all ldelema's on reftypes.
	(check_call_signature): Remove the OP_CHECK_ARRAY_TYPE from here,
	it was the wrong place to put it.

	* mini-x86.c (mono_arch_output_basic_block): Just use ecx as the
	register to pop to make this cleaner, at the request of Paolo.

2004-12-20  Ben Maurer  <bmaurer@ximian.com>

	* mini-ops.h (OP_GETHASHCODE): New op.

	* inssel.brg (OP_GETHASHCODE): Emit code for the new opcode

	* mini.c (mini_get_inst_for_method): Create the intrinsic hash
	operation.

	For a microbenchmark, this reduces the cost of Hashtable.get_Item
	by 25%.
	
	* mini-x86.c (mono_arch_output_basic_block): Rather than

	add ebp, 4

	Emit

	pop edx

	The first is 3 bytes while the second is 1. This saves 36 kb on
	mscorlib, quite a big saving. When bootstraping mcs, I was able to
	see a small boost because of icache locality.

	* cfold.c (FOLD_BINOPCOMM): Kill add foo, 0

Mon Dec 20 12:19:40 EST 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am, mini-ppc.h, mini-exceptions.c, exceptions-ppc.c:
	started code sharing with the generic code.

Mon Dec 20 11:08:06 EST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: added code for direct access to
	tls data slots.

Mon Dec 20 10:58:28 EST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, inssel-x86.brg, cpu-amd64.md, inssel.brg, inssel-amd64.brg,
	 mini-amd64.c, mini-x86.c, cpu-pentium.md: renamed OP_X86_TLS_GET
	to OP_TLS_GET.

2004-12-20  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c|h: Added functions to cache the declarative stack modifiers
	in MonoJitInfo and to create a security frame from a MonoJitInfo 
	structure.
	* mini.c: Initialize jinfo->cas_inited to FALSE when MonoJitInfo is
	created. Register internal calls for System.Security.SecurityFrame::
	_GetSecurityFrame and _GetSecurityStack.
	* mini.h: Added definition for new icalls (in mini-exceptions.c) and
	the definitions for the new stack walk/callback mechanism.
	* mini-exceptions.c: Added internal call GetSecurityFrame (to get the 
	first security frame for LinkDemands and InheritanceDemands) and
	GetSecurityStack for Demands. Both use the new mono_walk_stack code
	from lupus.
	* mini-x86.h, mini-amd64.h, mini-sparc.h: Architecture specific stack
	walk initialization (lupus).

2004-12-20  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_DUP, handle the dup / stloc
	idiom.
	(handle_loaded_temps): Do not create a temporary variable for
	things that we know are temps. They will never be modified.
	(mono_spill_call): Set MONO_INST_IS_TEMP
	(mono_emulate_opcode): ditto
	(emit_tree): ditto
	(mono_method_to_ir.CEE_DUP): ditto

2004-12-19  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (type_to_eval_stack_type): Make this handle the void type
	(mono_emit_call_args): set the call->type with type_to_eval_stack_type
	(emit_tree): use ip_in_bb to special case some common idioms
	Update all callers to pass in the IP.
	(mono_method_to_ir): Make CEE_CALL* do the above as well.

	This gives us a nice 2% speedup in mcs bootstrap.

	* mini-x86.c (peephole_pass): Peephole pass to make
	mov  [foo], eax
	push [foo]

	into

	mov [foo], eax
	push eax

	* mini.c (ip_in_bb): new method.
	(mono_method_to_ir): use this method rather than doing the hash
	lookup ourselves.

	* linear-scan.c (mono_linear_scan): When expiring actives, you
	don't need to keep around variables that expire on this
	instruction. This makes it so that:
	     a = b + 1
	will turn into:
	     store (ebx add (ebx, 1))
	which will become
	     add ebx, 1

2004-12-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Optimize the common ldobj+stloc 
	combination to avoid doing two copies. Fix up problems with previous
	patch.

	* mini.c: Fix 64 bit warnings.

	* mini-x86.c (INST_IGNORES_CFLAGS): Add OP_STOREI4_MEMBASE_REG.

2004-12-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h mini-amd64.c exceptions-amd64.c: Port exception handling
	changes from the x86 code.

	* mini.h: Add prototype for mono_arch_get_throw_corlib_exception ().

2004-12-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_emit_epilog): Optimize the corlib exception
	throwing code to reduce its size, unify the AOT and non-aot code and 
	get rid of relocations in the AOT case.

	* mini-x86.h mini.c exceptions-x86.c 
	(mono_arch_get_throw_corlib_exception): New arch specific function to 
	raise corlib exceptions which doesn't require relocations in the 
	caller.

	* aot.c (emit_method): Handle PATCH_INFO_NONE as well.

2004-12-15  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_emit_method_call): Only allocate the got var when it is
	needed.

	* mini-x86.c (mono_arch_patch_code): Add missing PATCH_INFO_METHOD_REL
	in the AOT case.

2004-12-14  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini-x86.c, cpu-pentium.md, inssel-x86.brg: Fixed bug
	with add function when used from Inc/dec atomic 
	functions. Re-enabled optimization on x86.
	* mini-ops.h: renamed atomic_add functions to
	allow _add to match the Interlocked::Add and
	_add_next to match Interlocked::Inc/Dec.

2004-12-15  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Fixed a subtle bug in mono_method_to_ir, about the
	linking of BBs to the end BB, and enabled SSAPRE also with
	consprop and copyprop (which was prevented by that bug).

2004-12-14  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini-x86.c: disabling the Interlocked optimizing code. 

2004-12-14  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (load_aot_module): Move reading of got_addr after the AOT
	file version check.
	
2004-12-14  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini-x86.c, inssel-x86.brg, cpu-pentium.md: removed _imm 
	interlocked optimization due lack of support on x86, rewrote 
	exchange to take into account that base may be in eax.
	
	xsp works again; activated Interlocked optimizing code.
	
2004-12-14  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h (MONO_AOT_FILE_VERSION): Bump AOT file version.

2004-12-13  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ops.h: Add new opcodes.

	* mini.h: Add new patch types. Add got_var to MonoCompile.

	* mini.h mini-x86.c mini-amd64.c aot.c: Rename 
	mono_arch_get_aot_patch_offset () to mono_arch_get_patch_offset () and
	make it work with all kinds of patchable code.

	* inssel.brg inssel-x86.brg: Add new rules dealing with computing the
	address of the GOT, and referencing entries in the GOT.

	* mini.c: Add code to load the GOT address if needed by an opcode.

	* aot.c mini-x86.h mini-x86.c cpu-pentium.md: Add support for position 
	independent AOT code on the x86 using an elf-style Global Offset Table.

2004-12-14  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (RUNTIME): Set MONO_SHARED_DIR.

2004-12-13 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini-x86.c: disabling the Interlocked optimizing code. It segfaults
	when running xsp.

2004-12-13  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini-x86.c,mini-ops.h,inssel-x86.brg,cpu-pentium.md: Implementation
	of Interlocked:Increment/Decrement/Add as inline ops.
	(mini-x86.c (mono_arch_get_inst_for_method and mono_arch_output_basic_block))

2004-12-12  Geoff Norton  <gnorton@customerdna.com>

	* exceptions-ppc.c: Reorder code so gcc3.4 can compile it
	* mini-ppc.c: Unify mono_arch_patch_code with changes in r37636.

2004-12-12  Duncan Mak  <duncan@ximian.com>

	* mini-ppc.c (mono_arch_patch_code): Hopefully made this build
	again. `patch_info->table_size' is no longer valid after Zoltan's
	commit #37636.

2004-12-12  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): Only call mono_debug_init_method()
	if we are the "real" method, ie. not an inlined method inside it.

2004-12-11  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (CEE_LDSFLD): Make sure that the vtable has been init'd
	before we look in the special fields table. This fixes
	../tests/thread-static-init.cs.

2004-12-11 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: return immediately after setting OP_ARRAY_RANK or CEE_LDLEN
	for Array get_Rank and get_Length. Fixes bug #70465.

2004-12-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c aot.c: Put the bblock table for a SWITCH patch into a
	separate structure to reduce the size of MonoJumpInfo.

Fri Dec 10 18:09:22 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, aot.c, driver.c: allow disabling the aot code.

2004-12-10  Patrik Torstensson  <patrik.torstensson@gmail.com>

	* mini.c (mini_get_inst_for_method): Changed to allow ports
	to return a MonoInst instead of opcode 
	(renamed mini_get_opcode_for_method to better reflect the new functionality)
	
	* mini-[x86|s390|s390x|ppc|sparc].c (mono_arch_get_inst_for_method): 
	Allow ports to return a created MonoInst instead of op-code, will enable
	new optimizations.
	(renamed mini_get_opcode_for_method to better reflected the functionality)

2004-12-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (NEW_AOTCONST): Share some code between the different NEW_AOTCONST macros.

2004-12-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c jit-icalls.c: Pass generic_context to mono_ldtoken_wrapper.
	Fixes #69985.

2004-12-08  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_CALLVIRT, use `fsig->signature'
	if we're a CEE_CONSTRAINED call.  Fixes gen-118.cs.

2004-12-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_output_basic_block): Implement OP_FCONV_TO_<X>
	correctly.

	* exceptions.cs: Disable some tests which depend on properties of x86 fp
	arithmetic.

2004-12-08  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (CLEANFILES): Add *.exe, *.dll.

2004-12-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_output_basic_block): Fix LOCALLOC_IMM
	bug introduced by the previous patch.

Tue Dec 7 11:44:39 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, objectc.cs: handle large structs passed by value
	(fixes bug #69972).

Tue Dec 7 10:43:31 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: OP_ARGLIST implementation from
	Geoff Norton  <gnorton@customerdna.com>.

Tue Dec 7 10:14:25 CET 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-x86.brg, inssel-ppc.brg: fix reference to register
	in stmt: OP_OUTARG_VT (reg) (should fix bug #69785).

Tue Dec 7 10:06:39 CET 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: avoid calling ppc_patch in exception trampolines.

2004-12-01  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* inssel-s390.brgi, mini-ops.h, mini-s390.c : Add stubs for support of tls offset
	support.

2004-12-06  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c: Zero out localled-ed memory.

	* iltests.il: Add tests for zeroing out localloc-ed memory.

2004-12-04  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_CALLVIRT, use the new
	mono_method_get_signature_full().	

2004-12-03  Massimiliano Mantione  <massi@ximian.com>

	* mini.c: Added removal of critical edges (prerequisite for SSAPRE),
	and some utility functions (always for SSAPRE), integrated SSAPRE.
	* mini.h: Likewise.
	* driver.c: Added ssapre option.
	* ssa.c: Small fix on OP_ARG handling.
	* ssapre.c, ssapre.h: Added files containing SSAPRE implementation.
	* Makefile.am: Likewise.

2004-12-02  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-x86.c (mono_arch_create_jit_trampoline): Remove code which is
	now in the xp code.

	* mini.c (mini_init): Register mono_thread_force_interruption_checkpoint
	icall.

2004-12-01  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* inssel-s390.brg : Add OP_OUTARG_VT (OP_REFANYTYPE (reg)) rule.
	
	* cpu-s390.md : Increase instruction length of oparglist.

	* mini-s390.c : Implement vararg and TYPEDEBYREF support.

2004-11-30  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_CALLVIRT, added support for
	virtual generic methods.  We call a special helper_compile_generic_method()
	icall to retrieve the method from the vtable, inflate and compile
	it and then do a CEE_CALLI.  Thanks a lot to Paolo for this idea.

	* jit-icalls.c (helper_compile_generic_method): New JIT icall.

2004-11-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c: Fix up vararg corner cases. Fixes #70019.

2004-11-29  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-sparc.md mini-sparc.c (long_conv_to_ovf_i): Fill missing delay slot.
	Fixes #69929.

2004-11-27  Ben Maurer  <bmaurer@ximian.com>

	* inssel.brg (CEE_SWITCH): The AOT stuff Zoltan added is only for
	platforms with PIC aot.

2004-11-28  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_DUP, added handle_stobj().
	Fixes gen-112.cs.

2004-11-28  Martin Baulig  <martin@ximian.com>

	* mini-x86.c (mono_arch_call_opcode): Use the original type, not
	the result of mono_type_get_underlying_type() to check whether
	we're byref.

2004-11-26  Martin Baulig  <martin@ximian.com>

	* mini.c
	(mono_method_to_ir): Use `!method->signature->has_type_parameters'
	in the g_assert().

2004-11-26  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_emit_this_vret_args): Handle this and vret
	the same way as the other arguments so they won't get clobbered.

	* mini-amd64.c (mono_arch_output_basic_block): Avoid doing virtual 
	calls through R11 since it is clobbered by the trampoline code.

2004-11-26  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am: Consistently use $(RUNTIME) rather than ./mono to
	pick up in-tree mscorlib.dll.

2004-11-25  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Rename MonoAOTModule->cleanup to out_of_date.

	* mini-amd64.c aot.c: Switch to PIC relative AOT code. References to 
	runtime data/code are now stored in a table similar to the GOT in ELF. 
	This allows the code itself to be position independent.

	* aot.c: Fix loading of referenced assemblies after the lazy assembly
	loading changes.

	* aot.c: Attach ELF type (object/function) directives to all global
	symbols.

	* tramp-amd64.c (amd64_magic_trampoline): Patch RIP relative calls too.

	* inssel.brg (SWITCH): Emit an AOT_CONST in the aot case.

	* mini-amd64.h: Turn on PIC AOT code.

	* mini.h (mono_arch_get_aot_patch_offset): New arch specific function
	returning the offset within an OP_AOTCONST instruction where the GOT
	offset needs to be added.

	* mini.h: Bump AOT file format version.

2004-11-25  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): In CEE_CALL, don't allow calling any
	uninflated generic methods.

2004-11-25  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): Don't allow any uninflated generic methods.

2004-11-24  Martin Baulig  <martin@ximian.com>

	* minit.c (type_to_eval_stack_type): Set `inst->klass' to the
	original klass (this only applies for generic instances).

2004-11-24  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): Use `STACK_OBJ' instead of
	`ldind_type [CEE_LDIND_REF]' (which would be beyond the end of
	that array).

2004-11-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Disable inlining for methods containing
	localloc. Fixes #69678.

	* iltests.il (test_0_localloc_inline): Add regression test for #69678.
	
2004-11-23  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Set %al to the number of
	used SSE registers on pinvoke calls. Fixes #69774.

2004-11-23  Geoff Norton  <gnorton@customerdna.com>

	* inssel-ppc.brg, mini-ppc.c: Use mono_class_from_mono_type instead of
	vt->inst_vtype->data.klass.  This fixes generic structs and bug #69766

2004-11-23  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (MCS,ILASM): Don't refer to runtime/ directory.
	Refer directly to the mcs/ tree.

2004-11-19  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* mini-s390.c, tramp-s390.c, mini-s390.h: Add LMF processing for trampolines.
	Check if a trampoline for a synchronized method is required. 

Fri Nov 19 17:34:21 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: set to zero the memory allocated
	with localloc if needed. Throe arithmetric exception in
	div an rem if needed. Implement ovf checks in OP_LCONV_TO_OVF_I.
	Adapted from a patch by Geoff Norton  <gnorton@customerdna.com>.

2004-11-19  Geoff Norton  <gnorton@customerdna.com>

	* mini-ppc.c: Call mono_type_get_underlying_type to unwrap generic
	types before switching on type.  Fixes #69622.

2004-11-19  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (check-local): New.  Integrate into 'make check'.
	(MCS,RUNTIME): Define using in-tree mono and mcs.
	(ILASM): New.
	(%.exe): Use $(ILASM).

Fri Nov 19 14:54:07 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: adjust initial prolog size (bug #69691).

2004-11-18  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-pentium.md (localloc): Increase max instruction len. Fixes
	#69664.

2004-11-17  Raja R Harinath  <rharinath@novell.com>

	* Makefile.am (clean-local): Rename from 'clean'.

2004-11-15  Nelae Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* mini.c, mini-x86.c, mini-amd64.c, exceptions-s390.c: Add siginfo_t parameter
	to mono_arch_is_int_overflow. 
	* exceptions-s390.c: Add mono_arch_is_int_overflow routine to discern between
	SIGFPE events.

2004-11-15  Sebastien Pouliot  <sebastien@ximian.com>

	* declsec.c|h: New files to support declarative security attributes.
	Added function to check if a method has (applicable) security.
	* mini.c|h: Add check for declarative security attributes in
	mono_method_check_inlining.
	* Makefile.am: Added declsec.c and declsec.h to the build.

Mon Nov 15 11:53:46 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h: update to keep dynamic code info per-domain.

2004-11-12  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c mini-*.h: Get rid of MONO_ARCH_HAVE_RETHROW since all architectures support it now.
	(mini_init): Get rid of it from here too.

Thu Nov 11 20:17:17 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-ppc,h, cpu-g5.md, exceptions-ppc.c:
	implemented OP_RETHROW (patch by Geoff Norton
	<gnorton@customerdna.com>).

2004-11-10  Geoff Norton  <gnorton@customerdna.com>

	* tramp-ppc.c (ppc_magic_trampoline): Don't trampoline methods
	between appdomains.  Fixes appdomain-unload on PPC.

2004-10-26  Lluis Sanchez Gual  <lluis@novell.com>

	* exceptions-ppc.c, exceptions-s390.c, exceptions-s390x.c,
	mini-exceptions.c: handle the new wrapper types.
	* mini.c: The CEE_ISINST and CEE_CASTCLASS opcodes now take the
	token value as a MonoClass* when compiling a wrapper.
	mono_jit_create_remoting_trampoline now takes an additional
	MonoRemotingTarget parameter.
	
2004-11-10  Martin Baulig  <martin@localhost>

	* mini.c (mono_method_to_ir): Use `generic_container->context'
	rather than creating a new one.

2004-11-09  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* exceptions-s390.c, mini-s390, cpu-s390.md: Add support for OP_RETHROW.

	* inssel-390.md, mini-s390.c: Correct register allocation for globals.

2004-11-09  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_aot_init): Add MONO_AOT_CACHE env variable to turn on
	the experimental aot cache stuff.

Tue Nov 9 17:30:20 CET 2004 Paolo Molaro <lupus@ximian.com>

	* aot.c, mini.c, exceptions-ppc.c, exceptions-s390.c, exceptions-s390x.c,
	mini-exceptions.c: update to exception clause structure changes.

2004-11-08  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-x86.c (throw_exception): Fix warnings.

	* mini-x86.h mini-x86.c cpu-pentium.md exceptions-x86.c: Add support 
	for OP_RETHROW.

2004-11-08  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-sparc.c (get_throw_exception): Really fix this.

2004-11-07  Ben Maurer  <bmaurer@ximian.com>

	* tramp-*.c: we no longer support icalls without wrappers, so
	a bit of code can be removed here

2004-11-07  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-sparc.c (get_throw_exception): Fix more bugs in previous
	patch.

	* cpu-sparc.md: Add op_rethrow.

	* exceptions-sparc.c (get_throw_exception): Fix bug in previous patch.

	* mini-sparc.h mini-sparc.c exceptions-sparc.c: Add support for OP_RETHROW.

	* mini.h: Add mono_arch_get_rethrow_exception () arch specific function.
	* mini-ops.h: Add OP_RETHROW.

	* mini.c inssel.brg: Distinguish between THROW and RETHROW.

	* cpu-amd64.c mini-amd64.c exceptions-amd64.c: Add support for OP_RETHROW.

2004-11-05  Geoff Norton  <gnorton@customerdna.com>
	
	* helpers.c: Change otool arguments from -V -v -t to -v -t on Darwin
	Makes the output much easier to read

2004-11-05  Ben Maurer  <bmaurer@ximian.com>

	* ssa.c: allocate MonoMethodVar.uses from the mempool. First, this
	prevents another huge leak when compiling with ssa. Secondly, the
	performance of doing this rather than freeing the lists is much
	better. GList does a lock every time you allocate a list link,
	so that it can use a memory pool. So, it is better to just use
	a memory pool of our own.
	
	* ssa.c, linear-scan.c: replace g_list_remove_link with
	g_list_delete.  The remove one does not free the GList, so we were
	leaking memory. On -O=all --compile-all with corlib, this cut down
	3 MB of allocations.

2004-11-05  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-sparc.c (mono_arch_create_jit_trampoline): Fix sparc build.

	* tramp-amd64.c (mono_arch_create_jit_trampoline): Fix amd64 build.

	* mini.h mini.c tramp-*.c: Moved xp parts of JIT trampoline creation
	into a new function mono_create_jit_trampoline ().

2004-11-02  Zoltan Varga  <vargaz@freemail.hu>

	* trace.c (get_spec): Allow tracing of classes without a namespace.

2004-11-02  Sebastien Pouliot  <sebastien@ximian.com>

	* mini.c: Fix pointer overwrite in mini_method_compile.

2004-11-2  Geoff Norton  <gnorton@customerdna.com>

	* inssel-ppc.brg (OP_OUTARG_VT (CEE_LDOBJ (base))):
	The darwin ABI needs some special handling for 1 and 2 byte structs
	Lets use lbz/lhz instead of lwz everywhere.
	* mini-ppc.c (calculate_sizes):  The Darwin ABI needs from special handling
	for 1 and 2 byte structs and struct which are size >= 3 || size % 4 != 0.
	Use stb/sth for the former, and put the latter always on stack instead of in
	argument registers.

2004-10-30  Zoltan Varga  <vargaz@freemail.hu>

	* trace.c (is_filenamechar): Add '_'.

2004-10-29  Neale Ferguson  <Neale.Ferguson@SoftwareAG-usa.com>

	* mini-s390.c: Fix prolog length to allow for large trace requirements.

	* exceptions-s390.c: Remove dwarf unwinding stuff that was unused.

2004-10-29  Zoltan Varga  <vargaz@freemail.hu>

	* Makefile.am (libgc_libs): Do some automake magic so libmono/mono
	depends on libmonogc. Fixes #68805.

2004-10-26  Miguel de Icaza  <miguel@ximian.com>

	* mini.c (mono_jit_free_method): Provide extra information for
	this error.  Currently this leaks, but will be turned into a
	developer option in the future.

2004-10-26  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c (mono_main): Applied patch from Willibald Krenn <willibald.krenn@gmx.at>. Make --graph work for icalls and pinvoke methods.

2004-10-25  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_aot_load_method): Align PATCH_INFO_R8 on an 8 byte 
	boundary. Fixes reading of PATCH_INFO_R4 and R8.
	(mono_aot_load_method): Do not allocate MonoAotMethod in the GC heap.

2004-10-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_patch_code): Fix patching of class init
	trampolines for AOT code.

2004-10-22    <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Disable AOT for methods containing calls to methods of
	constructed types. Fixes #68136.

2004-10-21  Martin Baulig  <martin@ximian.com>

	* exceptions-x86.c (throw_exception): Call mono_debugger_throw_exception();
	if it returns true, unwind the stack to the call instruction.

2004-10-21    <vargaz@freemail.hu>

	* aot.c: Reorganize the AOT file format to avoid relocations. Fix warnings.

	* mini.h: Bump AOT version number.

	* objects.cs: Add another test for unbox trampolines.

	* tramp-amd64.c (amd64_magic_trampoline): Disable patching of trampolines for 
	valuetype methods.

2004-10-20    <vargaz@freemail.hu>

	* driver.c: Add SHARED to the set of optimizations tested.

	* tramp-amd64.c (amd64_magic_trampoline): Patch trampoline code as well.

	* mini.c (mono_method_to_ir): Mark the domainvar as volatile when it is implicitly
	used by CEE_NEWARR.

	* ssa.c (mono_ssa_deadce): Do not optimize away accesses to volatile variables.

2004-10-20  Martin Baulig  <martin@ximian.com>

	* mini-exceptions.c (mono_handle_exception): Call
	mono_debugger_handle_exception() to tell the debugger about
	catch/finally clauses.

2004-10-18  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-amd64.c (mono_arch_find_jit_info): Pop arguments of the stack.

	* mini-amd64.c (mono_amd64_get_vcall_slot_addr): Handle extended registers. Fixes
	#68447.

2004-10-15  Geoff Norton  <gnorton@customerdna.com>

	* mini-ppc.c (calculate_sizes): Marshal valuetypes for pinvoke
	methods as their native size, fixed bug #57543, #57545.
	* mini-ppc.c (mono_arch_output_basic_block): Use mulli for imm16 types
	This saves a temporary register and mullw call down into 1 (minor perf
	increase for cases like sum = sum * 5;  This use to translate into:
	    li r11,5
	    mullw r28,r28,r11
	It now translates to
	    mulli r28,r28,5

2004-10-15  Zoltan Varga  <vargaz@freemail.hu>

	* trace.c (mono_trace_eval): Use mono_method_desc_full_match. Fixes
	#68388.

2004-10-11  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): If we're a generic method, get the
	MonoGenericContainer from our MonoMethodNormal and create a
	MonoGenericContext from it.

2004-10-08  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long32.brg (OP_LCONV_TO_OVF_I2): Fix CONV_I1 -> CONV_I2.

	* basic-long.cs: Add test for checked i8->i2 cast.

Wed Oct 6 12:40:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-ppc.brg: added a couple of speedup rules.

2004-10-05  Zoltan Varga  <vargaz@freemail.hu>

	* Makefile.am (genmdesc_LDADD): Don't link this against libmetadata
	to speed up rebuilds.

2004-10-04  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* mini-s390.c: Minor fix to OP_OR_IMM.

2004-10-03  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-sparc.c (sparc_magic_trampoline): Handle appdomain stuff
	better. Fixes appdomain-unload.exe on sparc.

2004-10-02  Massimiliano Mantione  <massi@ximian.com>

	* ssa.c: Fixed casts to unsigned where the value was of 64 bits in
	simulate_long_compare, patch by will@exomi.com (Ville-Pertti Keinonen),
	see bug 67324.

2004-10-02  Zoltan Varga  <vargaz@freemail.hu>

	* jit-icalls.c: Handle a nonexisting trunc function more correctly.

2004-09-30  Lluis Sanchez Gual  <lluis@novell.com>

	* mini.c: Always generate a field read/write wrapper for members
	of the class MarshalByRefObject since the actual instance could
	be a CBO.

2004-09-28  Lluis Sanchez Gual  <lluis@novell.com>

	* mini.c: Use mono_thread_exit() to stop threads, instead of ExitThread.

2004-09-28  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c mini.h trace.c: Move the setting of the main assembly into
	a separate function called mono_trace_set_assembly () and call it after
	actually loading the main assembly. Fixes #66872.

2004-09-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h mini-amd64.c tramp-amd64.c: Allocate trampoline memory
	using the code manager.

2004-09-24  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c mini-amd64.h: Add support for MONO_ARCH_HAVE_INVALIDATE_METHOD.

2004-09-23  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Fix bug in previous patch.
	
	* cpu-amd64.md: Fix instruction lengths of membase opcodes. Fixes
	#66650.

Wed Sep 22 19:03:20 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.h, exceptions-ppc.c, exceptions-s390.c, exceptions-s390x.c,
	mini-exceptions.c: updates for changed stack walk interface.

2004-09-21  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* mini-s390.c, cpu-s390.md: Minor changes to OP_ARGLIST handling

2004-09-17  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Fix LDSTR in dynamic methods. Fixes #66132.

2004-09-13  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c (mini_regression_list): Do not call mono_assembly_close 
	since assemblies can't be unloaded.
	
2004-09-11  Zoltan Varga  <vargaz@freemail.hu>

	* cpu-amd64.md: Fix more instruction lengths.

	* cpu-amd64.md: Fix lengths of some instructions.

2004-09-11 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel.brg: Make the array ldelema check aot friendly.

2004-09-11  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_get_argument_info): Fix stack_unwind test.

	* cpu-amd64.md inssel-long.brg inssel-amd64.brg: Small optimizations.

2004-09-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c: Fix build.

	* mini-sparc.c mini-x86.c mini-amd64.c: Use the new 
	mono_type_get_underlying_type () helper function to simplify code.
	
2004-09-09  Martin Baulig  <martin@ximian.com>

	* mini-amd64.c: Don't access `type->data.klass' directly, call
	mono_class_from_mono_type() instead since the type may be a
	generic instance.

2004-09-09  Martin Baulig  <martin@ximian.com>

	* mini-amd64.c (get_call_info): Fix support for generic instances.
	(add_valuetype): Use mono_class_from_mono_type() to get the class
	since we can be a generic instance.

Thu Sep 9 01:43:53 PDT 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini.h, regalloc.c, regalloc.h: powerpc speedups.

2004-09-07 Ben Maurer  <bmaurer@users.sourceforge.net>

	* liveness.c: reset spill costs on each scan: bug 62107

2004-09-07  Bernie Solomon  <bernard@ugsolutions.com>

	* exceptions-sparc.c (mono_arch_find_jit_info): remove
	unnecessary line that doesn't compile

2004-09-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c mini.h mini-x86.h tramp-x86.c: Instead of freeing delegate
	trampolines, make them call an error function so people can fix their
	code.

2004-09-06  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): When initializing locals, handle a
	generic instances like a valuetype if it's a valuetype and like a
	class if it's a class.

2004-09-06  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-x86.c (mono_arch_find_jit_info): Pop arguments off the
	stack. Fixes #64674.

	* exceptions.cs: Add test for unwinding of call arguments.

Mon Sep 6 05:50:02 PDT 2004 Paolo Molaro <lupus@ximian.com>

	* mini-*.c, mini-ops.h, inssel-long32.brg: introduced
	OP_ADDCC_IMM and OP_SUBCC_IMM (add/sub immediate that will
	set the carry/borrow flag). The sparc and s390 implementations
	can now use optimized versions (and simplify the code). ppc bugfixes.

2004-09-06  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-ppc.c (mono_arch_find_jit_info): Fix memory leak.

2004-09-05  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-amd64.brg: Remove leftover 32 bit rule.

	* mini-amd64.c (mono_arch_instrument_prolog): Fix tracing support.

2004-09-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (mono_find_jit_info): Refactor common code from
	mono_arch_find_jit_info functions into a new function. Fix a memory
	leak.

	* exceptions-x86.c exceptions-amd64.c exceptions-sparc.c: Remove
	refactored code.
	
2004-09-02  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs inssel-long32.brg: Handle the OP_LCONV_TO_OVF_I2 case
	as well.
	
	* exceptions.cs: Add array size tests.

	* mini.c: Allocate a separate icall wrapper for each arity of 
	mono_array_new_va. Fixes #59509.

	* exceptions.cs: Add testcase for 64578.

	* inssel-long32.brg: Fix OP_LCONV_TO_OVF_I1 rule. Fixes #64578.

	* trace.c (is_filenamechar): Allow 0..9 in strings. Fixes #65094.
	
2004-09-02  Martin Baulig  <martin@ximian.com>

	* mini.c (mono_method_to_ir): When initializing the locals, call
	handle_initobj() on the generic instance itself, not its
	underlying type.

2004-09-02  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h (MonoJitDynamicMethodInfo): New structure, extension of 
	MonoJitInfo for dynamic methods.

	* mini.c: Rename trampoline_hash_mutex to jit_mutex.

	* mini.c: Add support for freeing JIT data for dynamic methods.
	
2004-09-01  Martin Baulig  <martin@ximian.com>

	* mini-x86.c (is_regsize_var): Added support for generic
	instances.
	(mono_arch_emit_prolog): Make this compile again, use
	`x86_push_imm_template (code)'.

2004-08-30 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini-x86.c: make all push_imm instructions that get
	patched always emit the long form

2004-08-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_create_jump_trampoline): Store the jump trampolines 
	in a per-domain hash.

	* mini-amd64.c (merge_argument_class_from_type): Handle generic
	types.

2004-08-29  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c cpu-amd64.md inssel-amd64.brg mini-amd64.h: Ongoing SSE
	work.
	
	* mini-amd64.c cpu-amd64.md inssel-amd64.brg mini-amd64.h: More SSE
	work.

	* mini-amd64.c cpu-amd64.md: Implement checked int<->uint casts.
	Beginnings of SSE2 support.

	* exceptions.cs: Add more tests for checked int<->uint casts.

2004-08-28  Martin Baulig  <martin@ximian.com>

	* mini-x86.c (mono_arch_instrument_epilog): Added support for
	generic instances.

	* mini.c
	(mono_type_to_ldind, mono_type_to_stind, type_to_eval_stack_type):
	Handle generic instances recursively.

2004-08-27 Ben Maurer  <bmaurer@users.sourceforge.net>

	* iltests.il: test for conv.u8 on a constant

2004-08-27 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel-long32.brg: c&p rules for LCONV_x4 (membase) and
	LCONV_x4 (shrun_32 (membase)).

2004-08-27 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel-x86.brg: c&p rules for push/setret of long

2004-08-26 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel-x86.brg: c&p rules for compare (base, regvar) and
	compare (regvar, base)

	* inssel-x86.brg: more burg love

	* inssel.brg: more cleanup

	* inssel-x86.brg, inssel-long32.brg: burg cleanup.

2004-08-26 Ben Maurer  <bmaurer@users.sourceforge.net>

	* basic-long.cs, basic-calls.cs: new tests for optimization.

2004-08-26  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (read_tls_offset_from_method): Fix typo in previous
	patch.

2004-08-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (read_tls_offset_from_method): Add another case.
	
2004-08-25  Bernie Solomon  <bernard@ugsolutions.com>

	* inssel.brg (mini_emit_memcpy): use 
	NO_UNALIGNED_ACCESS to disable memcpy optimization

2004-08-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c: Handle generic types in various places.

	* mini.c (mono_method_to_ir): Handle generic types in init locals.

2004-08-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (handle_box): Fix warning.

	* mini-amd64.c (mono_arch_local_regalloc): Fix regalloc problem.

	* mini-amd64.h: Enable the emit_state optimization.

	* mini-ops.h cpu-amd64.md: Add new amd64_test_null opcode.

	* mini-amd64.c: Add some new 64 bit peephole opts.

	* inssel.brg (mini_emit_memcpy): Optimize for 64 bit architectures.

	* cpu-amd64.md: sreg1 of div instructions must be %rax.

	* mini-amd64.c: Register allocator fixes.

	* mini.c: Add an optimization to emit_state to avoid allocation of new
	registers on some platforms.

2004-08-23  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-x86.brg inssel-amd64: Add yet another missing tree->dreg assignment.

	* mini-x86.c (mono_arch_local_regalloc): Fix bug in long register
	allocation. Fixes #63085.

	* basic-long.cs: Add new regression test.

	* mini-amd64.c: Register allocator improvements.

2004-08-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (read_tls_offset_from_method): Add another code
	sequence.

	* tramp-amd64.c (amd64_class_init_trampoline): Use a more efficient
	instruction sequence for nullifying class init trampolines.

	* objects.cs: Add new regalloc test.

	* mini-amd64.c inssel-amd64.brg: Optimize parameter passing.

2004-08-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_call_opcode): Refactor this a little.
	
	* mini-amd64.c (mono_arch_regalloc_cost): Adjust regalloc costs for
	arguments.

	* driver.c: Fix profiling after TLS changes.
	
	* driver.c (mono_main): Set mono_stats.enabled if needed.

	* mini.c (handle_alloc): New helper function used by CEE_NEWOBJ and
	CEE_BOX.

2004-08-20 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini-x86.c: use a 1 op rather than a 2 op tls access
	instruction -> faster.

2004-08-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c inssel-amd64.brg cpu-amd64.md: Merge changes from
	x86 backend.

2004-08-19 Bernie Solomon <bernard@ugsolutions.com>

	* exceptions-sparc.c (throw_exception): fix typo

2004-08-19 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini-x86.c, cpu-pentium.md, inssel-x86.brg:
	set tree->dreg correctly with tls. Allow any
	register to be used.

	* mini-x86.c (read_tls_offset_from_method): add new code
	generation pattern seen with GCC.


Thu Aug 19 17:26:55 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-exceptions.c, exceptions-x86.c, exceptions-amd64.c,
	exceptions-ppc.c, exceptions-s390.c, exceptions-s390x.c,
	exceptions-sparc.c: fix some performance issues in exception
	handling and setting of the stack trace for exceptions that were
	already thrown.

2004-08-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c inssel-amd64.brg cpu-amd64.md: Merge changes from 
	x86 backend.
	
	* mini-amd64.c (mono_arch_is_int_overflow): Handle all possible 
	registers.

2004-08-18 Ben Maurer  <bmaurer@users.sourceforge.net>

	This patch inlines tls access, when possible.
	
	* mini.h: new arch functions for TLS intrinsics.
	All platforms updated with a stub.

	* mini.c: use the new intrinsics

	* mini-x86.c, cpu-pentium.md, inssel-x86.brg, mini-ops.h:
	arch specific intrinsic for tls variables

2004-08-18  Zoltan Varga  <vargaz@freemail.hu>

	* Makefile.am (libmono_la_LDFLAGS): Enable creating of libmono dll
	under windows.

2004-08-17 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini.c: thread local allocation

2004-08-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.h (MONO_ARCH_NO_EMULATE_LONG_SHIFT_OPS): Enable.

	* Makefile.am: Link against the static version of libmonogc.
	
	* Makefile.am: Link the static versions of the convenience libraries
	into the mono executable.

	* mini-x86.h mini-x86.c: Throw the correct exception on integer overflow.

2004-08-15  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c mini-amd64.h mini-amd64.c: Throw the correct exception
	on integer overflow.

	* mini-amd64.c: Reorganize function call code.

	* mini-amd64.c (peephole_pass): Merge changes from mini-x86.c.

2004-08-14 Ben Maurer  <bmaurer@ximian.com>

	* inssel-x86.brg: use xor eax,eax.
	
	* basic.cs: new tests

2004-08-14  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_emit_epilog): Use RIP relative addressing
	in exception throwing code.
	
2004-08-14 Ben Maurer  <bmaurer@ximian.com>

	* inssel-x86.brg: use xor esi,esi.

2004-08-14  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c (mono_main): Call mono_trace_parse_options earlier so it
	can trace methods compiled during mini_init () too.

	* cpu-amd64.md mini-amd64.c (mono_arch_output_basic_block): Handle 
	CEE_CONV_U4.

2004-08-14 Ben Maurer  <bmaurer@ximian.com>

	* Makefile.am: static link on x86 (r=zoltan)

2004-08-14  Zoltan Varga  <vargaz@freemail.hu>

	* tramp-amd64.c (amd64_magic_trampoline): Avoid patching the trampoline
	code since it causes some programs to fail.

2004-08-12  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (bb_is_loop_start): Merge changes from mini-x86.c.

2004-08-11  Bernie Solomon <bernard@ugsolutions.com>

	* mini.c: ovfops_op_map - add STACK_OBJ case for
	CONV_I 
	* basic.cs: add test_0_pin_string as test
	case for above.

2004-08-11  Bernie Solomon <bernard@ugsolutions.com>

	* Makefile.am: build C# if srcdir != builddir

Tue Aug 10 19:23:47 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* dominators.c, mini.h, mini-x86.c: fix loop alignment with
	fall-through blocks.

Tue Aug 10 16:18:22 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* driver.c: enable loop by default again and include abcrem in -O=all.

2004-08-08  Zoltan Varga  <vargaz@freemail.hu>

	* iltests.il: Add some localloc tests.

	* mini.c (mono_method_to_ir): Set stack type of LOCALLOC correctly.

	* inssel-amd64.brg inssel-x86.brg: Set dreg of LOCALLOC correctly. 
	Fixes #62574.

	* inssel-amd64.brg: Add some optimizations.

	* mini-amd64.c (mono_arch_setup_jit_tls_data): Add tls offset detection
	for gcc-3.4.

	* Makefile.am: Statically link mono against libmono on AMD64.
	
	* mini-amd64.c inssel-amd64.brg: Optimizations.

2004-08-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_emit_prolog): Optimize lmf saving a bit.

	* tramp-amd64.c: Patch calling code in trampolines.

2004-08-06  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c: pinvoke struct passing fixes.

2004-08-05  Bernie Solomon  <bernard@ugsolutions.com>

	* mini-sparc.c: redo change, make mono_arch_cpu_init call
	mono_arch_cpu_optimizazions so sparcv9 is initialized when embedded

2004-08-05  Duncan Mak  <duncan@ximian.com>

	* mini.c: Renamed CEE_STELEM to CEE_STELEM_ANY and CEE_LDELEM to
	CEE_LDELEM_ANY.

2004-08-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (emit_move_return_value): Move return value for normal
	calls too.

2004-08-05  Martin Baulig  <martin@ximian.com>

	* mini.c (ret_type_to_call_opcode): Don't use a `t' variable for
	`type->type'; just modify `type' itself when dealing with enums
	and generic instances.
	(check_call_signature): Make `simple_type' a `MonoType *'.

2004-08-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Use OP_PADD to add offsets to addresses.

	* mini-amd64.h: Disable SIGSEGV_ON_ALTSTACK.

2004-08-04  Bernie Solomon  <bernard@ugsolutions.com>

	* mini-sparc.c (mono_arch_emit_epilog): fix check
	for folding last op into restore instruction

2004-08-05  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-amd64.c (mono_arch_get_throw_exception_by_name): Allocate
	helper methods using the code manager.
	
	* exceptions-amd64.c (mono_arch_get_throw_exception): Fix maximum length.

	* mini-amd64.c (mono_arch_allocate_vars): Fix tls offset detection.

Tue Aug 3 23:50:00 EST 2004 Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>
	
	* mini-s390x.c mini-s390x.h tramp-s390x.c inssel-s390x.brg
	  cpu-s390x.md exceptions-s390x.c Makefile.am: S/390 64-bit JIT

	* mini-s390.c: fix tail processing

Tue Aug 3 01:35:44 PDT 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: mul.ovf.un exception name fix.

2004-08-03  Martin Baulig  <martin@ximian.com>

	* mini-x86.c (mono_arch_call_opcode): Correctly handle generic
	instances; before jumping to `handle_enum', also modify `ptype'.

2004-08-02  Bernie Solomon  <bernard@ugsolutions.com>

	* cpu-sparc.md: fcall maximal length too small.

2004-08-02  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c mini.h: Add initial support for passing/returning 
	structures to/from pinvoked methods.

Mon Aug 2 11:59:35 PDT 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: reg allocator fix.

2004-07-31  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c (mono_arch_output_basic_block): Fix OP_X86_PUSH_OBJ.

	* inssel.brg: Optimize memset on 64 bit machines.

	* mini-amd64.c: Fix some vararg cases.

2004-07-30  Neale Ferguson <Neale.Ferguson@SoftwareAG-usa.com>

	* mini-s390.c: Corrected macro in emit_float_to_int

	* s390-abi.cs: Tests to exercise the s390 ABI

2004-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-amd64.c (mono_arch_find_jit_info): Fix restoring of
	caller saved regs.

	* basic.cs: Add a test for add.ovf.un.

2004-07-30  Bernie Solomon  <bernard@ugsolutions.com>

	* mini-sparc.c: add case for OP_IDIV_UN

2004-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-amd64.c mini-amd64.h mini.c: Add support for vararg pinvoke calls.
	
	* mini-amd64.c cpu-amd64.md: Ongoing JIT work.

2004-07-30  Ben Maurer  <bmaurer@ximian.com>

	* basic.cs: regression tests.

	* inssel-x86.brg: Disable cmp BYTE PTR [eax], imm, it causes various
	regressions.

2004-07-30  Zoltan Varga  <vargaz@freemail.hu>

	* basic.cs: Add a new test.

	* mini-amd64.c aot.c cpu-amd64.md: Add support for tracing, profiling 
	and AOT. Various fixes and optimizations.

	* inssel.brg (CALL_REG): Add 64 bit versions of call_reg rules.

Fri Jul 30 15:49:26 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: make sure temp regs are not used for global reg
	allocation.

2004-07-29  Bernie Solomon  <bernard@ugsolutions.com>

	* cpu-sparc.md: conv_i8 fix for 64bits

	* mini-sparc.c: add cases for OP_IXXX codes for 64bits

2004-07-29  Ben Maurer  <bmaurer@ximian.com>
	
	* cpu-pentium.md, mini-x86.c, inssel-x86.brg, mini-ops.h:
	add opcode for cmp BYTE PTR [eax], imm.

	* inssel.brg: Make memcpy and memset takes bases.

2004-07-28  Zoltan Varga  <vargaz@freemail.hu>

	* *-amd64.*: More AMD64 work.
	
2004-07-28  Ben Maurer  <bmaurer@ximian.com>

	* cpu-pentium.md, inssel-x86.brg, mini-ops.h, mini-x86.c:
	add a compare-not-equal opcode.
	
2004-07-28  Lluis Sanchez Gual  <lluis@novell.com>

	* mini.c: Use mono_init_from_assembly instead of mono_init.
	
2004-07-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Fix opcode mapping for STACK_MP on 64 bit platforms.

	* mini.c (CEE_NEWOBJ): Call mono_array_new_va using the correct signature.

	* mini.c: Use MONO_ARCH_SIGACTION on AMD64 as well.

	* inssel.brg: 64 bit fixes.

	* mini.h (MonoCallInst): Add some AMD64 specific data.

	* mini.h: Add some OP_P opcodes.

2004-07-28  Ben Maurer  <bmaurer@ximian.com>

	* basic.cs: tests for 61797 and 61740

Tue Jul 27 16:05:19 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini-sparc.c, mini-s390.c: keep track of line
	numbers in the debug info (spotted by Geoff Norton, <gnorton@customerdna.com>).

2004-07-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_output_basic_block): Add CEE_CONV_U8/I8.

	* *-amd64*.*: Ongoing AMD64 work.

2004-07-23 Zoltan Varga <vargaz@freemail.hu>

	* inssel-long.brg: Implement CONV_I8/CONV_U8 in the backends.

	* *-amd64*: Ongoing AMD64 work.

	* mini-arch.h: Add AMD64 support.

	* mini-sparc.c (mono_arch_is_inst_imm): New arch dependent function.

	* mini.h: Add new arch dependent function mono_arch_is_inst_imm.

	* mini-ops.h: Add new opcodes.

	* Makefile.am: Add AMD64 support.

	* inssel.brg inssel-long32.brg inssel-long.brg: Move mul/div and shift
	rules into the inssel-long*.brg files.

	* *-amd64.*: Add beginnings of AMD64 backend.

2004-07-22  Ben Maurer  <bmaurer@ximian.com>

	* mini.c (print_dfn): commenting out the code that prints
	the cil. With -O=deadce, this makes -v -v crash.
	
	* cpu-pentium.md: make checkthis have a length of 2

2004-04-21  Bernie Solomon  <bernard@ugsolutions.com>

	* mini-sparc.h: fix implementations of __builtin
	functions for Sun compiler for V9.

2004-07-16  Ben Maurer  <bmaurer@ximain.com>

	* mini.c: use the new stelem.ref wrapper
	* exceptions.cs, arrays.cs: new stelem.ref tests

Wed Jul 14 19:08:41 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, exceptions-ppc.c: cleanups and fixes (the
	new XSP should work with these changes).

2004-07-14  Ben Maurer  <bmaurer@ximain.com>
	
	* inssel-{long32,x86,}.brg: trivial optimizations.
	
Mon Jul 12 20:25:57 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: load value when emitting box operation in
	constrained calls.

2004-07-12  Ben Maurer  <bmaurer@ximian.com>

	* mini-x86.c (OP_CHECK_THIS): cmp DWORD PTR [eax], eax
	is one byte shorter than cmp DWORD PTR [eax], 0.

Mon Jul 12 17:47:00 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-ppc.brg: arguments on the stack are always
	relative to the stack pointer (spotted by Neale Ferguson).

2004-07-11 Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* exceptions-x86.c: delay appending the method name to the trace until
	after mono_jit_info_table_find is called, as this gets the real
	MonoMethod.

2004-07-09  Ben Maurer  <bmaurer@ximian.com>

	* aot.c: register roots

2004-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* aot.c : I could just use PLATFORM_WIN32 flag.

2004-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* aot.c : Reverting the previous fix. This time it broke linux build.

2004-07-09  Atsushi Enomoto  <atsushi@ximian.com>

	* aot.c : quick cygwin build fix. mkdir() with two args does not exist.

2004-07-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (handle_stack_args): Remove some more debugging code.
	
	* mini.c (handle_stack_args): Remove debug output left in by mistake.

	* driver.c mini.h aot.c: Allow additional options to be specified with
	--aot and pass them to mono_compile_assembly.

	* aot.c: Add experimental code to AOT compile all loaded assemblies
	on demand and save the code into a cache in the filesystem.

	* aot.c: Add support for more wrapper methods.
	
	* mini.c (handle_stack_args): Handle some corner cases. Fixes 
	58863.

	* cpu-*.md: Remove removed opcodes.

	* mini.h mini.c: Move JIT icall handling to icall.c. Replace usage of
	CEE_MONO_PROC<x> with CEE_MONO_ICALL. Move registration of marshalling
	related icalls to marshal.c.

2004-07-06  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ops.h: Add OP_SAVE_LMF and OP_RESTORE_LMF.

	* Makefile.am (EXTRA_DIST): Add inssel-long[32].brg.

	* inssel.brg: Fix warning. Add rules for SAVE_LMF and RESTORE_LMF.

2004-07-06  Ben Maurer  <bmaurer@ximian.com>
	* liveness.c: If liveness is recomputated we need to reset the information
	for each variable. This way, if the liveness range has been narrowed
	by optimizations that happened after the last computation, we can return
	a smaller range.
	
	For example, if you have
	
	{
		int i = 0;
		
		// Tons of code that does not affect i
		
		i = foo ();
		...
	}
	
	i = 0 is dead code and will be removed by SSA. However, when
	linear scan gets to the code, i will still appear to be live
	throughout the entire block. This prevents good register allocation.

2004-07-06  Martin Baulig  <martin@ximian.com>

	* debug-mini.c (mono_debug_init_method): Allow
	MONO_WRAPPER_MANAGED_TO_NATIVE wrappers.
	(mono_debug_add_icall_wrapper): New method.

	* mini.c (mono_icall_get_wrapper): Call mono_debug_add_icall_wrapper().

2004-07-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (optimize_branches): Fix linking of bblocks in branch->branch
	optimization.

2004-07-03  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_aot_load_method): Fix loading of debug info.

2004-07-02  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Add logging support.

2004-07-01  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h: Add prototype for mono_print_method_from_ip.

	* mini.c: 64 bit fixes. Use LCOMPARE for comparing longs.

	* inssel.brg: 64 bit fixes.

	* inssel.brg inssel-long32.brg: Move 32 bit arithmetic rules to 
	inssel-long32.brg.

	* Makefile.am: Add SPARC64 support.

2004-07-02  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c: Fix alignment problems on 32 bit platforms.

2004-07-01  Zoltan Varga  <vargaz@freemail.hu>

	* helpers.c (mono_disassemble_code): Pass -xarch=v9 to assembler on
	SPARC64.

	* aot.c: Add SPARC64 support. Reorganize patch table to fix alignment
	problems.

	* mini.h: Bump AOT file version. Some 64 bit fixes.

2004-06-30  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-sparc.brg: Add new rule to avoid register moves.

	* inssel.brg: Add ldind_to_load_membase helper function.

2004-06-30  Ben Maurer  <bmaurer@ximian.com>

	* mini.c: OffsetToStringData intrinsic.
	
2004-06-30  Zoltan Varga  <vargaz@freemail.hu>

	* ssa.c: Handle OP_LCOMPARE the same as OP_COMPARE.

	* objects.cs exceptions.cs basic.cs basic-long.cs basic-calls.cs: New
	regression tests.

	* mini-ops.h cpu-sparc.md mini-sparc.h mini-sparc.c exceptions-sparc.c tramp-sparc.c inssel-long.brg: Add SPARC64 support.
Mon Jun 28 18:05:09 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: reinstated mono_compile_get_interface_var()
	on x86, too, since the change breaks the Gtk# build there as well.

Fri Jun 25 17:36:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* driver.c: remove loop from the default optimizations: it seems to
	interact badly with some of the other options (see bug #60613).

2004-06-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c mini-x86.h mini-x86.c: Applied patch from Guenter Feldmann 
	(fld@informatik.uni-bremen.de): Add Solaris x86 support.

Tue Jun 22 21:29:11 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: small updates to be able to compile
	vararg-using methods.

2004-06-21  Martin Baulig  <martin@ximian.com>

	* mini/mini-exceptions.c
	(mono_handle_exception): Added `gpointer original_ip' argument.
	After calling mono_unhandled_exception(), call
	mono_debugger_unhandled_exception() and if that returns true,
	restore the context and return.

Mon Jun 21 19:26:40 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: prefer the use of relative branches so
	they won't need to be patched in aot code (patch from Patrick Beard).

Mon Jun 21 19:03:18 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* aot.c: patch from Patrick Beard to make the output assembly
	more correct for the MacOSX assembler. Small tweak to
	generate sane images on Linux/PPC, too.

Fri Jun 18 18:24:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini.h, mini-ppc.c: handle varargs methods with a special
	case until bug #59509 is fixed (shows up in #60332).

Tue Jun 15 16:36:51 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: make sure the needed wrappers are compiled, too, with
	precomp.

Mon Jun 14 18:36:08 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* driver.c: remove NPTL reference in --version output.

Sun Jun 13 17:25:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* aot.c: patch from Patrick Beard (pcbeard@mac.com) to
	generate valid assembly for the Mach-O assembler.

Sun Jun 13 15:59:38 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* driver.c: don't include abcrem in the all optimization specifier
	since it slows down jit compilation too much for now.

2004-06-12 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini.c: use BIGMUL only if both operands have the same signage.
	* iltests.il: Test for bug 60056. (errors related to signage in
	BIGMUL).

	r=lupus.

Thu Jun 10 16:06:42 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, aot.c: memory leak fixes.

Tue Jun 8 16:37:15 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-long32.brg: implemented a few missing ulong cast opcodes.

Tue Jun 8 15:36:30 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: remove the -static hack completely, it links in
	statically glib as well.

Sat Jun 5 16:32:33 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* iltests.il, mini.c: fixed bug#59580 in branch optimization.
	* exceptions.cs: make it compile with new mcs/csc.

2004-06-03 Massimiliano Mantione <massi@ximian.com>
	* cpu-pentium.md basic-float.cs Fixed bug on fpu spills (see bug 54467),
	and added relevant test case.

Mon May 31 19:41:46 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c revert Zoltan's fix to bug#58863 on ppc, since it causes
	regressions in gtk-sharp.

2004-05-29  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs: New regression tests.

	* jit-icalls.c (mono_llmult_ovf): Fix some boundary conditions.

Sat May 29 10:45:58 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: emit castclass/isinst in their own trees (bug #54209/59057).

2004-05-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.h (MONO_ARCH_NEED_DIV_CHECK): Define this.

	* cpu-sparc.md mini-sparc.c: Add overflow detection to div opcodes.

2004-05-28	Patrik Torstensson <totte@hiddenpeaks.com>

	* mini.c (mono_jit_runtime_invoke): Init class in this
	method instead of trusting mono_jit_compile_method to
	do the work (because wrappers can be in object class)

2004-05-27  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_output_basic_block): Fix sub.imm.

	* basic-long.cs: New regression test.

Thu May 27 15:50:52 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* cpu-g4.md, mini-ppc.c: fixes to long add/sub ovf opcodes
	and div/rem checks.

Thu May 27 12:36:53 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: fix miguel's change to build mono statically against
	libmono (track build dependencies).

2004-05-26  Zoltan Varga  <vargaz@freemail.hu>

	* cfold.c: Some glib versions do not have G_MININT32.

2004-05-26  Massimiliano Mantione  <massi@ximian.com>

	* mini-x86.c cpu-pentium.md Makefile.am basic-math.cs: Fixed problem
	with precision of tan, atan, sin and cos, and implemented related
	regressions tests (fixes bug 54467, but one new problem appeared and
	is not fixed yet).

2004-05-26  Zoltan Varga  <vargaz@freemail.hu>

	* cfold.c (FOLD_BINOPZ): Avoid division by zero.

	* exceptions.cs: Add test for constant folding && division by zero.

	* driver.c mini.h mini.c mini-x86.c: Revert most of the previous patch
	since driver.c is in libmono too, so the optimization was useless.

	* driver.c mini.h mini.c mini-x86.c: Moved the mono_lmf_addr TLS 
	variable to driver.c so the compiler can emit more efficient code to
	access them.

2004-05-26  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* Makefile.am: don't distribute generated inssel.[ch] files.

2004-05-25  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_jit_compile_method_with_opt): Really emit icall wrappers
	into the default appdomain. Fixes #58707.

	* jit-icalls.c: Remove the broken approximation for truncl, doing
	no conversion is better.

	* mini.c (handle_stack_args): Avoid reusing variables for stack slots.
	Fixes #58863.

Tue May 25 14:33:56 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ops.h, mini-ppc.c, cpu-g4.md, inssel-ppc.brg: eliminate the use
	of the mcrxr instruction which is not available on some processors
	even if it's documented to be. Implement add and sub overflow correctly
	(still not complete for long unsigned). Speed up icalls a bit.

2004-05-25 13:01 CET Patrik Torstenson <totte@hiddenpeaks.com>

	* mini.c (mono_jit_compile_method_with_opt): Make sure that
	we run .cctor in the current domain instead of target_domain.
	
	Fixes bug #58558, .cctor not being called in -O=shared.

Tue May 25 12:46:50 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.h, jit-icalls.c: added explicit checks for divide by zero.

2004-05-24 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini-x86.c (EMIT_COND_BRANCH): If an OP_LABEL has an offset
	which can be done with an imm8, do it that way.
	(mono_arch_output_basic_block): ditto for a jmp
	(mono_arch_emit_prolog): Computate maximum offset of a label.

2004-05-24 18:18 CET Patrik Torstenson <totte@hiddenpeaks.com>

	* mini-x86.c (mono_arch_local_regalloc): the reg allocator
	now tries to allocate prefered physical reg's for virtual
	regs. This reduces the number of emited spills/loads with
	20-30% on our core assemblies.

Mon May 24 18:21:51 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c: truncl() is not needed and trunc() is
	the correct thing to do anyway (bug #58287).

2004-05-24  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_flush_icache): Call sync_instruction_memory
	if available.

Mon May 24 12:49:45 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* driver.c: enable loop optimizations by default.

Mon May 24 11:13:46 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-x86.c: fix calc of max loop size when aligning loops start.

2004-05-23  Zoltan Varga  <vargaz@freemail.hu>

	* ssa.c (mono_ssa_cprop): Allocate carray dynamically instead of on
	the stack.

2004-05-22  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_output_basic_block): ADD_IMM and SUB_IMM
	should set carry.

	* basic-long.cs: Add tests for add/subtract of immediates with carry.

	* mini.c exceptions-x86.c: Remove MONO_USE_EXC_TABLES stuff.
	
	* mini.c (inline_method): Allways inline some wrappers even if the cost
	is too large. Fixes #58785.

	* mini.c: Add support for MARSHAL_CONV_FTN_DEL.
	
2004-05-21  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c exceptions-sparc.c: Applied patch from Mark Crichton
	(crichton@gimp.org). Beginning of support for sparc/linux.

	* mini-sparc.c: Optimize retrieval of LMF address.

Fri May 21 08:00:12 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c:  handle alloca in methods with clauses.

Fri May 21 07:35:30 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: cleanups, off-by-one fixes, avoid recursive thunks.

2004-05-20  Lluis Sanchez Gual  <lluis@ximian.com>

	* mini.c: Delegate most of the abort signal work to 
	  mono_thread_request_interruption, which also handles Stop and Suspend
	  states.

2004-05-20  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c mini.h: Allow inlining of icall wrappers if the backend 
	supports the save/restore lmf opcodes.

2004-05-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_setup_jit_tls_data): Handle code generated
	by gcc-3.4 as well.

	* mini-x86.h mini-x86.c tramp-x86.c: Optimize lmf restoring code.

2004-05-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini.h mini.c (mini_method_compile): Only run abc removal pass on 
	methods which contain array accesses.

	* mini.c (CEE_LDTOKEN): Handle this instruction correctly on bb
	boundaries. Fixes #58537.

	* iltests.il: Add regression test for #58537.

2004-05-18  Patrik Torstensson <totte@hiddenpeaks.com>

	* mini-x86.c (mono_arch_local_regalloc): Last part of
	fix for bug #58633 (releasing register to early).

2004-05-18  Miguel de Icaza  <miguel@ximian.com>

	* basic-long.cs: Add new regression test.

2004-05-18  Patrik Torstensson <totte@hiddenpeaks.com>

	* mini-x86.c (mono_arch_local_regalloc): Avoid releasing a
	register too early on the chain.

2004-05-18  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (create_helper_signature): Use a helper function to reduce
	the code which needs to be written. Also set the calling convention of
	icalls on windows. Fixes #57840.

Tue May 18 11:05:18 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.h, exceptions-x86.c, exceptions-sparc.c, exceptions-s390.c,
	exceptions-ppc.c: added helper function to get the instruction address
	from a signal handler context.

2004-05-17 Ben Maurer  <bmaurer@users.sourceforge.net>

	* helpers.c: use g_get_tmp_dir. Invokes happyness 
	from gonzalo.

2004-05-17 Ben Maurer  <bmaurer@users.sourceforge.net>

	* helpers.c: Add new env variable to pass args to objdump.
	Specifically for those of us who love -Mintel. r=miguel, gonzalo.

2004-05-17  Radek Doulik  <rodo@ximian.com>

	* Makefile.am (common_sources): added abcremoval.h so it get
	disted and daily mono packages on go-mono.com will build again

2004-05-17  Massimiliano Mantione  <massi@ximian.com>

	* abcremoval.c: Fixed coding style, added copyright header.

	* abcremoval.h: Fixed style and moved prototype to mini.h, added copyright header.

	* mini.h: Added prototype for abc removal main function.

	* build_relations_propagation_table.pl: Added copyright header.

2004-05-16	Patrik Torstensson <totte@hiddenpeaks.com>

	* basic-long.cs: reg test for complex ceq_long bug.

2004-05-16	Patrik Torstensson <totte@hiddenpeaks.com>

	* mini-x86.c (mono_arch_local_regalloc): Correctly free 
	reg in long and clob case (bug #58343). Fixed/added comments.

2004-05-14 Ben Maurer  <bmaurer@users.sourceforge.net>

	* mini.c (mono_jit_runtime_invoke): Follow new convention
	of calling the invoke method with an function pointer.

2004-05-14  Zoltan Varga  <vargaz@freemail.hu>

	* ChangeLog: Fix author of memory leak patch.

Fri May 14 15:13:06 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: fix make dist as well...


2004-05-14  Massimiliano Mantione  <massi@ximian.com>

	* cfold.c: Made so that conversions from pointer to int4 are no-ops
	on archs where pointers are 4 bytes long.

	* Makefile.am: Added abcremoval.c source file.

	* abcremoval.c: Added abcremoval.c.

	* abcremoval.h: Added abcremoval.h.

	* build_relations_propagation_table.pl: Added build_relations_propagation_table.pl.

	* inssel.brg: Enabled bounds check removal.

	* mini.c: Added support for abcrem optimization.

	* mini.h: Added abcrem optimization label.

	* driver.c: Added support for abcrem optimization.

	* propagated_relations_table.def: Added propagated_relations_table.def.

Fri May 14 14:30:13 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, cfold.c: fix style.

Fri May 14 14:28:22 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: handle issue with the low-level implementation of
	some long opcodes (bug #54209).

2004-05-13 Ben Maurer  <bmaurer@users.sourceforge.net>

	* basic.cs: test for my new cmov stuff.

2004-05-13	Patrik Torstensson

	* mini-x86.c: added OP_X86_COMPARE_MEMBASE_IMM peephole
	opt and added peephole documentation.

Thu May 13 11:41:49 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: rewrote the generic trampoline code.

2004-05-11	Patrik Torstensson

	* mini-x86.c: optimize long shl/shr asm code (one less branch)

2004-05-11  Zoltan Varga  <vargaz@freemail.hu>

	* basic.cs basic-long.cs objects.cs: Make these compile under MS csc.

	* mini.h mini.c dominators.c: Applied patch from Derek Woo
	(derek@eecg.toronto.edu): Fix memory leaks in loop optimizations.

	* mini.c: Add new icalls for AsAny marshalling.

Tue May 11 16:00:38 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c, mini-ppc.c: more cleanups.

2004-05-11  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: no warnings.

Tue May 11 13:59:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, mini.c: use mono_resolve_patch_target ().

2004-05-11  Lluis Sanchez Gual  <lluis@ximian.com>

	* mini.c: In the thread abort signal handler, if the thread is in the
	process of being stoped, don't throw the Abort exception, just stop the
	thread.

Tue May 11 12:15:24 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: removed old code.

Tue May 11 12:02:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-ppc.c, cfold.c: export mono_is_power_of_two().
	do some simple speed optimizations on ppc.

Mon May 10 17:21:00 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: fixes to handle large stack frames
	and large offsets in load/store.

2004-05-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_local_regalloc): Remove the previous fix, since
	it causes regressions.

2004-05-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c: Fix vararg support + add beginnings of sigaltstack
	support.

Fri May 7 13:25:50 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* jit-icalls.c: remove warnings.
	* inssel-x86.brg, inssel.brg, mini-x86.c, cfold.c: some simple
	speedups for unsafe code.

2004-05-07 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel.brg: Optimize Stind.[ui][12]. r=zoltan.

2004-05-06  Zoltan Varga  <vargaz@freemail.hu>

	* basic-calls.cs: Add new regression test.

	* mini.c (mono_runtime_install_handlers): Use SA_ONSTACK since it is
	more portable.

	* mini.c (mono_method_to_ir): Handle opcode emulation for *_OVF opcodes.

	* mini-x86.c (mono_arch_local_regalloc): Free new_dest register when it
	is no longer used.

2004-05-06	Patrik Torstensson

	* mini-x86.[c|h], inssel-x86.brg, cpu-pentium.md, mini.c: enabled
	long reg allocation in any reg (not only eax:edx) and implemented 
	long shl/shr ops in asm instead of helpers.

2004-05-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.h: Fix warnings.

	* exceptions-sparc.c (mono_arch_find_jit_info): Pop unused lfm off the
	stack.

	* mini-exceptions.c (mono_handle_exception): Call the filter in a
	separate statement for clarity.

	* mini-sparc.c: Update status.

2004-05-04  Zoltan Varga  <vargaz@freemail.hu>

	* mini-exceptions.c (ves_icall_get_frame_info): Flush register windows
	here.

Mon May 3 22:58:51 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-ppc.brg: another small pre-release workaround:
	we don't do overflow detection for long_sub_un.

Sun May 2 20:12:22 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c, mini-ops, inssel-long32.brg: speedup ulong >> 32
	(also works around a weird ppc bug: 57957).

Sat May 1 16:56:10 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* tramp-ppc.c: trampoline fixes.

Fri Apr 30 15:54:26 EDT 2004	Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: fixed typos.

Thu Apr 29 20:15:41 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, exceptions-ppc.c: more code saves registers
	at the top of the stack. Fixed typos. Use a frame registers
	for all the methods with exception clauses.

Thu Apr 29 18:52:09 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: restore fp registers.

Thu Apr 29 18:26:56 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, exceptions-ppc.c: save the registers in reverse
	order from the stack top (moved the stack room to save the
	return value for trace after the param area). Fixed corruption
	in restoring registers on unwind.

Thu Apr 29 16:47:15 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: fixed unisgned -> double conversion.

Thu Apr 29 13:50:51 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c, mini-ppc.h, mini-ppc.c: fixed localloc
	and prolog/epilog for methods that use it. Allow
	enough param area room for varargs methods. Fix miguel's
	breakage in exception handling.

Thu Apr 29 12:06:51 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* Makefile.am: run genmdesc only on current arch.

2004-04-29  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* exceptions-x86.c:
	* mini-x86.h: fix the build on windows.

2004-04-28  Zoltan Varga  <vargaz@freemail.hu>

	* Makefile.am mini.h mini-exceptions.c mini-x86.h mini-sparc.h exceptions-sparc.c: Move parts of the sparc exception handling code to XP code.

	* exceptions-sparc.c exceptions-ppc.c exceptions-s390.c mini-ppc.h mini-s390.h mini-sparc.h: Fix up ports after changes.

	* mini-exceptions.c: New file.
	
	* mini.c mini-exceptions.c mini-x86.h exceptions-x86.c Makefile.am:
	Move some parts of the x86 exception handling code to an 
	arch-independent file so it can be shared with other ports.

Tue Apr 27 12:15:59 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* trace.c, cpu-g4.md, inssel-ppc.brg, mini-ppc.c: some fixes for FP code.

2004-04-26  David Waite  <mass@akuma.org>

	* driver.c: remove comma from end of enumeration declaration

2004-04-26  Jackson Harper  <jackson@ximian.com>

	* driver.c: parse config file before loading first assembly. This
	allows the user gac to be enabled/disabled. 
	
2004-04-23  Miguel de Icaza  <miguel@ximian.com>

	* mini-ppc.c (ppc_patch): Replaced the branch code patching with a
	simpler mechanism: we do not care what is encoded initially
	(branch absolute or relative), we care about the code and its
	target.  I kept the old code for reference for now.

	The new code tries first to determine if the jump is anywhere in
	the -/+32 absolute meg range, if it succeeds, it encodes using the
	absolute branch;  If not, it tried to find something in the
	relative range, if not, it uses the handle_thunk code. 

Fri Apr 23 14:20:40 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: use the correct ip register on macosx.

Thu Apr 22 13:23:16 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions.c, mini.c, mini-ppc.h: adapt code to macosx.

Thu Apr 22 18:08:37 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, cpu-g4.md: made the branch macros more flexible.
	Raise exception on integer divide by zero by hand since the hw
	doesn't support it. Handle NaNs in FP compares.

Thu Apr 22 16:10:31 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c, mini-ppc.h, mini.c: simplified some
	code reducing duplication between the platforms and enabled
	signal exception handling (on linux for now).

Wed Apr 21 12:27:48 EDT 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: more macosx support.

Wed Apr 21 16:38:28 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.h, mini-ppc.c, cpu-g4.md: enable bigmul optimization.

Wed Apr 21 16:20:32 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.h, mini-ppc.c, cpu-g4.md: support for implicit exceptions.

2004-04-19 Ben Maurer  <bmaurer@users.sourceforge.net>

	* iltests.il: more tests.

2004-04-19  Zoltan Varga  <vargaz@freemail.hu>

	* mini-*.c (mono_arch_get_allocatable_int_vars): Skip written-only
	vars as well.

Mon Apr 19 19:39:47 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c: some fixes to bootstrap mcs/corlib/etc.

2004-04-19  Zoltan Varga  <vargaz@freemail.hu>

	* liveness.c: Mark variables as volatile in all basic blocks reachable
	from exception clauses.

2004-04-18  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs (test_0_rethow_stacktrace): Make this work with
	inlining.

2004-04-18 Ben Maurer  <bmaurer@users.sourceforge.net>

	* iltests.il, basic.cs: more tests for regalloc.

2004-04-17 Ben Maurer  <bmaurer@users.sourceforge.net>

	* iltests.il: Some tests for register allocation modifications
	I have locally.

2004-04-16  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs: Add regression test for bug #56782.

	* exceptions-*.c (mono_arch_handle_exception): Do not overwrite the
	original stack trace if an exception is rethrown. Fixes #56782. Oh,
	the beauty of fixing the same thing in 5 different files...

2004-04-15  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Do not compute coverage for inlined
	methods.

2004-04-14  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Add support for STRWLPARRAY marshalling convention.

Wed Apr 14 18:15:55 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: missing fixes in mono_jit_walk_stack (need
	to init the context to setup the regs pointer).

Wed Apr 14 17:59:09 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* exceptions-ppc.c: more exceptions work.

Wed Apr 14 17:46:22 CEST 2004 Paolo Molaro <lupus@ximian.com>

	* mini.c: avoid reusing the same MonoInst on multiple trees: this is
	not allowed.

2004-04-13  Miguel de Icaza  <miguel@ximian.com>

	* inssel-x86.brg (reg): Add new rules for add, sub and mul that
	can use the memory directly.

	* cpu-pentium.md: Update documentation from a post from Zoltan. 

	add x86_add_membase, x86_sub_membase, x86_mul_membase

2004-04-13  Miguel de Icaza  <miguel@ximian.com>

	* mini-ppc.c: Remove unused definitions FLOAT_REGS and
	GENERAL_REGS they were also hardcoded for all PPC ports.

	(add_general): Use PPC_NUM_REG_ARGS instead of GENERAL_REGS.

	Remove hard-coded limit for floating point registers, use
	PPC_LAST_FPARG_REG instead in MONO_TYPE_R4 and MONO_TYPE_R8.

	Notice that in MacOS X calling conventions you can fit a lot more
	floating point values in registers, so I should update the PInvoke
	test to excercise the passing of floating point values on the
	stack (currently broken).
	
2004-04-06  Miguel de Icaza  <miguel@ximian.com>

	* tramp-ppc.c (create_trampoline_code): Added
	JUMP_TRAMPOLINE_SIZE. 
	(ppc_magic_trampoline): Follow the pattern from
	x86_magic_trampoline: if code is set to zero, return. 
	(create_trampoline_code): Always pass MonoMethod to the jump
	trampoline, before it was passing a null.
	(mono_arch_create_jump_trampoline): Implement the jump stub, could
	share the code with mono_arch_create_jit_trampoline. 

	* mini-ppc.c (mono_arch_output_basic_block): CEE_JMP opcode
	implemented.
	(mono_arch_patch_code): MONO_PATCH_INFO_METHOD_JUMP patch type
	implemented.  

	* cpu-g4.md: Added length for jmp instruction, the worst case
	scenario is 92 bytes (4 mandatory bytes, potential 19 registers
	for save_lmf).

2004-04-08  Zoltan Varga  <vargaz@freemail.hu>

	* aot.c (mono_compile_assembly): Add back unlink removed by mistake.

2004-04-07  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Only set bblock->real_offset when adding a new bblock, and
	before each IL instruction.

	* mini.c (CEE_BOX): Fix warnings.

2004-04-07  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: removed a few unused vars and extra whitespace.

2004-04-05 Ben Maurer  <bmaurer@users.sourceforge.net>

	* inssel.brg (MONO_EMIT_BOUNDS_CHECK): a new macro to emit bounds
	checks.
	(MONO_EMIT_BOUNDS_CHECK_IMM): the above, but when you know the
	index.
	(OP_GETCHR): use the above
	(CEE_LDELEMA): use the above.

	* inseel-x86.brg (MONO_EMIT_BOUNDS_CHECK): a faster and smaller
	version of the generic impl.
	(MONO_EMIT_BOUNDS_CHECK_IMM): the same
	(CEE_LDELEMA): use the above.

2004-04-05  Zoltan Varga  <vargaz@freemail.hu>

	* inssel-long32.brg (CEE_CONV_OVF_I8): Sign extend the i4 value to i8.
	Fixes #56317.

	* iltests.il: Added new regression test for #56317.

2004-04-05  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_setup_jit_tls_data): Use pthread_attr_get_np
	under NetBSD. Fixes #56450.

	* liveness.c (update_gen_kill_set): Fix previous patch.

2004-04-04  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini-x86.h: SA_STACK defined as SA_ONSTACK. Fixed build under NetBSD.

2004-04-02  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c (mono_method_to_ir): Avoid handle_loaded_temps in
	ldsfld and ldsflda.

	* inssel-sparc.brg: Add more optimizations.

	* mini-sparc.c: Replace multiply/divide with shifts if possible.

2004-04-01  Martin Baulig  <martin@ximian.com>

	* mini.c (handle_box): New static function; moved the
	implementation of CEE_BOX here.
	(mono_method_to_ir): Added `constrained_call' variable.
	(mono_method_to_ir:CEE_CONSTRAINED_): Set it.
	(mono_method_to_ir:CEE_CALL): If `constrained_call' is set, use
	mono_method_get_constrained() to get the method.

2004-04-01  Martin Baulig  <martin@ximian.com>

	* mini.c (TYPE_PARAM_TO_TYPE, TYPE_PARAM_TO_CLASS): Removed.
	(MTYPE_PARAM_TO_TYPE, MTYPE_PARAM_TO_CLASS): Removed.
	(mono_method_to_ir): We don't need these macros anymore since
	mono_class_get_full() already takes care of it.	

2004-03-31  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* aot.c: set aot_verbose to 0, fixed format string that caused sigsegv,
	use @function (as doesn't accept #function here) and check the return
	value of system and stop if fails.

2004-03-31  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: set the timeout to 2s when calling mono_domain_finalize.

2004-03-31  Zoltan Varga  <vargaz@freemail.hu>

	* mini-ppc.c (mono_arch_patch_code): Fix ppc build.

	* inssel-sparc.brg mini-sparc.c aot.c: Implement AOT support.

	* inssel-long32.brg (OP_LNEG): Use ADC instead of ADD here. Fixes
	#56223.

	* basic-long.cs: Add test for negation of Int64.MinValue.

2004-03-30  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c: Update status.

	* mini-sparc.c tramp-sparc.c: Save lmf in trampolines.

	* exceptions-sparc.c: Fix return value in filters.

	* inssel-sparc.brg: Fix register allocation in some rules.

2004-03-28  Martin Baulig  <martin@ximian.com>

	* mini.c (mmono_method_to_ir): In CEE_STELEM, do a handle_stobj()
	if neccessary.	

2004-03-28  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.c (mono_arch_patch_code): Fix warnings.
	
	* mini-x86.c (mono_arch_output_basic_block): Fix CEE_MUL_OVF_UN if 
	dreg is not EAX. Thanks to Willibard Krenn for spotting this. Also
	remove unused conv_u4 opcode.

	* mini-x86.c: Remove valgrind workaround since it slows down things
	even when mono is not run under valgrind.

2004-03-26  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c: Update status.

	* inssel-sparc.brg: Add some optimizations.

	* inssel-sparc.brg mini-sparc.c: Rework branch instructions to allow
	future delay slot filling. Add support for varargs, tail calls and JMP.

	* inssel.brg mini-ops.h mini.c: Use OP_REFANYTYPE instead of 
	CEE_REFANYTYPE, since CEE_REFANYTYPE needs a prefix to be unique.

	* inssel.brg: Fix register allocation in OP_ARGLIST.

	* inssel.brg: Fix warnings.

2004-03-25  Martin Baulig  <martin@ximian.com>

	* mini.c (inflate_generic_field): Removed.
	(mini_get_method): Removed, use mono_get_method_full(),
	(mini_get_class): Removed, use mono_class_get_full().
	(mono_method_to_ir): Pass our generic context to
	mono_field_from_token().	

2004-03-25  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_get_class): Take a `MonoGenericContext *' instead
	of a `MonoMethod *'.
	(mini_get_method): Take a `MonoGenericContext *' instead
	of a `MonoMethod *'.
	(TYPE_PARAM_TO_TYPE, MTYPE_PARAM_TO_TYPE): mono_method_to_ir() has
	a new local variable called `generic_context' which holds the
	current `MonoGenericContext *'; use it to lookup things.

2004-03-24  Martin Baulig  <martin@ximian.com>

	* mini.c (mini_get_class): New static method; if we're inside a
	generic instance, inflate the class if neccessary.
	(mono_method_to_ir): Use mini_get_class() instead of mono_class_get().

2004-03-24  Zoltan Varga  <vargaz@freemail.hu>

	* iltests.il: New regression test for #55976.

	* mini.c (mono_method_to_ir): Empty the stack in endfinally. Fixes
	#55976.

2004-03-23  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-sparc.c (mono_sparc_handle_exception): Remove debugging
	output.

2004-03-23  Zoltan Varga  <vargaz@freemail.hu>

	* liveness.c: Consider SSA stores as well as loads when making vars
	volatile.

	* exceptions.cs: New regression tests for register allocation.
	
2004-03-22  Lluis Sanchez Gual  <lluis@ximian.com>

	* mini-ppc.c, tramp-ppc.c: Added lock for accessing the domain code manager.
	* mini.c: Removed domain lock from mono_jit_compile_method_with_opt. Use
	  domain lock only to protect puntual access to data structures.
	  Added access lock for sighash, jit_icall_hash_name, 
	  jit_icall_hash_addr and domain->code_mp.

2004-03-20  Zoltan Varga  <vargaz@freemail.hu>

	* driver.c: Print SIGSEGV handling method.

	* mini-x86.c (mono_arch_free_jit_tls_data): Add missing ifdef.

	* mini.c (setup_jit_tls_data): Handle case when this is called
	multiple times for a thread.

	* mini-x86.c cpu-pentium.md: Fix floating point branch opcodes so fbxx 
	is different from fbxx_un. Fixes #54303. Also use constants instead of
	magic numbers in a lot of places.

2004-03-19  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs: Fix cctor test when --regression is used.

Thu Mar 18 19:57:56 CET 2004 Paolo Molaro <lupus@ximian.com>

	* mini-ppc.c, exceptions-ppc.c: basic exceptions support 
	for Linux/ppc.

Thu Mar 18 19:56:19 CET 2004 Paolo Molaro <lupus@ximian.com>

	* inssel-ppc.brg: fixed register assignments for some rules.

2004-03-17  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions.cs: Add test for exceptions in static constructors.

	* mini.c (mono_jit_compile_method_with_out): Move the calling of
	static constructors outside the domain lock. Fixes #55720.

2004-03-17  Martin Baulig  <martin@ximian.com>

	* mini.c (get_generic_field_inst): Removed, this'll never happen.
	(inflate_generic_field): Take the `MonoMethod *' instead of the
	`MonoClass *' and added support for generic method.
	(mono_method_to_ir): In CEE_LDSFLD and CEE_STSFLD, assert we never
	have a `field->parent->gen_params', only inflate the field if it's
	an open constructed type.

2004-03-17  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-x86.c (mono_arch_handle_exception): Allocate a new
	exception object instead of the preconstructed ones.

2004-03-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c: reverted changed to sigsegv_signal_handler commited
	accidentally in the previous patch.

2004-03-17  Gonzalo Paniagua Javier <gonzalo@ximian.com>

	* mini.c:
	(mono_method_to_ir): CEE_CALLVIRT, abort if no method. It hanged when
	running --aot with an old assembly.

2004-03-16  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.c (mono_arch_instrument_epilog): Fix handling of floating
	point values.

	* mini-sparc.c: Add support for v9 branches with prediction.

2004-03-15  Bernie Solomon  <bernard@ugsolutions.com>

	* mini.c (mini_init): #warning is GNUC only

	* mini-sparc.h: implement __builtin_frame_address
	and __builtin_return_address for Sun C compiler

2004-03-15  Zoltan Varga  <vargaz@freemail.hu>

	* exceptions-sparc.c (mono_arch_has_unwind_info): Add missing function.

2004-03-14  Zoltan Varga  <vargaz@freemail.hu>

	* basic-calls.cs: Add test for unaligned byref long argument passing.

	* mini-ops.h: Add sparcv9 compare and branch instructions.

	* inssel-sparc.brg mini-sparc.h mini-sparc.c cpu-sparc.md: Use some
	v9 instructions if we have a v9 cpu.

	* mini-sparc.c (mono_arch_get_global_int_regs): Use unused input
	registers for global allocation.

	* exceptions-sparc.c: Fixes.
	
2004-03-11  Zoltan Varga  <vargaz@freemail.hu>

	* liveness.c (mono_analyze_liveness): Optimized version.

	* inssel-sparc.brg cpu-sparc.md: Ongoing sparc work.

	* mini-sparc.h mini-sparc.c tramp-sparc.c exceptions-sparc.c: Ongoing
	sparc work.

	* basic-float.cs basic-calls.cs: New regression tests.

2004-03-10  Zoltan Varga  <vargaz@freemail.hu>

	* mini-x86.h: Define SIGSEGV_ON_ALTSTACK only if we have a working
	sigaltstack implementation.

	* mini-x86.c (mono_arch_setup_jit_tls_data): Fix previous patch.
	
	* mini-x86.c (mono_arch_setup_jit_tls_data): Turn off the sigaltstack
	stuff if SIGSEGV_ON_ALTSTACK is not defined.

2004-03-09  Zoltan Varga  <vargaz@freemail.hu>

	* mini.c: Fix warnings.
	
	* mini.c (mono_resolve_patch_target): New function which contains the
	arch independent part of the patching process.

	* mini-x86.c (mono_arch_patch_code): Move arch independent parts of the
	patching code to a separate function.

2004-03-09  Bernie Solomon  <bernard@ugsolutions.com>

	* mini.c (add_signal_handler): ifdef out on Windows

2004-03-08  Zoltan Varga  <vargaz@freemail.hu>

	* mini-sparc.h mini-sparc.c inssel-sparc.brg exceptions-sparc.c 
	cpu-sparc.md: Add exception handling support + other fixes.

	* driver.c: Print --help output to stdout. Fixes #55261. Also fix
	typed GC detection in --version.

	* basic.cs exceptions.cs: New regression tests.

	* mini.h mini-x86.h mini-ppc.h: Add MonoCompileArch structure where
	the arch specific code can store data during a compilation.

	* mini-ops.h: Add OP_SETFRET.

	* mini.c (mini_get_ldelema_ins): Instead of allways calling the same
	function, register a separate icall for each arity, so the icalls can
	get a wrapper.
	
	* mini.c (mono_print_tree): Print negative offsets in a more readable
	form.
	
	* mini.c: Make signal handling work on sparc.
	
	* mini.c (mini_init): Add emulation for lconv_to_r8_un.

